# MIT License
#
# Copyright (c) 2021-2025 Advanced Micro Devices, Inc.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


# This file has been autogenerated, do not modify.

from libc cimport stdlib
from libc cimport string
from libc.stdint cimport *
cimport cpython.long
cimport cpython.buffer
ctypedef bint _Bool # bool is not a reserved keyword in C, _Bool is

cimport hip._util.types
from hip cimport chip

cdef class hipDeviceArch_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipDeviceArch_t* getElementPtr(self)

    @staticmethod
    cdef hipDeviceArch_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipDeviceArch_t fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipDeviceArch_t new()
    @staticmethod
    cdef hipDeviceArch_t fromValue(chip.hipDeviceArch_t other)


cdef class hipUUID_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipUUID_t* getElementPtr(self)

    @staticmethod
    cdef hipUUID_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipUUID_t fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipUUID_t new()
    @staticmethod
    cdef hipUUID_t fromValue(chip.hipUUID_t other)


cdef class hipDeviceProp_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipDeviceProp_t* getElementPtr(self)

    @staticmethod
    cdef hipDeviceProp_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipDeviceProp_t fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipDeviceProp_t new()
    @staticmethod
    cdef hipDeviceProp_t fromValue(chip.hipDeviceProp_t other)


cdef class hipPointerAttribute_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipPointerAttribute_t* getElementPtr(self)

    @staticmethod
    cdef hipPointerAttribute_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipPointerAttribute_t fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipPointerAttribute_t new()
    @staticmethod
    cdef hipPointerAttribute_t fromValue(chip.hipPointerAttribute_t other)


cdef class hipDeviceptr_t(hip._util.types.Pointer): pass

cdef class hipChannelFormatDesc(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipChannelFormatDesc* getElementPtr(self)

    @staticmethod
    cdef hipChannelFormatDesc fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipChannelFormatDesc fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipChannelFormatDesc new()
    @staticmethod
    cdef hipChannelFormatDesc fromValue(chip.hipChannelFormatDesc other)


cdef class hipArray(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipArray* getElementPtr(self)

    @staticmethod
    cdef hipArray fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipArray fromPyobj(object pyobj)


cdef class HIP_ARRAY_DESCRIPTOR(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_ARRAY_DESCRIPTOR* getElementPtr(self)

    @staticmethod
    cdef HIP_ARRAY_DESCRIPTOR fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_ARRAY_DESCRIPTOR fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_ARRAY_DESCRIPTOR new()
    @staticmethod
    cdef HIP_ARRAY_DESCRIPTOR fromValue(chip.HIP_ARRAY_DESCRIPTOR other)


cdef class HIP_ARRAY3D_DESCRIPTOR(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_ARRAY3D_DESCRIPTOR* getElementPtr(self)

    @staticmethod
    cdef HIP_ARRAY3D_DESCRIPTOR fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_ARRAY3D_DESCRIPTOR fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_ARRAY3D_DESCRIPTOR new()
    @staticmethod
    cdef HIP_ARRAY3D_DESCRIPTOR fromValue(chip.HIP_ARRAY3D_DESCRIPTOR other)


cdef class hip_Memcpy2D(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hip_Memcpy2D* getElementPtr(self)

    @staticmethod
    cdef hip_Memcpy2D fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hip_Memcpy2D fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hip_Memcpy2D new()
    @staticmethod
    cdef hip_Memcpy2D fromValue(chip.hip_Memcpy2D other)


cdef class hipMipmappedArray(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipMipmappedArray* getElementPtr(self)

    @staticmethod
    cdef hipMipmappedArray fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipMipmappedArray fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipMipmappedArray new()
    @staticmethod
    cdef hipMipmappedArray fromValue(chip.hipMipmappedArray other)


cdef class HIP_TEXTURE_DESC_st(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_TEXTURE_DESC_st* getElementPtr(self)

    @staticmethod
    cdef HIP_TEXTURE_DESC_st fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_TEXTURE_DESC_st fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_TEXTURE_DESC_st new()
    @staticmethod
    cdef HIP_TEXTURE_DESC_st fromValue(chip.HIP_TEXTURE_DESC_st other)


cdef class hipResourceDesc_union_0_struct_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipResourceDesc_union_0_struct_0* getElementPtr(self)

    @staticmethod
    cdef hipResourceDesc_union_0_struct_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipResourceDesc_union_0_struct_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipResourceDesc_union_0_struct_0 new()
    @staticmethod
    cdef hipResourceDesc_union_0_struct_0 fromValue(chip.hipResourceDesc_union_0_struct_0 other)


cdef class hipResourceDesc_union_0_struct_1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipResourceDesc_union_0_struct_1* getElementPtr(self)

    @staticmethod
    cdef hipResourceDesc_union_0_struct_1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipResourceDesc_union_0_struct_1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipResourceDesc_union_0_struct_1 new()
    @staticmethod
    cdef hipResourceDesc_union_0_struct_1 fromValue(chip.hipResourceDesc_union_0_struct_1 other)


cdef class hipResourceDesc_union_0_struct_2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipResourceDesc_union_0_struct_2* getElementPtr(self)

    @staticmethod
    cdef hipResourceDesc_union_0_struct_2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipResourceDesc_union_0_struct_2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipResourceDesc_union_0_struct_2 new()
    @staticmethod
    cdef hipResourceDesc_union_0_struct_2 fromValue(chip.hipResourceDesc_union_0_struct_2 other)


cdef class hipResourceDesc_union_0_struct_3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipResourceDesc_union_0_struct_3* getElementPtr(self)

    @staticmethod
    cdef hipResourceDesc_union_0_struct_3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipResourceDesc_union_0_struct_3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipResourceDesc_union_0_struct_3 new()
    @staticmethod
    cdef hipResourceDesc_union_0_struct_3 fromValue(chip.hipResourceDesc_union_0_struct_3 other)


cdef class hipResourceDesc_union_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipResourceDesc_union_0* getElementPtr(self)

    @staticmethod
    cdef hipResourceDesc_union_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipResourceDesc_union_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipResourceDesc_union_0 new()
    @staticmethod
    cdef hipResourceDesc_union_0 fromValue(chip.hipResourceDesc_union_0 other)


cdef class hipResourceDesc(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipResourceDesc* getElementPtr(self)

    @staticmethod
    cdef hipResourceDesc fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipResourceDesc fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipResourceDesc new()
    @staticmethod
    cdef hipResourceDesc fromValue(chip.hipResourceDesc other)


cdef class HIP_RESOURCE_DESC_st_union_0_struct_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_RESOURCE_DESC_st_union_0_struct_0* getElementPtr(self)

    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_0 new()
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_0 fromValue(chip.HIP_RESOURCE_DESC_st_union_0_struct_0 other)


cdef class HIP_RESOURCE_DESC_st_union_0_struct_1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_RESOURCE_DESC_st_union_0_struct_1* getElementPtr(self)

    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_1 new()
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_1 fromValue(chip.HIP_RESOURCE_DESC_st_union_0_struct_1 other)


cdef class HIP_RESOURCE_DESC_st_union_0_struct_2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_RESOURCE_DESC_st_union_0_struct_2* getElementPtr(self)

    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_2 new()
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_2 fromValue(chip.HIP_RESOURCE_DESC_st_union_0_struct_2 other)


cdef class HIP_RESOURCE_DESC_st_union_0_struct_3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_RESOURCE_DESC_st_union_0_struct_3* getElementPtr(self)

    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_3 new()
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_3 fromValue(chip.HIP_RESOURCE_DESC_st_union_0_struct_3 other)


cdef class HIP_RESOURCE_DESC_st_union_0_struct_4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_RESOURCE_DESC_st_union_0_struct_4* getElementPtr(self)

    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_4 new()
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0_struct_4 fromValue(chip.HIP_RESOURCE_DESC_st_union_0_struct_4 other)


cdef class HIP_RESOURCE_DESC_st_union_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_RESOURCE_DESC_st_union_0* getElementPtr(self)

    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0 new()
    @staticmethod
    cdef HIP_RESOURCE_DESC_st_union_0 fromValue(chip.HIP_RESOURCE_DESC_st_union_0 other)


cdef class HIP_RESOURCE_DESC_st(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_RESOURCE_DESC_st* getElementPtr(self)

    @staticmethod
    cdef HIP_RESOURCE_DESC_st fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_RESOURCE_DESC_st new()
    @staticmethod
    cdef HIP_RESOURCE_DESC_st fromValue(chip.HIP_RESOURCE_DESC_st other)


cdef class hipResourceViewDesc(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipResourceViewDesc* getElementPtr(self)

    @staticmethod
    cdef hipResourceViewDesc fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipResourceViewDesc fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipResourceViewDesc new()
    @staticmethod
    cdef hipResourceViewDesc fromValue(chip.hipResourceViewDesc other)


cdef class HIP_RESOURCE_VIEW_DESC_st(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_RESOURCE_VIEW_DESC_st* getElementPtr(self)

    @staticmethod
    cdef HIP_RESOURCE_VIEW_DESC_st fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_RESOURCE_VIEW_DESC_st fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_RESOURCE_VIEW_DESC_st new()
    @staticmethod
    cdef HIP_RESOURCE_VIEW_DESC_st fromValue(chip.HIP_RESOURCE_VIEW_DESC_st other)


cdef class hipPitchedPtr(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipPitchedPtr* getElementPtr(self)

    @staticmethod
    cdef hipPitchedPtr fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipPitchedPtr fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipPitchedPtr new()
    @staticmethod
    cdef hipPitchedPtr fromValue(chip.hipPitchedPtr other)


cdef class hipExtent(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExtent* getElementPtr(self)

    @staticmethod
    cdef hipExtent fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExtent fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExtent new()
    @staticmethod
    cdef hipExtent fromValue(chip.hipExtent other)


cdef class hipPos(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipPos* getElementPtr(self)

    @staticmethod
    cdef hipPos fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipPos fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipPos new()
    @staticmethod
    cdef hipPos fromValue(chip.hipPos other)


cdef class hipMemcpy3DParms(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipMemcpy3DParms* getElementPtr(self)

    @staticmethod
    cdef hipMemcpy3DParms fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipMemcpy3DParms fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipMemcpy3DParms new()
    @staticmethod
    cdef hipMemcpy3DParms fromValue(chip.hipMemcpy3DParms other)


cdef class HIP_MEMCPY3D(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_MEMCPY3D* getElementPtr(self)

    @staticmethod
    cdef HIP_MEMCPY3D fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_MEMCPY3D fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_MEMCPY3D new()
    @staticmethod
    cdef HIP_MEMCPY3D fromValue(chip.HIP_MEMCPY3D other)


cdef class uchar1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.uchar1* getElementPtr(self)

    @staticmethod
    cdef uchar1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef uchar1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef uchar1 new()
    @staticmethod
    cdef uchar1 fromValue(chip.uchar1 other)


cdef class uchar2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.uchar2* getElementPtr(self)

    @staticmethod
    cdef uchar2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef uchar2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef uchar2 new()
    @staticmethod
    cdef uchar2 fromValue(chip.uchar2 other)


cdef class uchar3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.uchar3* getElementPtr(self)

    @staticmethod
    cdef uchar3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef uchar3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef uchar3 new()
    @staticmethod
    cdef uchar3 fromValue(chip.uchar3 other)


cdef class uchar4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.uchar4* getElementPtr(self)

    @staticmethod
    cdef uchar4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef uchar4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef uchar4 new()
    @staticmethod
    cdef uchar4 fromValue(chip.uchar4 other)


cdef class char1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.char1* getElementPtr(self)

    @staticmethod
    cdef char1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef char1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef char1 new()
    @staticmethod
    cdef char1 fromValue(chip.char1 other)


cdef class char2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.char2* getElementPtr(self)

    @staticmethod
    cdef char2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef char2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef char2 new()
    @staticmethod
    cdef char2 fromValue(chip.char2 other)


cdef class char3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.char3* getElementPtr(self)

    @staticmethod
    cdef char3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef char3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef char3 new()
    @staticmethod
    cdef char3 fromValue(chip.char3 other)


cdef class char4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.char4* getElementPtr(self)

    @staticmethod
    cdef char4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef char4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef char4 new()
    @staticmethod
    cdef char4 fromValue(chip.char4 other)


cdef class ushort1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ushort1* getElementPtr(self)

    @staticmethod
    cdef ushort1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ushort1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef ushort1 new()
    @staticmethod
    cdef ushort1 fromValue(chip.ushort1 other)


cdef class ushort2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ushort2* getElementPtr(self)

    @staticmethod
    cdef ushort2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ushort2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef ushort2 new()
    @staticmethod
    cdef ushort2 fromValue(chip.ushort2 other)


cdef class ushort3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ushort3* getElementPtr(self)

    @staticmethod
    cdef ushort3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ushort3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef ushort3 new()
    @staticmethod
    cdef ushort3 fromValue(chip.ushort3 other)


cdef class ushort4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ushort4* getElementPtr(self)

    @staticmethod
    cdef ushort4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ushort4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef ushort4 new()
    @staticmethod
    cdef ushort4 fromValue(chip.ushort4 other)


cdef class short1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.short1* getElementPtr(self)

    @staticmethod
    cdef short1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef short1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef short1 new()
    @staticmethod
    cdef short1 fromValue(chip.short1 other)


cdef class short2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.short2* getElementPtr(self)

    @staticmethod
    cdef short2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef short2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef short2 new()
    @staticmethod
    cdef short2 fromValue(chip.short2 other)


cdef class short3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.short3* getElementPtr(self)

    @staticmethod
    cdef short3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef short3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef short3 new()
    @staticmethod
    cdef short3 fromValue(chip.short3 other)


cdef class short4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.short4* getElementPtr(self)

    @staticmethod
    cdef short4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef short4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef short4 new()
    @staticmethod
    cdef short4 fromValue(chip.short4 other)


cdef class uint1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.uint1* getElementPtr(self)

    @staticmethod
    cdef uint1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef uint1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef uint1 new()
    @staticmethod
    cdef uint1 fromValue(chip.uint1 other)


cdef class uint2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.uint2* getElementPtr(self)

    @staticmethod
    cdef uint2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef uint2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef uint2 new()
    @staticmethod
    cdef uint2 fromValue(chip.uint2 other)


cdef class uint3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.uint3* getElementPtr(self)

    @staticmethod
    cdef uint3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef uint3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef uint3 new()
    @staticmethod
    cdef uint3 fromValue(chip.uint3 other)


cdef class uint4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.uint4* getElementPtr(self)

    @staticmethod
    cdef uint4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef uint4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef uint4 new()
    @staticmethod
    cdef uint4 fromValue(chip.uint4 other)


cdef class int1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.int1* getElementPtr(self)

    @staticmethod
    cdef int1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef int1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef int1 new()
    @staticmethod
    cdef int1 fromValue(chip.int1 other)


cdef class int2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.int2* getElementPtr(self)

    @staticmethod
    cdef int2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef int2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef int2 new()
    @staticmethod
    cdef int2 fromValue(chip.int2 other)


cdef class int3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.int3* getElementPtr(self)

    @staticmethod
    cdef int3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef int3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef int3 new()
    @staticmethod
    cdef int3 fromValue(chip.int3 other)


cdef class int4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.int4* getElementPtr(self)

    @staticmethod
    cdef int4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef int4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef int4 new()
    @staticmethod
    cdef int4 fromValue(chip.int4 other)


cdef class ulong1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ulong1* getElementPtr(self)

    @staticmethod
    cdef ulong1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ulong1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef ulong1 new()
    @staticmethod
    cdef ulong1 fromValue(chip.ulong1 other)


cdef class ulong2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ulong2* getElementPtr(self)

    @staticmethod
    cdef ulong2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ulong2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef ulong2 new()
    @staticmethod
    cdef ulong2 fromValue(chip.ulong2 other)


cdef class ulong3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ulong3* getElementPtr(self)

    @staticmethod
    cdef ulong3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ulong3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef ulong3 new()
    @staticmethod
    cdef ulong3 fromValue(chip.ulong3 other)


cdef class ulong4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ulong4* getElementPtr(self)

    @staticmethod
    cdef ulong4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ulong4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef ulong4 new()
    @staticmethod
    cdef ulong4 fromValue(chip.ulong4 other)


cdef class long1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.long1* getElementPtr(self)

    @staticmethod
    cdef long1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef long1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef long1 new()
    @staticmethod
    cdef long1 fromValue(chip.long1 other)


cdef class long2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.long2* getElementPtr(self)

    @staticmethod
    cdef long2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef long2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef long2 new()
    @staticmethod
    cdef long2 fromValue(chip.long2 other)


cdef class long3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.long3* getElementPtr(self)

    @staticmethod
    cdef long3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef long3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef long3 new()
    @staticmethod
    cdef long3 fromValue(chip.long3 other)


cdef class long4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.long4* getElementPtr(self)

    @staticmethod
    cdef long4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef long4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef long4 new()
    @staticmethod
    cdef long4 fromValue(chip.long4 other)


cdef class ulonglong1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ulonglong1* getElementPtr(self)

    @staticmethod
    cdef ulonglong1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ulonglong1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef ulonglong1 new()
    @staticmethod
    cdef ulonglong1 fromValue(chip.ulonglong1 other)


cdef class ulonglong2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ulonglong2* getElementPtr(self)

    @staticmethod
    cdef ulonglong2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ulonglong2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef ulonglong2 new()
    @staticmethod
    cdef ulonglong2 fromValue(chip.ulonglong2 other)


cdef class ulonglong3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ulonglong3* getElementPtr(self)

    @staticmethod
    cdef ulonglong3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ulonglong3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef ulonglong3 new()
    @staticmethod
    cdef ulonglong3 fromValue(chip.ulonglong3 other)


cdef class ulonglong4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ulonglong4* getElementPtr(self)

    @staticmethod
    cdef ulonglong4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ulonglong4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef ulonglong4 new()
    @staticmethod
    cdef ulonglong4 fromValue(chip.ulonglong4 other)


cdef class longlong1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.longlong1* getElementPtr(self)

    @staticmethod
    cdef longlong1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef longlong1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef longlong1 new()
    @staticmethod
    cdef longlong1 fromValue(chip.longlong1 other)


cdef class longlong2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.longlong2* getElementPtr(self)

    @staticmethod
    cdef longlong2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef longlong2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef longlong2 new()
    @staticmethod
    cdef longlong2 fromValue(chip.longlong2 other)


cdef class longlong3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.longlong3* getElementPtr(self)

    @staticmethod
    cdef longlong3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef longlong3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef longlong3 new()
    @staticmethod
    cdef longlong3 fromValue(chip.longlong3 other)


cdef class longlong4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.longlong4* getElementPtr(self)

    @staticmethod
    cdef longlong4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef longlong4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef longlong4 new()
    @staticmethod
    cdef longlong4 fromValue(chip.longlong4 other)


cdef class float1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.float1* getElementPtr(self)

    @staticmethod
    cdef float1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef float1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef float1 new()
    @staticmethod
    cdef float1 fromValue(chip.float1 other)


cdef class float2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.float2* getElementPtr(self)

    @staticmethod
    cdef float2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef float2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef float2 new()
    @staticmethod
    cdef float2 fromValue(chip.float2 other)


cdef class float3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.float3* getElementPtr(self)

    @staticmethod
    cdef float3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef float3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef float3 new()
    @staticmethod
    cdef float3 fromValue(chip.float3 other)


cdef class float4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.float4* getElementPtr(self)

    @staticmethod
    cdef float4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef float4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef float4 new()
    @staticmethod
    cdef float4 fromValue(chip.float4 other)


cdef class double1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.double1* getElementPtr(self)

    @staticmethod
    cdef double1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef double1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef double1 new()
    @staticmethod
    cdef double1 fromValue(chip.double1 other)


cdef class double2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.double2* getElementPtr(self)

    @staticmethod
    cdef double2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef double2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef double2 new()
    @staticmethod
    cdef double2 fromValue(chip.double2 other)


cdef class double3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.double3* getElementPtr(self)

    @staticmethod
    cdef double3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef double3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef double3 new()
    @staticmethod
    cdef double3 fromValue(chip.double3 other)


cdef class double4(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.double4* getElementPtr(self)

    @staticmethod
    cdef double4 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef double4 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef double4 new()
    @staticmethod
    cdef double4 fromValue(chip.double4 other)


cdef class __hip_texture(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.__hip_texture* getElementPtr(self)

    @staticmethod
    cdef __hip_texture fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef __hip_texture fromPyobj(object pyobj)


cdef class textureReference(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.textureReference* getElementPtr(self)

    @staticmethod
    cdef textureReference fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef textureReference fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef textureReference new()
    @staticmethod
    cdef textureReference fromValue(chip.textureReference other)


cdef class hipTextureDesc(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipTextureDesc* getElementPtr(self)

    @staticmethod
    cdef hipTextureDesc fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipTextureDesc fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipTextureDesc new()
    @staticmethod
    cdef hipTextureDesc fromValue(chip.hipTextureDesc other)


cdef class __hip_surface(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.__hip_surface* getElementPtr(self)

    @staticmethod
    cdef __hip_surface fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef __hip_surface fromPyobj(object pyobj)


cdef class surfaceReference(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.surfaceReference* getElementPtr(self)

    @staticmethod
    cdef surfaceReference fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef surfaceReference fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef surfaceReference new()
    @staticmethod
    cdef surfaceReference fromValue(chip.surfaceReference other)


cdef class ihipCtx_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ihipCtx_t* getElementPtr(self)

    @staticmethod
    cdef ihipCtx_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ihipCtx_t fromPyobj(object pyobj)


cdef class ihipStream_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ihipStream_t* getElementPtr(self)

    @staticmethod
    cdef ihipStream_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ihipStream_t fromPyobj(object pyobj)


cdef class hipIpcMemHandle_st(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipIpcMemHandle_st* getElementPtr(self)

    @staticmethod
    cdef hipIpcMemHandle_st fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipIpcMemHandle_st fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipIpcMemHandle_st new()
    @staticmethod
    cdef hipIpcMemHandle_st fromValue(chip.hipIpcMemHandle_st other)


cdef class hipIpcEventHandle_st(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipIpcEventHandle_st* getElementPtr(self)

    @staticmethod
    cdef hipIpcEventHandle_st fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipIpcEventHandle_st fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipIpcEventHandle_st new()
    @staticmethod
    cdef hipIpcEventHandle_st fromValue(chip.hipIpcEventHandle_st other)


cdef class ihipModule_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ihipModule_t* getElementPtr(self)

    @staticmethod
    cdef ihipModule_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ihipModule_t fromPyobj(object pyobj)


cdef class ihipModuleSymbol_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ihipModuleSymbol_t* getElementPtr(self)

    @staticmethod
    cdef ihipModuleSymbol_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ihipModuleSymbol_t fromPyobj(object pyobj)


cdef class ihipMemPoolHandle_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ihipMemPoolHandle_t* getElementPtr(self)

    @staticmethod
    cdef ihipMemPoolHandle_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ihipMemPoolHandle_t fromPyobj(object pyobj)


cdef class hipFuncAttributes(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipFuncAttributes* getElementPtr(self)

    @staticmethod
    cdef hipFuncAttributes fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipFuncAttributes fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipFuncAttributes new()
    @staticmethod
    cdef hipFuncAttributes fromValue(chip.hipFuncAttributes other)


cdef class ihipEvent_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ihipEvent_t* getElementPtr(self)

    @staticmethod
    cdef ihipEvent_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ihipEvent_t fromPyobj(object pyobj)


cdef class hipMemLocation(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipMemLocation* getElementPtr(self)

    @staticmethod
    cdef hipMemLocation fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipMemLocation fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipMemLocation new()
    @staticmethod
    cdef hipMemLocation fromValue(chip.hipMemLocation other)


cdef class hipMemAccessDesc(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipMemAccessDesc* getElementPtr(self)

    @staticmethod
    cdef hipMemAccessDesc fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipMemAccessDesc fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipMemAccessDesc new()
    @staticmethod
    cdef hipMemAccessDesc fromValue(chip.hipMemAccessDesc other)


cdef class hipMemPoolProps(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipMemPoolProps* getElementPtr(self)

    @staticmethod
    cdef hipMemPoolProps fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipMemPoolProps fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipMemPoolProps new()
    @staticmethod
    cdef hipMemPoolProps fromValue(chip.hipMemPoolProps other)


cdef class hipMemPoolPtrExportData(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipMemPoolPtrExportData* getElementPtr(self)

    @staticmethod
    cdef hipMemPoolPtrExportData fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipMemPoolPtrExportData fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipMemPoolPtrExportData new()
    @staticmethod
    cdef hipMemPoolPtrExportData fromValue(chip.hipMemPoolPtrExportData other)


cdef class dim3(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.dim3* getElementPtr(self)

    @staticmethod
    cdef dim3 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef dim3 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef dim3 new()
    @staticmethod
    cdef dim3 fromValue(chip.dim3 other)


cdef class hipLaunchParams_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipLaunchParams_t* getElementPtr(self)

    @staticmethod
    cdef hipLaunchParams_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipLaunchParams_t fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipLaunchParams_t new()
    @staticmethod
    cdef hipLaunchParams_t fromValue(chip.hipLaunchParams_t other)


cdef class hipFunctionLaunchParams_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipFunctionLaunchParams_t* getElementPtr(self)

    @staticmethod
    cdef hipFunctionLaunchParams_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipFunctionLaunchParams_t fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipFunctionLaunchParams_t new()
    @staticmethod
    cdef hipFunctionLaunchParams_t fromValue(chip.hipFunctionLaunchParams_t other)


cdef class hipExternalMemoryHandleDesc_st_union_0_struct_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalMemoryHandleDesc_st_union_0_struct_0* getElementPtr(self)

    @staticmethod
    cdef hipExternalMemoryHandleDesc_st_union_0_struct_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalMemoryHandleDesc_st_union_0_struct_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalMemoryHandleDesc_st_union_0_struct_0 new()
    @staticmethod
    cdef hipExternalMemoryHandleDesc_st_union_0_struct_0 fromValue(chip.hipExternalMemoryHandleDesc_st_union_0_struct_0 other)


cdef class hipExternalMemoryHandleDesc_st_union_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalMemoryHandleDesc_st_union_0* getElementPtr(self)

    @staticmethod
    cdef hipExternalMemoryHandleDesc_st_union_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalMemoryHandleDesc_st_union_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalMemoryHandleDesc_st_union_0 new()
    @staticmethod
    cdef hipExternalMemoryHandleDesc_st_union_0 fromValue(chip.hipExternalMemoryHandleDesc_st_union_0 other)


cdef class hipExternalMemoryHandleDesc_st(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalMemoryHandleDesc_st* getElementPtr(self)

    @staticmethod
    cdef hipExternalMemoryHandleDesc_st fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalMemoryHandleDesc_st fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalMemoryHandleDesc_st new()
    @staticmethod
    cdef hipExternalMemoryHandleDesc_st fromValue(chip.hipExternalMemoryHandleDesc_st other)


cdef class hipExternalMemoryBufferDesc_st(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalMemoryBufferDesc_st* getElementPtr(self)

    @staticmethod
    cdef hipExternalMemoryBufferDesc_st fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalMemoryBufferDesc_st fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalMemoryBufferDesc_st new()
    @staticmethod
    cdef hipExternalMemoryBufferDesc_st fromValue(chip.hipExternalMemoryBufferDesc_st other)


cdef class hipExternalMemoryMipmappedArrayDesc_st(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalMemoryMipmappedArrayDesc_st* getElementPtr(self)

    @staticmethod
    cdef hipExternalMemoryMipmappedArrayDesc_st fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalMemoryMipmappedArrayDesc_st fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalMemoryMipmappedArrayDesc_st new()
    @staticmethod
    cdef hipExternalMemoryMipmappedArrayDesc_st fromValue(chip.hipExternalMemoryMipmappedArrayDesc_st other)


cdef class hipExternalMemory_t(hip._util.types.Pointer): pass

cdef class hipExternalSemaphoreHandleDesc_st_union_0_struct_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreHandleDesc_st_union_0_struct_0* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreHandleDesc_st_union_0_struct_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreHandleDesc_st_union_0_struct_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreHandleDesc_st_union_0_struct_0 new()
    @staticmethod
    cdef hipExternalSemaphoreHandleDesc_st_union_0_struct_0 fromValue(chip.hipExternalSemaphoreHandleDesc_st_union_0_struct_0 other)


cdef class hipExternalSemaphoreHandleDesc_st_union_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreHandleDesc_st_union_0* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreHandleDesc_st_union_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreHandleDesc_st_union_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreHandleDesc_st_union_0 new()
    @staticmethod
    cdef hipExternalSemaphoreHandleDesc_st_union_0 fromValue(chip.hipExternalSemaphoreHandleDesc_st_union_0 other)


cdef class hipExternalSemaphoreHandleDesc_st(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreHandleDesc_st* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreHandleDesc_st fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreHandleDesc_st fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreHandleDesc_st new()
    @staticmethod
    cdef hipExternalSemaphoreHandleDesc_st fromValue(chip.hipExternalSemaphoreHandleDesc_st other)


cdef class hipExternalSemaphore_t(hip._util.types.Pointer): pass

cdef class hipExternalSemaphoreSignalParams_st_struct_0_struct_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreSignalParams_st_struct_0_struct_0* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0_struct_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0_struct_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0_struct_0 new()
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0_struct_0 fromValue(chip.hipExternalSemaphoreSignalParams_st_struct_0_struct_0 other)


cdef class hipExternalSemaphoreSignalParams_st_struct_0_union_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreSignalParams_st_struct_0_union_0* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0_union_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0_union_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0_union_0 new()
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0_union_0 fromValue(chip.hipExternalSemaphoreSignalParams_st_struct_0_union_0 other)


cdef class hipExternalSemaphoreSignalParams_st_struct_0_struct_1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreSignalParams_st_struct_0_struct_1* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0_struct_1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0_struct_1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0_struct_1 new()
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0_struct_1 fromValue(chip.hipExternalSemaphoreSignalParams_st_struct_0_struct_1 other)


cdef class hipExternalSemaphoreSignalParams_st_struct_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreSignalParams_st_struct_0* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0 new()
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st_struct_0 fromValue(chip.hipExternalSemaphoreSignalParams_st_struct_0 other)


cdef class hipExternalSemaphoreSignalParams_st(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreSignalParams_st* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st new()
    @staticmethod
    cdef hipExternalSemaphoreSignalParams_st fromValue(chip.hipExternalSemaphoreSignalParams_st other)


cdef class hipExternalSemaphoreWaitParams_st_struct_0_struct_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreWaitParams_st_struct_0_struct_0* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0_struct_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0_struct_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0_struct_0 new()
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0_struct_0 fromValue(chip.hipExternalSemaphoreWaitParams_st_struct_0_struct_0 other)


cdef class hipExternalSemaphoreWaitParams_st_struct_0_union_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreWaitParams_st_struct_0_union_0* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0_union_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0_union_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0_union_0 new()
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0_union_0 fromValue(chip.hipExternalSemaphoreWaitParams_st_struct_0_union_0 other)


cdef class hipExternalSemaphoreWaitParams_st_struct_0_struct_1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreWaitParams_st_struct_0_struct_1* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0_struct_1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0_struct_1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0_struct_1 new()
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0_struct_1 fromValue(chip.hipExternalSemaphoreWaitParams_st_struct_0_struct_1 other)


cdef class hipExternalSemaphoreWaitParams_st_struct_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreWaitParams_st_struct_0* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0 new()
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st_struct_0 fromValue(chip.hipExternalSemaphoreWaitParams_st_struct_0 other)


cdef class hipExternalSemaphoreWaitParams_st(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreWaitParams_st* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st new()
    @staticmethod
    cdef hipExternalSemaphoreWaitParams_st fromValue(chip.hipExternalSemaphoreWaitParams_st other)


cdef class _hipGraphicsResource(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip._hipGraphicsResource* getElementPtr(self)

    @staticmethod
    cdef _hipGraphicsResource fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef _hipGraphicsResource fromPyobj(object pyobj)


cdef class ihipGraph(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ihipGraph* getElementPtr(self)

    @staticmethod
    cdef ihipGraph fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ihipGraph fromPyobj(object pyobj)


cdef class hipGraphNode(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipGraphNode* getElementPtr(self)

    @staticmethod
    cdef hipGraphNode fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipGraphNode fromPyobj(object pyobj)


cdef class hipGraphExec(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipGraphExec* getElementPtr(self)

    @staticmethod
    cdef hipGraphExec fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipGraphExec fromPyobj(object pyobj)


cdef class hipUserObject(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipUserObject* getElementPtr(self)

    @staticmethod
    cdef hipUserObject fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipUserObject fromPyobj(object pyobj)


cdef class hipHostFn_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipHostFn_t getElementPtr(self)

    @staticmethod
    cdef hipHostFn_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipHostFn_t fromPyobj(object pyobj)


cdef class hipHostNodeParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipHostNodeParams* getElementPtr(self)

    @staticmethod
    cdef hipHostNodeParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipHostNodeParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipHostNodeParams new()
    @staticmethod
    cdef hipHostNodeParams fromValue(chip.hipHostNodeParams other)


cdef class hipKernelNodeParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipKernelNodeParams* getElementPtr(self)

    @staticmethod
    cdef hipKernelNodeParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipKernelNodeParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipKernelNodeParams new()
    @staticmethod
    cdef hipKernelNodeParams fromValue(chip.hipKernelNodeParams other)


cdef class hipMemsetParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipMemsetParams* getElementPtr(self)

    @staticmethod
    cdef hipMemsetParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipMemsetParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipMemsetParams new()
    @staticmethod
    cdef hipMemsetParams fromValue(chip.hipMemsetParams other)


cdef class hipMemAllocNodeParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipMemAllocNodeParams* getElementPtr(self)

    @staticmethod
    cdef hipMemAllocNodeParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipMemAllocNodeParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipMemAllocNodeParams new()
    @staticmethod
    cdef hipMemAllocNodeParams fromValue(chip.hipMemAllocNodeParams other)


cdef class hipAccessPolicyWindow(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipAccessPolicyWindow* getElementPtr(self)

    @staticmethod
    cdef hipAccessPolicyWindow fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipAccessPolicyWindow fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipAccessPolicyWindow new()
    @staticmethod
    cdef hipAccessPolicyWindow fromValue(chip.hipAccessPolicyWindow other)


cdef class hipLaunchAttributeValue(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipLaunchAttributeValue* getElementPtr(self)

    @staticmethod
    cdef hipLaunchAttributeValue fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipLaunchAttributeValue fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipLaunchAttributeValue new()
    @staticmethod
    cdef hipLaunchAttributeValue fromValue(chip.hipLaunchAttributeValue other)


cdef class HIP_MEMSET_NODE_PARAMS(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.HIP_MEMSET_NODE_PARAMS* getElementPtr(self)

    @staticmethod
    cdef HIP_MEMSET_NODE_PARAMS fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef HIP_MEMSET_NODE_PARAMS fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef HIP_MEMSET_NODE_PARAMS new()
    @staticmethod
    cdef HIP_MEMSET_NODE_PARAMS fromValue(chip.HIP_MEMSET_NODE_PARAMS other)


cdef class hipGraphInstantiateParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipGraphInstantiateParams* getElementPtr(self)

    @staticmethod
    cdef hipGraphInstantiateParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipGraphInstantiateParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipGraphInstantiateParams new()
    @staticmethod
    cdef hipGraphInstantiateParams fromValue(chip.hipGraphInstantiateParams other)


cdef class hipMemAllocationProp_struct_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipMemAllocationProp_struct_0* getElementPtr(self)

    @staticmethod
    cdef hipMemAllocationProp_struct_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipMemAllocationProp_struct_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipMemAllocationProp_struct_0 new()
    @staticmethod
    cdef hipMemAllocationProp_struct_0 fromValue(chip.hipMemAllocationProp_struct_0 other)


cdef class hipMemAllocationProp(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipMemAllocationProp* getElementPtr(self)

    @staticmethod
    cdef hipMemAllocationProp fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipMemAllocationProp fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipMemAllocationProp new()
    @staticmethod
    cdef hipMemAllocationProp fromValue(chip.hipMemAllocationProp other)


cdef class hipExternalSemaphoreSignalNodeParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreSignalNodeParams* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreSignalNodeParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreSignalNodeParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreSignalNodeParams new()
    @staticmethod
    cdef hipExternalSemaphoreSignalNodeParams fromValue(chip.hipExternalSemaphoreSignalNodeParams other)


cdef class hipExternalSemaphoreWaitNodeParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipExternalSemaphoreWaitNodeParams* getElementPtr(self)

    @staticmethod
    cdef hipExternalSemaphoreWaitNodeParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipExternalSemaphoreWaitNodeParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipExternalSemaphoreWaitNodeParams new()
    @staticmethod
    cdef hipExternalSemaphoreWaitNodeParams fromValue(chip.hipExternalSemaphoreWaitNodeParams other)


cdef class ihipMemGenericAllocationHandle(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.ihipMemGenericAllocationHandle* getElementPtr(self)

    @staticmethod
    cdef ihipMemGenericAllocationHandle fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef ihipMemGenericAllocationHandle fromPyobj(object pyobj)


cdef class hipArrayMapInfo_union_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipArrayMapInfo_union_0* getElementPtr(self)

    @staticmethod
    cdef hipArrayMapInfo_union_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipArrayMapInfo_union_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipArrayMapInfo_union_0 new()
    @staticmethod
    cdef hipArrayMapInfo_union_0 fromValue(chip.hipArrayMapInfo_union_0 other)


cdef class hipArrayMapInfo_union_1_struct_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipArrayMapInfo_union_1_struct_0* getElementPtr(self)

    @staticmethod
    cdef hipArrayMapInfo_union_1_struct_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipArrayMapInfo_union_1_struct_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipArrayMapInfo_union_1_struct_0 new()
    @staticmethod
    cdef hipArrayMapInfo_union_1_struct_0 fromValue(chip.hipArrayMapInfo_union_1_struct_0 other)


cdef class hipArrayMapInfo_union_1_struct_1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipArrayMapInfo_union_1_struct_1* getElementPtr(self)

    @staticmethod
    cdef hipArrayMapInfo_union_1_struct_1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipArrayMapInfo_union_1_struct_1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipArrayMapInfo_union_1_struct_1 new()
    @staticmethod
    cdef hipArrayMapInfo_union_1_struct_1 fromValue(chip.hipArrayMapInfo_union_1_struct_1 other)


cdef class hipArrayMapInfo_union_1(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipArrayMapInfo_union_1* getElementPtr(self)

    @staticmethod
    cdef hipArrayMapInfo_union_1 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipArrayMapInfo_union_1 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipArrayMapInfo_union_1 new()
    @staticmethod
    cdef hipArrayMapInfo_union_1 fromValue(chip.hipArrayMapInfo_union_1 other)


cdef class hipArrayMapInfo_union_2(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipArrayMapInfo_union_2* getElementPtr(self)

    @staticmethod
    cdef hipArrayMapInfo_union_2 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipArrayMapInfo_union_2 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipArrayMapInfo_union_2 new()
    @staticmethod
    cdef hipArrayMapInfo_union_2 fromValue(chip.hipArrayMapInfo_union_2 other)


cdef class hipArrayMapInfo(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipArrayMapInfo* getElementPtr(self)

    @staticmethod
    cdef hipArrayMapInfo fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipArrayMapInfo fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipArrayMapInfo new()
    @staticmethod
    cdef hipArrayMapInfo fromValue(chip.hipArrayMapInfo other)


cdef class hipMemcpyNodeParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipMemcpyNodeParams* getElementPtr(self)

    @staticmethod
    cdef hipMemcpyNodeParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipMemcpyNodeParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipMemcpyNodeParams new()
    @staticmethod
    cdef hipMemcpyNodeParams fromValue(chip.hipMemcpyNodeParams other)


cdef class hipChildGraphNodeParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipChildGraphNodeParams* getElementPtr(self)

    @staticmethod
    cdef hipChildGraphNodeParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipChildGraphNodeParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipChildGraphNodeParams new()
    @staticmethod
    cdef hipChildGraphNodeParams fromValue(chip.hipChildGraphNodeParams other)


cdef class hipEventWaitNodeParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipEventWaitNodeParams* getElementPtr(self)

    @staticmethod
    cdef hipEventWaitNodeParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipEventWaitNodeParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipEventWaitNodeParams new()
    @staticmethod
    cdef hipEventWaitNodeParams fromValue(chip.hipEventWaitNodeParams other)


cdef class hipEventRecordNodeParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipEventRecordNodeParams* getElementPtr(self)

    @staticmethod
    cdef hipEventRecordNodeParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipEventRecordNodeParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipEventRecordNodeParams new()
    @staticmethod
    cdef hipEventRecordNodeParams fromValue(chip.hipEventRecordNodeParams other)


cdef class hipMemFreeNodeParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipMemFreeNodeParams* getElementPtr(self)

    @staticmethod
    cdef hipMemFreeNodeParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipMemFreeNodeParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipMemFreeNodeParams new()
    @staticmethod
    cdef hipMemFreeNodeParams fromValue(chip.hipMemFreeNodeParams other)


cdef class hipGraphNodeParams_union_0(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipGraphNodeParams_union_0* getElementPtr(self)

    @staticmethod
    cdef hipGraphNodeParams_union_0 fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipGraphNodeParams_union_0 fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipGraphNodeParams_union_0 new()
    @staticmethod
    cdef hipGraphNodeParams_union_0 fromValue(chip.hipGraphNodeParams_union_0 other)


cdef class hipGraphNodeParams(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipGraphNodeParams* getElementPtr(self)

    @staticmethod
    cdef hipGraphNodeParams fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipGraphNodeParams fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipGraphNodeParams new()
    @staticmethod
    cdef hipGraphNodeParams fromValue(chip.hipGraphNodeParams other)


cdef class hipGraphEdgeData(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipGraphEdgeData* getElementPtr(self)

    @staticmethod
    cdef hipGraphEdgeData fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipGraphEdgeData fromPyobj(object pyobj)
    @staticmethod
    cdef __allocate(void* ptr)
    @staticmethod
    cdef hipGraphEdgeData new()
    @staticmethod
    cdef hipGraphEdgeData fromValue(chip.hipGraphEdgeData other)


cdef class hipStreamCallback_t(hip._util.types.Pointer):
    cdef bint _is_ptr_owner

    cdef chip.hipStreamCallback_t getElementPtr(self)

    @staticmethod
    cdef hipStreamCallback_t fromPtr(void* ptr, bint owner=*)
    @staticmethod
    cdef hipStreamCallback_t fromPyobj(object pyobj)
