# MIT License
#
# Copyright (c) 2021-2025 Advanced Micro Devices, Inc.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


# This file has been autogenerated, do not modify.

cimport hip._util.posixloader as loader
cdef void* _lib_handle = NULL

DLL = b"libhipsolver.so"

cdef int __init() except 1 nogil:
    global DLL
    global _lib_handle
    cdef char* dll = NULL
    if _lib_handle == NULL:
        with gil:
            dll = DLL
        return loader.open_library(&_lib_handle,dll)
    return 0

cdef int __init_symbol(void** result, const char* name) except 1 nogil:
    global _lib_handle
    cdef int init_result = 0
    if _lib_handle == NULL:
        init_result = __init()
        if init_result > 0:
            return init_result
    if result[0] == NULL:
        return loader.load_symbol(result,_lib_handle, name)
    return 0


cdef void* _hipsolverCreate__funptr = NULL
cdef hipsolverStatus_t hipsolverCreate(void ** handle):
    global _hipsolverCreate__funptr
    if __init_symbol(&_hipsolverCreate__funptr,"hipsolverCreate") > 0:
        pass
    return (<hipsolverStatus_t (*)(void **) noexcept nogil> _hipsolverCreate__funptr)(handle)


cdef void* _hipsolverDestroy__funptr = NULL
cdef hipsolverStatus_t hipsolverDestroy(void * handle):
    global _hipsolverDestroy__funptr
    if __init_symbol(&_hipsolverDestroy__funptr,"hipsolverDestroy") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverDestroy__funptr)(handle)


cdef void* _hipsolverSetStream__funptr = NULL
cdef hipsolverStatus_t hipsolverSetStream(void * handle,hipStream_t streamId):
    global _hipsolverSetStream__funptr
    if __init_symbol(&_hipsolverSetStream__funptr,"hipsolverSetStream") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipStream_t) noexcept nogil> _hipsolverSetStream__funptr)(handle,streamId)


cdef void* _hipsolverGetStream__funptr = NULL
cdef hipsolverStatus_t hipsolverGetStream(void * handle,hipStream_t* streamId):
    global _hipsolverGetStream__funptr
    if __init_symbol(&_hipsolverGetStream__funptr,"hipsolverGetStream") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipStream_t*) noexcept nogil> _hipsolverGetStream__funptr)(handle,streamId)


cdef void* _hipsolverSetDeterministicMode__funptr = NULL
cdef hipsolverStatus_t hipsolverSetDeterministicMode(void * handle,hipsolverDeterministicMode_t mode):
    global _hipsolverSetDeterministicMode__funptr
    if __init_symbol(&_hipsolverSetDeterministicMode__funptr,"hipsolverSetDeterministicMode") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverDeterministicMode_t) noexcept nogil> _hipsolverSetDeterministicMode__funptr)(handle,mode)


cdef void* _hipsolverGetDeterministicMode__funptr = NULL
cdef hipsolverStatus_t hipsolverGetDeterministicMode(void * handle,hipsolverDeterministicMode_t * mode):
    global _hipsolverGetDeterministicMode__funptr
    if __init_symbol(&_hipsolverGetDeterministicMode__funptr,"hipsolverGetDeterministicMode") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverDeterministicMode_t *) noexcept nogil> _hipsolverGetDeterministicMode__funptr)(handle,mode)


cdef void* _hipsolverCreateGesvdjInfo__funptr = NULL
cdef hipsolverStatus_t hipsolverCreateGesvdjInfo(void ** info):
    global _hipsolverCreateGesvdjInfo__funptr
    if __init_symbol(&_hipsolverCreateGesvdjInfo__funptr,"hipsolverCreateGesvdjInfo") > 0:
        pass
    return (<hipsolverStatus_t (*)(void **) noexcept nogil> _hipsolverCreateGesvdjInfo__funptr)(info)


cdef void* _hipsolverDestroyGesvdjInfo__funptr = NULL
cdef hipsolverStatus_t hipsolverDestroyGesvdjInfo(void * info):
    global _hipsolverDestroyGesvdjInfo__funptr
    if __init_symbol(&_hipsolverDestroyGesvdjInfo__funptr,"hipsolverDestroyGesvdjInfo") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverDestroyGesvdjInfo__funptr)(info)


cdef void* _hipsolverXgesvdjSetMaxSweeps__funptr = NULL
cdef hipsolverStatus_t hipsolverXgesvdjSetMaxSweeps(void * info,int max_sweeps):
    global _hipsolverXgesvdjSetMaxSweeps__funptr
    if __init_symbol(&_hipsolverXgesvdjSetMaxSweeps__funptr,"hipsolverXgesvdjSetMaxSweeps") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int) noexcept nogil> _hipsolverXgesvdjSetMaxSweeps__funptr)(info,max_sweeps)


cdef void* _hipsolverXgesvdjSetSortEig__funptr = NULL
cdef hipsolverStatus_t hipsolverXgesvdjSetSortEig(void * info,int sort_eig):
    global _hipsolverXgesvdjSetSortEig__funptr
    if __init_symbol(&_hipsolverXgesvdjSetSortEig__funptr,"hipsolverXgesvdjSetSortEig") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int) noexcept nogil> _hipsolverXgesvdjSetSortEig__funptr)(info,sort_eig)


cdef void* _hipsolverXgesvdjSetTolerance__funptr = NULL
cdef hipsolverStatus_t hipsolverXgesvdjSetTolerance(void * info,double tolerance):
    global _hipsolverXgesvdjSetTolerance__funptr
    if __init_symbol(&_hipsolverXgesvdjSetTolerance__funptr,"hipsolverXgesvdjSetTolerance") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,double) noexcept nogil> _hipsolverXgesvdjSetTolerance__funptr)(info,tolerance)


cdef void* _hipsolverXgesvdjGetResidual__funptr = NULL
cdef hipsolverStatus_t hipsolverXgesvdjGetResidual(void * handle,void * info,double * residual):
    global _hipsolverXgesvdjGetResidual__funptr
    if __init_symbol(&_hipsolverXgesvdjGetResidual__funptr,"hipsolverXgesvdjGetResidual") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,double *) noexcept nogil> _hipsolverXgesvdjGetResidual__funptr)(handle,info,residual)


cdef void* _hipsolverXgesvdjGetSweeps__funptr = NULL
cdef hipsolverStatus_t hipsolverXgesvdjGetSweeps(void * handle,void * info,int * executed_sweeps):
    global _hipsolverXgesvdjGetSweeps__funptr
    if __init_symbol(&_hipsolverXgesvdjGetSweeps__funptr,"hipsolverXgesvdjGetSweeps") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,int *) noexcept nogil> _hipsolverXgesvdjGetSweeps__funptr)(handle,info,executed_sweeps)


cdef void* _hipsolverCreateSyevjInfo__funptr = NULL
cdef hipsolverStatus_t hipsolverCreateSyevjInfo(void ** info):
    global _hipsolverCreateSyevjInfo__funptr
    if __init_symbol(&_hipsolverCreateSyevjInfo__funptr,"hipsolverCreateSyevjInfo") > 0:
        pass
    return (<hipsolverStatus_t (*)(void **) noexcept nogil> _hipsolverCreateSyevjInfo__funptr)(info)


cdef void* _hipsolverDestroySyevjInfo__funptr = NULL
cdef hipsolverStatus_t hipsolverDestroySyevjInfo(void * info):
    global _hipsolverDestroySyevjInfo__funptr
    if __init_symbol(&_hipsolverDestroySyevjInfo__funptr,"hipsolverDestroySyevjInfo") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverDestroySyevjInfo__funptr)(info)


cdef void* _hipsolverXsyevjSetMaxSweeps__funptr = NULL
cdef hipsolverStatus_t hipsolverXsyevjSetMaxSweeps(void * info,int max_sweeps):
    global _hipsolverXsyevjSetMaxSweeps__funptr
    if __init_symbol(&_hipsolverXsyevjSetMaxSweeps__funptr,"hipsolverXsyevjSetMaxSweeps") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int) noexcept nogil> _hipsolverXsyevjSetMaxSweeps__funptr)(info,max_sweeps)


cdef void* _hipsolverXsyevjSetSortEig__funptr = NULL
cdef hipsolverStatus_t hipsolverXsyevjSetSortEig(void * info,int sort_eig):
    global _hipsolverXsyevjSetSortEig__funptr
    if __init_symbol(&_hipsolverXsyevjSetSortEig__funptr,"hipsolverXsyevjSetSortEig") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int) noexcept nogil> _hipsolverXsyevjSetSortEig__funptr)(info,sort_eig)


cdef void* _hipsolverXsyevjSetTolerance__funptr = NULL
cdef hipsolverStatus_t hipsolverXsyevjSetTolerance(void * info,double tolerance):
    global _hipsolverXsyevjSetTolerance__funptr
    if __init_symbol(&_hipsolverXsyevjSetTolerance__funptr,"hipsolverXsyevjSetTolerance") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,double) noexcept nogil> _hipsolverXsyevjSetTolerance__funptr)(info,tolerance)


cdef void* _hipsolverXsyevjGetResidual__funptr = NULL
cdef hipsolverStatus_t hipsolverXsyevjGetResidual(void * handle,void * info,double * residual):
    global _hipsolverXsyevjGetResidual__funptr
    if __init_symbol(&_hipsolverXsyevjGetResidual__funptr,"hipsolverXsyevjGetResidual") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,double *) noexcept nogil> _hipsolverXsyevjGetResidual__funptr)(handle,info,residual)


cdef void* _hipsolverXsyevjGetSweeps__funptr = NULL
cdef hipsolverStatus_t hipsolverXsyevjGetSweeps(void * handle,void * info,int * executed_sweeps):
    global _hipsolverXsyevjGetSweeps__funptr
    if __init_symbol(&_hipsolverXsyevjGetSweeps__funptr,"hipsolverXsyevjGetSweeps") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,int *) noexcept nogil> _hipsolverXsyevjGetSweeps__funptr)(handle,info,executed_sweeps)


cdef void* _hipsolverSorgbr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSorgbr_bufferSize(void * handle,hipblasSideMode_t side,int m,int n,int k,float * A,int lda,float * tau,int * lwork):
    global _hipsolverSorgbr_bufferSize__funptr
    if __init_symbol(&_hipsolverSorgbr_bufferSize__funptr,"hipsolverSorgbr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,float *,int,float *,int *) noexcept nogil> _hipsolverSorgbr_bufferSize__funptr)(handle,side,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverDorgbr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDorgbr_bufferSize(void * handle,hipblasSideMode_t side,int m,int n,int k,double * A,int lda,double * tau,int * lwork):
    global _hipsolverDorgbr_bufferSize__funptr
    if __init_symbol(&_hipsolverDorgbr_bufferSize__funptr,"hipsolverDorgbr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,double *,int,double *,int *) noexcept nogil> _hipsolverDorgbr_bufferSize__funptr)(handle,side,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverCungbr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCungbr_bufferSize(void * handle,hipblasSideMode_t side,int m,int n,int k,float2 * A,int lda,float2 * tau,int * lwork):
    global _hipsolverCungbr_bufferSize__funptr
    if __init_symbol(&_hipsolverCungbr_bufferSize__funptr,"hipsolverCungbr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,float2 *,int,float2 *,int *) noexcept nogil> _hipsolverCungbr_bufferSize__funptr)(handle,side,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverZungbr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZungbr_bufferSize(void * handle,hipblasSideMode_t side,int m,int n,int k,double2 * A,int lda,double2 * tau,int * lwork):
    global _hipsolverZungbr_bufferSize__funptr
    if __init_symbol(&_hipsolverZungbr_bufferSize__funptr,"hipsolverZungbr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,double2 *,int,double2 *,int *) noexcept nogil> _hipsolverZungbr_bufferSize__funptr)(handle,side,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverSorgbr__funptr = NULL
cdef hipsolverStatus_t hipsolverSorgbr(void * handle,hipblasSideMode_t side,int m,int n,int k,float * A,int lda,float * tau,float * work,int lwork,int * devInfo):
    global _hipsolverSorgbr__funptr
    if __init_symbol(&_hipsolverSorgbr__funptr,"hipsolverSorgbr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,float *,int,float *,float *,int,int *) noexcept nogil> _hipsolverSorgbr__funptr)(handle,side,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDorgbr__funptr = NULL
cdef hipsolverStatus_t hipsolverDorgbr(void * handle,hipblasSideMode_t side,int m,int n,int k,double * A,int lda,double * tau,double * work,int lwork,int * devInfo):
    global _hipsolverDorgbr__funptr
    if __init_symbol(&_hipsolverDorgbr__funptr,"hipsolverDorgbr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,double *,int,double *,double *,int,int *) noexcept nogil> _hipsolverDorgbr__funptr)(handle,side,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverCungbr__funptr = NULL
cdef hipsolverStatus_t hipsolverCungbr(void * handle,hipblasSideMode_t side,int m,int n,int k,float2 * A,int lda,float2 * tau,float2 * work,int lwork,int * devInfo):
    global _hipsolverCungbr__funptr
    if __init_symbol(&_hipsolverCungbr__funptr,"hipsolverCungbr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,float2 *,int,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverCungbr__funptr)(handle,side,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverZungbr__funptr = NULL
cdef hipsolverStatus_t hipsolverZungbr(void * handle,hipblasSideMode_t side,int m,int n,int k,double2 * A,int lda,double2 * tau,double2 * work,int lwork,int * devInfo):
    global _hipsolverZungbr__funptr
    if __init_symbol(&_hipsolverZungbr__funptr,"hipsolverZungbr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,double2 *,int,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverZungbr__funptr)(handle,side,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverSorgqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSorgqr_bufferSize(void * handle,int m,int n,int k,float * A,int lda,float * tau,int * lwork):
    global _hipsolverSorgqr_bufferSize__funptr
    if __init_symbol(&_hipsolverSorgqr_bufferSize__funptr,"hipsolverSorgqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float *,int,float *,int *) noexcept nogil> _hipsolverSorgqr_bufferSize__funptr)(handle,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverDorgqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDorgqr_bufferSize(void * handle,int m,int n,int k,double * A,int lda,double * tau,int * lwork):
    global _hipsolverDorgqr_bufferSize__funptr
    if __init_symbol(&_hipsolverDorgqr_bufferSize__funptr,"hipsolverDorgqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double *,int,double *,int *) noexcept nogil> _hipsolverDorgqr_bufferSize__funptr)(handle,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverCungqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCungqr_bufferSize(void * handle,int m,int n,int k,float2 * A,int lda,float2 * tau,int * lwork):
    global _hipsolverCungqr_bufferSize__funptr
    if __init_symbol(&_hipsolverCungqr_bufferSize__funptr,"hipsolverCungqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float2 *,int,float2 *,int *) noexcept nogil> _hipsolverCungqr_bufferSize__funptr)(handle,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverZungqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZungqr_bufferSize(void * handle,int m,int n,int k,double2 * A,int lda,double2 * tau,int * lwork):
    global _hipsolverZungqr_bufferSize__funptr
    if __init_symbol(&_hipsolverZungqr_bufferSize__funptr,"hipsolverZungqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double2 *,int,double2 *,int *) noexcept nogil> _hipsolverZungqr_bufferSize__funptr)(handle,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverSorgqr__funptr = NULL
cdef hipsolverStatus_t hipsolverSorgqr(void * handle,int m,int n,int k,float * A,int lda,float * tau,float * work,int lwork,int * devInfo):
    global _hipsolverSorgqr__funptr
    if __init_symbol(&_hipsolverSorgqr__funptr,"hipsolverSorgqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float *,int,float *,float *,int,int *) noexcept nogil> _hipsolverSorgqr__funptr)(handle,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDorgqr__funptr = NULL
cdef hipsolverStatus_t hipsolverDorgqr(void * handle,int m,int n,int k,double * A,int lda,double * tau,double * work,int lwork,int * devInfo):
    global _hipsolverDorgqr__funptr
    if __init_symbol(&_hipsolverDorgqr__funptr,"hipsolverDorgqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double *,int,double *,double *,int,int *) noexcept nogil> _hipsolverDorgqr__funptr)(handle,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverCungqr__funptr = NULL
cdef hipsolverStatus_t hipsolverCungqr(void * handle,int m,int n,int k,float2 * A,int lda,float2 * tau,float2 * work,int lwork,int * devInfo):
    global _hipsolverCungqr__funptr
    if __init_symbol(&_hipsolverCungqr__funptr,"hipsolverCungqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float2 *,int,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverCungqr__funptr)(handle,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverZungqr__funptr = NULL
cdef hipsolverStatus_t hipsolverZungqr(void * handle,int m,int n,int k,double2 * A,int lda,double2 * tau,double2 * work,int lwork,int * devInfo):
    global _hipsolverZungqr__funptr
    if __init_symbol(&_hipsolverZungqr__funptr,"hipsolverZungqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double2 *,int,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverZungqr__funptr)(handle,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverSorgtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSorgtr_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,float * tau,int * lwork):
    global _hipsolverSorgtr_bufferSize__funptr
    if __init_symbol(&_hipsolverSorgtr_bufferSize__funptr,"hipsolverSorgtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,float *,int *) noexcept nogil> _hipsolverSorgtr_bufferSize__funptr)(handle,uplo,n,A,lda,tau,lwork)


cdef void* _hipsolverDorgtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDorgtr_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,double * tau,int * lwork):
    global _hipsolverDorgtr_bufferSize__funptr
    if __init_symbol(&_hipsolverDorgtr_bufferSize__funptr,"hipsolverDorgtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,double *,int *) noexcept nogil> _hipsolverDorgtr_bufferSize__funptr)(handle,uplo,n,A,lda,tau,lwork)


cdef void* _hipsolverCungtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCungtr_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * tau,int * lwork):
    global _hipsolverCungtr_bufferSize__funptr
    if __init_symbol(&_hipsolverCungtr_bufferSize__funptr,"hipsolverCungtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,float2 *,int *) noexcept nogil> _hipsolverCungtr_bufferSize__funptr)(handle,uplo,n,A,lda,tau,lwork)


cdef void* _hipsolverZungtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZungtr_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * tau,int * lwork):
    global _hipsolverZungtr_bufferSize__funptr
    if __init_symbol(&_hipsolverZungtr_bufferSize__funptr,"hipsolverZungtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,double2 *,int *) noexcept nogil> _hipsolverZungtr_bufferSize__funptr)(handle,uplo,n,A,lda,tau,lwork)


cdef void* _hipsolverSorgtr__funptr = NULL
cdef hipsolverStatus_t hipsolverSorgtr(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,float * tau,float * work,int lwork,int * devInfo):
    global _hipsolverSorgtr__funptr
    if __init_symbol(&_hipsolverSorgtr__funptr,"hipsolverSorgtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,float *,float *,int,int *) noexcept nogil> _hipsolverSorgtr__funptr)(handle,uplo,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDorgtr__funptr = NULL
cdef hipsolverStatus_t hipsolverDorgtr(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,double * tau,double * work,int lwork,int * devInfo):
    global _hipsolverDorgtr__funptr
    if __init_symbol(&_hipsolverDorgtr__funptr,"hipsolverDorgtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,double *,double *,int,int *) noexcept nogil> _hipsolverDorgtr__funptr)(handle,uplo,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverCungtr__funptr = NULL
cdef hipsolverStatus_t hipsolverCungtr(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * tau,float2 * work,int lwork,int * devInfo):
    global _hipsolverCungtr__funptr
    if __init_symbol(&_hipsolverCungtr__funptr,"hipsolverCungtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverCungtr__funptr)(handle,uplo,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverZungtr__funptr = NULL
cdef hipsolverStatus_t hipsolverZungtr(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * tau,double2 * work,int lwork,int * devInfo):
    global _hipsolverZungtr__funptr
    if __init_symbol(&_hipsolverZungtr__funptr,"hipsolverZungtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverZungtr__funptr)(handle,uplo,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverSormqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSormqr_bufferSize(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,float * A,int lda,float * tau,float * C,int ldc,int * lwork):
    global _hipsolverSormqr_bufferSize__funptr
    if __init_symbol(&_hipsolverSormqr_bufferSize__funptr,"hipsolverSormqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,float *,int,float *,float *,int,int *) noexcept nogil> _hipsolverSormqr_bufferSize__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverDormqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDormqr_bufferSize(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,double * A,int lda,double * tau,double * C,int ldc,int * lwork):
    global _hipsolverDormqr_bufferSize__funptr
    if __init_symbol(&_hipsolverDormqr_bufferSize__funptr,"hipsolverDormqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,double *,int,double *,double *,int,int *) noexcept nogil> _hipsolverDormqr_bufferSize__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverCunmqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCunmqr_bufferSize(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,float2 * A,int lda,float2 * tau,float2 * C,int ldc,int * lwork):
    global _hipsolverCunmqr_bufferSize__funptr
    if __init_symbol(&_hipsolverCunmqr_bufferSize__funptr,"hipsolverCunmqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,float2 *,int,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverCunmqr_bufferSize__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverZunmqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZunmqr_bufferSize(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,double2 * A,int lda,double2 * tau,double2 * C,int ldc,int * lwork):
    global _hipsolverZunmqr_bufferSize__funptr
    if __init_symbol(&_hipsolverZunmqr_bufferSize__funptr,"hipsolverZunmqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,double2 *,int,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverZunmqr_bufferSize__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverSormqr__funptr = NULL
cdef hipsolverStatus_t hipsolverSormqr(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,float * A,int lda,float * tau,float * C,int ldc,float * work,int lwork,int * devInfo):
    global _hipsolverSormqr__funptr
    if __init_symbol(&_hipsolverSormqr__funptr,"hipsolverSormqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,float *,int,float *,float *,int,float *,int,int *) noexcept nogil> _hipsolverSormqr__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverDormqr__funptr = NULL
cdef hipsolverStatus_t hipsolverDormqr(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,double * A,int lda,double * tau,double * C,int ldc,double * work,int lwork,int * devInfo):
    global _hipsolverDormqr__funptr
    if __init_symbol(&_hipsolverDormqr__funptr,"hipsolverDormqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,double *,int,double *,double *,int,double *,int,int *) noexcept nogil> _hipsolverDormqr__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverCunmqr__funptr = NULL
cdef hipsolverStatus_t hipsolverCunmqr(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,float2 * A,int lda,float2 * tau,float2 * C,int ldc,float2 * work,int lwork,int * devInfo):
    global _hipsolverCunmqr__funptr
    if __init_symbol(&_hipsolverCunmqr__funptr,"hipsolverCunmqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,float2 *,int,float2 *,float2 *,int,float2 *,int,int *) noexcept nogil> _hipsolverCunmqr__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverZunmqr__funptr = NULL
cdef hipsolverStatus_t hipsolverZunmqr(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,double2 * A,int lda,double2 * tau,double2 * C,int ldc,double2 * work,int lwork,int * devInfo):
    global _hipsolverZunmqr__funptr
    if __init_symbol(&_hipsolverZunmqr__funptr,"hipsolverZunmqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,double2 *,int,double2 *,double2 *,int,double2 *,int,int *) noexcept nogil> _hipsolverZunmqr__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverSormtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSormtr_bufferSize(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,float * A,int lda,float * tau,float * C,int ldc,int * lwork):
    global _hipsolverSormtr_bufferSize__funptr
    if __init_symbol(&_hipsolverSormtr_bufferSize__funptr,"hipsolverSormtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,float *,int,float *,float *,int,int *) noexcept nogil> _hipsolverSormtr_bufferSize__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverDormtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDormtr_bufferSize(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,double * A,int lda,double * tau,double * C,int ldc,int * lwork):
    global _hipsolverDormtr_bufferSize__funptr
    if __init_symbol(&_hipsolverDormtr_bufferSize__funptr,"hipsolverDormtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,double *,int,double *,double *,int,int *) noexcept nogil> _hipsolverDormtr_bufferSize__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverCunmtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCunmtr_bufferSize(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,float2 * A,int lda,float2 * tau,float2 * C,int ldc,int * lwork):
    global _hipsolverCunmtr_bufferSize__funptr
    if __init_symbol(&_hipsolverCunmtr_bufferSize__funptr,"hipsolverCunmtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,float2 *,int,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverCunmtr_bufferSize__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverZunmtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZunmtr_bufferSize(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,double2 * A,int lda,double2 * tau,double2 * C,int ldc,int * lwork):
    global _hipsolverZunmtr_bufferSize__funptr
    if __init_symbol(&_hipsolverZunmtr_bufferSize__funptr,"hipsolverZunmtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,double2 *,int,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverZunmtr_bufferSize__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverSormtr__funptr = NULL
cdef hipsolverStatus_t hipsolverSormtr(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,float * A,int lda,float * tau,float * C,int ldc,float * work,int lwork,int * devInfo):
    global _hipsolverSormtr__funptr
    if __init_symbol(&_hipsolverSormtr__funptr,"hipsolverSormtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,float *,int,float *,float *,int,float *,int,int *) noexcept nogil> _hipsolverSormtr__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverDormtr__funptr = NULL
cdef hipsolverStatus_t hipsolverDormtr(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,double * A,int lda,double * tau,double * C,int ldc,double * work,int lwork,int * devInfo):
    global _hipsolverDormtr__funptr
    if __init_symbol(&_hipsolverDormtr__funptr,"hipsolverDormtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,double *,int,double *,double *,int,double *,int,int *) noexcept nogil> _hipsolverDormtr__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverCunmtr__funptr = NULL
cdef hipsolverStatus_t hipsolverCunmtr(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,float2 * A,int lda,float2 * tau,float2 * C,int ldc,float2 * work,int lwork,int * devInfo):
    global _hipsolverCunmtr__funptr
    if __init_symbol(&_hipsolverCunmtr__funptr,"hipsolverCunmtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,float2 *,int,float2 *,float2 *,int,float2 *,int,int *) noexcept nogil> _hipsolverCunmtr__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverZunmtr__funptr = NULL
cdef hipsolverStatus_t hipsolverZunmtr(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,double2 * A,int lda,double2 * tau,double2 * C,int ldc,double2 * work,int lwork,int * devInfo):
    global _hipsolverZunmtr__funptr
    if __init_symbol(&_hipsolverZunmtr__funptr,"hipsolverZunmtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,double2 *,int,double2 *,double2 *,int,double2 *,int,int *) noexcept nogil> _hipsolverZunmtr__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverSgebrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSgebrd_bufferSize(void * handle,int m,int n,int * lwork):
    global _hipsolverSgebrd_bufferSize__funptr
    if __init_symbol(&_hipsolverSgebrd_bufferSize__funptr,"hipsolverSgebrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int *) noexcept nogil> _hipsolverSgebrd_bufferSize__funptr)(handle,m,n,lwork)


cdef void* _hipsolverDgebrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDgebrd_bufferSize(void * handle,int m,int n,int * lwork):
    global _hipsolverDgebrd_bufferSize__funptr
    if __init_symbol(&_hipsolverDgebrd_bufferSize__funptr,"hipsolverDgebrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int *) noexcept nogil> _hipsolverDgebrd_bufferSize__funptr)(handle,m,n,lwork)


cdef void* _hipsolverCgebrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCgebrd_bufferSize(void * handle,int m,int n,int * lwork):
    global _hipsolverCgebrd_bufferSize__funptr
    if __init_symbol(&_hipsolverCgebrd_bufferSize__funptr,"hipsolverCgebrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int *) noexcept nogil> _hipsolverCgebrd_bufferSize__funptr)(handle,m,n,lwork)


cdef void* _hipsolverZgebrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZgebrd_bufferSize(void * handle,int m,int n,int * lwork):
    global _hipsolverZgebrd_bufferSize__funptr
    if __init_symbol(&_hipsolverZgebrd_bufferSize__funptr,"hipsolverZgebrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int *) noexcept nogil> _hipsolverZgebrd_bufferSize__funptr)(handle,m,n,lwork)


cdef void* _hipsolverSgebrd__funptr = NULL
cdef hipsolverStatus_t hipsolverSgebrd(void * handle,int m,int n,float * A,int lda,float * D,float * E,float * tauq,float * taup,float * work,int lwork,int * devInfo):
    global _hipsolverSgebrd__funptr
    if __init_symbol(&_hipsolverSgebrd__funptr,"hipsolverSgebrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,float *,float *,float *,float *,float *,int,int *) noexcept nogil> _hipsolverSgebrd__funptr)(handle,m,n,A,lda,D,E,tauq,taup,work,lwork,devInfo)


cdef void* _hipsolverDgebrd__funptr = NULL
cdef hipsolverStatus_t hipsolverDgebrd(void * handle,int m,int n,double * A,int lda,double * D,double * E,double * tauq,double * taup,double * work,int lwork,int * devInfo):
    global _hipsolverDgebrd__funptr
    if __init_symbol(&_hipsolverDgebrd__funptr,"hipsolverDgebrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,double *,double *,double *,double *,double *,int,int *) noexcept nogil> _hipsolverDgebrd__funptr)(handle,m,n,A,lda,D,E,tauq,taup,work,lwork,devInfo)


cdef void* _hipsolverCgebrd__funptr = NULL
cdef hipsolverStatus_t hipsolverCgebrd(void * handle,int m,int n,float2 * A,int lda,float * D,float * E,float2 * tauq,float2 * taup,float2 * work,int lwork,int * devInfo):
    global _hipsolverCgebrd__funptr
    if __init_symbol(&_hipsolverCgebrd__funptr,"hipsolverCgebrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,float *,float *,float2 *,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverCgebrd__funptr)(handle,m,n,A,lda,D,E,tauq,taup,work,lwork,devInfo)


cdef void* _hipsolverZgebrd__funptr = NULL
cdef hipsolverStatus_t hipsolverZgebrd(void * handle,int m,int n,double2 * A,int lda,double * D,double * E,double2 * tauq,double2 * taup,double2 * work,int lwork,int * devInfo):
    global _hipsolverZgebrd__funptr
    if __init_symbol(&_hipsolverZgebrd__funptr,"hipsolverZgebrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,double *,double *,double2 *,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverZgebrd__funptr)(handle,m,n,A,lda,D,E,tauq,taup,work,lwork,devInfo)


cdef void* _hipsolverSSgels_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSSgels_bufferSize(void * handle,int m,int n,int nrhs,float * A,int lda,float * B,int ldb,float * X,int ldx,unsigned long * lwork):
    global _hipsolverSSgels_bufferSize__funptr
    if __init_symbol(&_hipsolverSSgels_bufferSize__funptr,"hipsolverSSgels_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float *,int,float *,int,float *,int,unsigned long *) noexcept nogil> _hipsolverSSgels_bufferSize__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,lwork)


cdef void* _hipsolverDDgels_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDDgels_bufferSize(void * handle,int m,int n,int nrhs,double * A,int lda,double * B,int ldb,double * X,int ldx,unsigned long * lwork):
    global _hipsolverDDgels_bufferSize__funptr
    if __init_symbol(&_hipsolverDDgels_bufferSize__funptr,"hipsolverDDgels_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double *,int,double *,int,double *,int,unsigned long *) noexcept nogil> _hipsolverDDgels_bufferSize__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,lwork)


cdef void* _hipsolverCCgels_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCCgels_bufferSize(void * handle,int m,int n,int nrhs,float2 * A,int lda,float2 * B,int ldb,float2 * X,int ldx,unsigned long * lwork):
    global _hipsolverCCgels_bufferSize__funptr
    if __init_symbol(&_hipsolverCCgels_bufferSize__funptr,"hipsolverCCgels_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float2 *,int,float2 *,int,float2 *,int,unsigned long *) noexcept nogil> _hipsolverCCgels_bufferSize__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,lwork)


cdef void* _hipsolverZZgels_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZZgels_bufferSize(void * handle,int m,int n,int nrhs,double2 * A,int lda,double2 * B,int ldb,double2 * X,int ldx,unsigned long * lwork):
    global _hipsolverZZgels_bufferSize__funptr
    if __init_symbol(&_hipsolverZZgels_bufferSize__funptr,"hipsolverZZgels_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double2 *,int,double2 *,int,double2 *,int,unsigned long *) noexcept nogil> _hipsolverZZgels_bufferSize__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,lwork)


cdef void* _hipsolverSSgels__funptr = NULL
cdef hipsolverStatus_t hipsolverSSgels(void * handle,int m,int n,int nrhs,float * A,int lda,float * B,int ldb,float * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverSSgels__funptr
    if __init_symbol(&_hipsolverSSgels__funptr,"hipsolverSSgels") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float *,int,float *,int,float *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverSSgels__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverDDgels__funptr = NULL
cdef hipsolverStatus_t hipsolverDDgels(void * handle,int m,int n,int nrhs,double * A,int lda,double * B,int ldb,double * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverDDgels__funptr
    if __init_symbol(&_hipsolverDDgels__funptr,"hipsolverDDgels") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double *,int,double *,int,double *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverDDgels__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverCCgels__funptr = NULL
cdef hipsolverStatus_t hipsolverCCgels(void * handle,int m,int n,int nrhs,float2 * A,int lda,float2 * B,int ldb,float2 * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverCCgels__funptr
    if __init_symbol(&_hipsolverCCgels__funptr,"hipsolverCCgels") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float2 *,int,float2 *,int,float2 *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverCCgels__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverZZgels__funptr = NULL
cdef hipsolverStatus_t hipsolverZZgels(void * handle,int m,int n,int nrhs,double2 * A,int lda,double2 * B,int ldb,double2 * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverZZgels__funptr
    if __init_symbol(&_hipsolverZZgels__funptr,"hipsolverZZgels") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double2 *,int,double2 *,int,double2 *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverZZgels__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverSgeqrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSgeqrf_bufferSize(void * handle,int m,int n,float * A,int lda,int * lwork):
    global _hipsolverSgeqrf_bufferSize__funptr
    if __init_symbol(&_hipsolverSgeqrf_bufferSize__funptr,"hipsolverSgeqrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,int *) noexcept nogil> _hipsolverSgeqrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverDgeqrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDgeqrf_bufferSize(void * handle,int m,int n,double * A,int lda,int * lwork):
    global _hipsolverDgeqrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDgeqrf_bufferSize__funptr,"hipsolverDgeqrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,int *) noexcept nogil> _hipsolverDgeqrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverCgeqrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCgeqrf_bufferSize(void * handle,int m,int n,float2 * A,int lda,int * lwork):
    global _hipsolverCgeqrf_bufferSize__funptr
    if __init_symbol(&_hipsolverCgeqrf_bufferSize__funptr,"hipsolverCgeqrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,int *) noexcept nogil> _hipsolverCgeqrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverZgeqrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZgeqrf_bufferSize(void * handle,int m,int n,double2 * A,int lda,int * lwork):
    global _hipsolverZgeqrf_bufferSize__funptr
    if __init_symbol(&_hipsolverZgeqrf_bufferSize__funptr,"hipsolverZgeqrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,int *) noexcept nogil> _hipsolverZgeqrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverSgeqrf__funptr = NULL
cdef hipsolverStatus_t hipsolverSgeqrf(void * handle,int m,int n,float * A,int lda,float * tau,float * work,int lwork,int * devInfo):
    global _hipsolverSgeqrf__funptr
    if __init_symbol(&_hipsolverSgeqrf__funptr,"hipsolverSgeqrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,float *,float *,int,int *) noexcept nogil> _hipsolverSgeqrf__funptr)(handle,m,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDgeqrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDgeqrf(void * handle,int m,int n,double * A,int lda,double * tau,double * work,int lwork,int * devInfo):
    global _hipsolverDgeqrf__funptr
    if __init_symbol(&_hipsolverDgeqrf__funptr,"hipsolverDgeqrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,double *,double *,int,int *) noexcept nogil> _hipsolverDgeqrf__funptr)(handle,m,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverCgeqrf__funptr = NULL
cdef hipsolverStatus_t hipsolverCgeqrf(void * handle,int m,int n,float2 * A,int lda,float2 * tau,float2 * work,int lwork,int * devInfo):
    global _hipsolverCgeqrf__funptr
    if __init_symbol(&_hipsolverCgeqrf__funptr,"hipsolverCgeqrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverCgeqrf__funptr)(handle,m,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverZgeqrf__funptr = NULL
cdef hipsolverStatus_t hipsolverZgeqrf(void * handle,int m,int n,double2 * A,int lda,double2 * tau,double2 * work,int lwork,int * devInfo):
    global _hipsolverZgeqrf__funptr
    if __init_symbol(&_hipsolverZgeqrf__funptr,"hipsolverZgeqrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverZgeqrf__funptr)(handle,m,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverSSgesv_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSSgesv_bufferSize(void * handle,int n,int nrhs,float * A,int lda,int * devIpiv,float * B,int ldb,float * X,int ldx,unsigned long * lwork):
    global _hipsolverSSgesv_bufferSize__funptr
    if __init_symbol(&_hipsolverSSgesv_bufferSize__funptr,"hipsolverSSgesv_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,int *,float *,int,float *,int,unsigned long *) noexcept nogil> _hipsolverSSgesv_bufferSize__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,lwork)


cdef void* _hipsolverDDgesv_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDDgesv_bufferSize(void * handle,int n,int nrhs,double * A,int lda,int * devIpiv,double * B,int ldb,double * X,int ldx,unsigned long * lwork):
    global _hipsolverDDgesv_bufferSize__funptr
    if __init_symbol(&_hipsolverDDgesv_bufferSize__funptr,"hipsolverDDgesv_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,int *,double *,int,double *,int,unsigned long *) noexcept nogil> _hipsolverDDgesv_bufferSize__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,lwork)


cdef void* _hipsolverCCgesv_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCCgesv_bufferSize(void * handle,int n,int nrhs,float2 * A,int lda,int * devIpiv,float2 * B,int ldb,float2 * X,int ldx,unsigned long * lwork):
    global _hipsolverCCgesv_bufferSize__funptr
    if __init_symbol(&_hipsolverCCgesv_bufferSize__funptr,"hipsolverCCgesv_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,int *,float2 *,int,float2 *,int,unsigned long *) noexcept nogil> _hipsolverCCgesv_bufferSize__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,lwork)


cdef void* _hipsolverZZgesv_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZZgesv_bufferSize(void * handle,int n,int nrhs,double2 * A,int lda,int * devIpiv,double2 * B,int ldb,double2 * X,int ldx,unsigned long * lwork):
    global _hipsolverZZgesv_bufferSize__funptr
    if __init_symbol(&_hipsolverZZgesv_bufferSize__funptr,"hipsolverZZgesv_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,int *,double2 *,int,double2 *,int,unsigned long *) noexcept nogil> _hipsolverZZgesv_bufferSize__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,lwork)


cdef void* _hipsolverSSgesv__funptr = NULL
cdef hipsolverStatus_t hipsolverSSgesv(void * handle,int n,int nrhs,float * A,int lda,int * devIpiv,float * B,int ldb,float * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverSSgesv__funptr
    if __init_symbol(&_hipsolverSSgesv__funptr,"hipsolverSSgesv") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,int *,float *,int,float *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverSSgesv__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverDDgesv__funptr = NULL
cdef hipsolverStatus_t hipsolverDDgesv(void * handle,int n,int nrhs,double * A,int lda,int * devIpiv,double * B,int ldb,double * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverDDgesv__funptr
    if __init_symbol(&_hipsolverDDgesv__funptr,"hipsolverDDgesv") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,int *,double *,int,double *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverDDgesv__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverCCgesv__funptr = NULL
cdef hipsolverStatus_t hipsolverCCgesv(void * handle,int n,int nrhs,float2 * A,int lda,int * devIpiv,float2 * B,int ldb,float2 * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverCCgesv__funptr
    if __init_symbol(&_hipsolverCCgesv__funptr,"hipsolverCCgesv") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,int *,float2 *,int,float2 *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverCCgesv__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverZZgesv__funptr = NULL
cdef hipsolverStatus_t hipsolverZZgesv(void * handle,int n,int nrhs,double2 * A,int lda,int * devIpiv,double2 * B,int ldb,double2 * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverZZgesv__funptr
    if __init_symbol(&_hipsolverZZgesv__funptr,"hipsolverZZgesv") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,int *,double2 *,int,double2 *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverZZgesv__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverSgesvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSgesvd_bufferSize(void * handle,signed char jobu,signed char jobv,int m,int n,int * lwork):
    global _hipsolverSgesvd_bufferSize__funptr
    if __init_symbol(&_hipsolverSgesvd_bufferSize__funptr,"hipsolverSgesvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,signed char,signed char,int,int,int *) noexcept nogil> _hipsolverSgesvd_bufferSize__funptr)(handle,jobu,jobv,m,n,lwork)


cdef void* _hipsolverDgesvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDgesvd_bufferSize(void * handle,signed char jobu,signed char jobv,int m,int n,int * lwork):
    global _hipsolverDgesvd_bufferSize__funptr
    if __init_symbol(&_hipsolverDgesvd_bufferSize__funptr,"hipsolverDgesvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,signed char,signed char,int,int,int *) noexcept nogil> _hipsolverDgesvd_bufferSize__funptr)(handle,jobu,jobv,m,n,lwork)


cdef void* _hipsolverCgesvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCgesvd_bufferSize(void * handle,signed char jobu,signed char jobv,int m,int n,int * lwork):
    global _hipsolverCgesvd_bufferSize__funptr
    if __init_symbol(&_hipsolverCgesvd_bufferSize__funptr,"hipsolverCgesvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,signed char,signed char,int,int,int *) noexcept nogil> _hipsolverCgesvd_bufferSize__funptr)(handle,jobu,jobv,m,n,lwork)


cdef void* _hipsolverZgesvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZgesvd_bufferSize(void * handle,signed char jobu,signed char jobv,int m,int n,int * lwork):
    global _hipsolverZgesvd_bufferSize__funptr
    if __init_symbol(&_hipsolverZgesvd_bufferSize__funptr,"hipsolverZgesvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,signed char,signed char,int,int,int *) noexcept nogil> _hipsolverZgesvd_bufferSize__funptr)(handle,jobu,jobv,m,n,lwork)


cdef void* _hipsolverSgesvd__funptr = NULL
cdef hipsolverStatus_t hipsolverSgesvd(void * handle,signed char jobu,signed char jobv,int m,int n,float * A,int lda,float * S,float * U,int ldu,float * V,int ldv,float * work,int lwork,float * rwork,int * devInfo):
    global _hipsolverSgesvd__funptr
    if __init_symbol(&_hipsolverSgesvd__funptr,"hipsolverSgesvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,signed char,signed char,int,int,float *,int,float *,float *,int,float *,int,float *,int,float *,int *) noexcept nogil> _hipsolverSgesvd__funptr)(handle,jobu,jobv,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,rwork,devInfo)


cdef void* _hipsolverDgesvd__funptr = NULL
cdef hipsolverStatus_t hipsolverDgesvd(void * handle,signed char jobu,signed char jobv,int m,int n,double * A,int lda,double * S,double * U,int ldu,double * V,int ldv,double * work,int lwork,double * rwork,int * devInfo):
    global _hipsolverDgesvd__funptr
    if __init_symbol(&_hipsolverDgesvd__funptr,"hipsolverDgesvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,signed char,signed char,int,int,double *,int,double *,double *,int,double *,int,double *,int,double *,int *) noexcept nogil> _hipsolverDgesvd__funptr)(handle,jobu,jobv,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,rwork,devInfo)


cdef void* _hipsolverCgesvd__funptr = NULL
cdef hipsolverStatus_t hipsolverCgesvd(void * handle,signed char jobu,signed char jobv,int m,int n,float2 * A,int lda,float * S,float2 * U,int ldu,float2 * V,int ldv,float2 * work,int lwork,float * rwork,int * devInfo):
    global _hipsolverCgesvd__funptr
    if __init_symbol(&_hipsolverCgesvd__funptr,"hipsolverCgesvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,signed char,signed char,int,int,float2 *,int,float *,float2 *,int,float2 *,int,float2 *,int,float *,int *) noexcept nogil> _hipsolverCgesvd__funptr)(handle,jobu,jobv,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,rwork,devInfo)


cdef void* _hipsolverZgesvd__funptr = NULL
cdef hipsolverStatus_t hipsolverZgesvd(void * handle,signed char jobu,signed char jobv,int m,int n,double2 * A,int lda,double * S,double2 * U,int ldu,double2 * V,int ldv,double2 * work,int lwork,double * rwork,int * devInfo):
    global _hipsolverZgesvd__funptr
    if __init_symbol(&_hipsolverZgesvd__funptr,"hipsolverZgesvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,signed char,signed char,int,int,double2 *,int,double *,double2 *,int,double2 *,int,double2 *,int,double *,int *) noexcept nogil> _hipsolverZgesvd__funptr)(handle,jobu,jobv,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,rwork,devInfo)


cdef void* _hipsolverSgesvdj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSgesvdj_bufferSize(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,const float * A,int lda,const float * S,const float * U,int ldu,const float * V,int ldv,int * lwork,void * params):
    global _hipsolverSgesvdj_bufferSize__funptr
    if __init_symbol(&_hipsolverSgesvdj_bufferSize__funptr,"hipsolverSgesvdj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,const float *,int,const float *,const float *,int,const float *,int,int *,void *) noexcept nogil> _hipsolverSgesvdj_bufferSize__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,lwork,params)


cdef void* _hipsolverDgesvdj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDgesvdj_bufferSize(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,const double * A,int lda,const double * S,const double * U,int ldu,const double * V,int ldv,int * lwork,void * params):
    global _hipsolverDgesvdj_bufferSize__funptr
    if __init_symbol(&_hipsolverDgesvdj_bufferSize__funptr,"hipsolverDgesvdj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,const double *,int,const double *,const double *,int,const double *,int,int *,void *) noexcept nogil> _hipsolverDgesvdj_bufferSize__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,lwork,params)


cdef void* _hipsolverCgesvdj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCgesvdj_bufferSize(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,float2 * A,int lda,const float * S,float2 * U,int ldu,float2 * V,int ldv,int * lwork,void * params):
    global _hipsolverCgesvdj_bufferSize__funptr
    if __init_symbol(&_hipsolverCgesvdj_bufferSize__funptr,"hipsolverCgesvdj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,float2 *,int,const float *,float2 *,int,float2 *,int,int *,void *) noexcept nogil> _hipsolverCgesvdj_bufferSize__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,lwork,params)


cdef void* _hipsolverZgesvdj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZgesvdj_bufferSize(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,double2 * A,int lda,const double * S,double2 * U,int ldu,double2 * V,int ldv,int * lwork,void * params):
    global _hipsolverZgesvdj_bufferSize__funptr
    if __init_symbol(&_hipsolverZgesvdj_bufferSize__funptr,"hipsolverZgesvdj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,double2 *,int,const double *,double2 *,int,double2 *,int,int *,void *) noexcept nogil> _hipsolverZgesvdj_bufferSize__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,lwork,params)


cdef void* _hipsolverSgesvdj__funptr = NULL
cdef hipsolverStatus_t hipsolverSgesvdj(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,float * A,int lda,float * S,float * U,int ldu,float * V,int ldv,float * work,int lwork,int * devInfo,void * params):
    global _hipsolverSgesvdj__funptr
    if __init_symbol(&_hipsolverSgesvdj__funptr,"hipsolverSgesvdj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,float *,int,float *,float *,int,float *,int,float *,int,int *,void *) noexcept nogil> _hipsolverSgesvdj__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params)


cdef void* _hipsolverDgesvdj__funptr = NULL
cdef hipsolverStatus_t hipsolverDgesvdj(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,double * A,int lda,double * S,double * U,int ldu,double * V,int ldv,double * work,int lwork,int * devInfo,void * params):
    global _hipsolverDgesvdj__funptr
    if __init_symbol(&_hipsolverDgesvdj__funptr,"hipsolverDgesvdj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,double *,int,double *,double *,int,double *,int,double *,int,int *,void *) noexcept nogil> _hipsolverDgesvdj__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params)


cdef void* _hipsolverCgesvdj__funptr = NULL
cdef hipsolverStatus_t hipsolverCgesvdj(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,float2 * A,int lda,float * S,float2 * U,int ldu,float2 * V,int ldv,float2 * work,int lwork,int * devInfo,void * params):
    global _hipsolverCgesvdj__funptr
    if __init_symbol(&_hipsolverCgesvdj__funptr,"hipsolverCgesvdj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,float2 *,int,float *,float2 *,int,float2 *,int,float2 *,int,int *,void *) noexcept nogil> _hipsolverCgesvdj__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params)


cdef void* _hipsolverZgesvdj__funptr = NULL
cdef hipsolverStatus_t hipsolverZgesvdj(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,double2 * A,int lda,double * S,double2 * U,int ldu,double2 * V,int ldv,double2 * work,int lwork,int * devInfo,void * params):
    global _hipsolverZgesvdj__funptr
    if __init_symbol(&_hipsolverZgesvdj__funptr,"hipsolverZgesvdj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,double2 *,int,double *,double2 *,int,double2 *,int,double2 *,int,int *,void *) noexcept nogil> _hipsolverZgesvdj__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params)


cdef void* _hipsolverSgesvdjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSgesvdjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,int m,int n,const float * A,int lda,const float * S,const float * U,int ldu,const float * V,int ldv,int * lwork,void * params,int batch_count):
    global _hipsolverSgesvdjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverSgesvdjBatched_bufferSize__funptr,"hipsolverSgesvdjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,const float *,int,const float *,const float *,int,const float *,int,int *,void *,int) noexcept nogil> _hipsolverSgesvdjBatched_bufferSize__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,lwork,params,batch_count)


cdef void* _hipsolverDgesvdjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDgesvdjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,int m,int n,const double * A,int lda,const double * S,const double * U,int ldu,const double * V,int ldv,int * lwork,void * params,int batch_count):
    global _hipsolverDgesvdjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDgesvdjBatched_bufferSize__funptr,"hipsolverDgesvdjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,const double *,int,const double *,const double *,int,const double *,int,int *,void *,int) noexcept nogil> _hipsolverDgesvdjBatched_bufferSize__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,lwork,params,batch_count)


cdef void* _hipsolverCgesvdjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCgesvdjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,int m,int n,float2 * A,int lda,const float * S,float2 * U,int ldu,float2 * V,int ldv,int * lwork,void * params,int batch_count):
    global _hipsolverCgesvdjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverCgesvdjBatched_bufferSize__funptr,"hipsolverCgesvdjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,float2 *,int,const float *,float2 *,int,float2 *,int,int *,void *,int) noexcept nogil> _hipsolverCgesvdjBatched_bufferSize__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,lwork,params,batch_count)


cdef void* _hipsolverZgesvdjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZgesvdjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,int m,int n,double2 * A,int lda,const double * S,double2 * U,int ldu,double2 * V,int ldv,int * lwork,void * params,int batch_count):
    global _hipsolverZgesvdjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverZgesvdjBatched_bufferSize__funptr,"hipsolverZgesvdjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,double2 *,int,const double *,double2 *,int,double2 *,int,int *,void *,int) noexcept nogil> _hipsolverZgesvdjBatched_bufferSize__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,lwork,params,batch_count)


cdef void* _hipsolverSgesvdjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverSgesvdjBatched(void * handle,hipsolverEigMode_t jobz,int m,int n,float * A,int lda,float * S,float * U,int ldu,float * V,int ldv,float * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverSgesvdjBatched__funptr
    if __init_symbol(&_hipsolverSgesvdjBatched__funptr,"hipsolverSgesvdjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,float *,int,float *,float *,int,float *,int,float *,int,int *,void *,int) noexcept nogil> _hipsolverSgesvdjBatched__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverDgesvdjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDgesvdjBatched(void * handle,hipsolverEigMode_t jobz,int m,int n,double * A,int lda,double * S,double * U,int ldu,double * V,int ldv,double * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverDgesvdjBatched__funptr
    if __init_symbol(&_hipsolverDgesvdjBatched__funptr,"hipsolverDgesvdjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,double *,int,double *,double *,int,double *,int,double *,int,int *,void *,int) noexcept nogil> _hipsolverDgesvdjBatched__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverCgesvdjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverCgesvdjBatched(void * handle,hipsolverEigMode_t jobz,int m,int n,float2 * A,int lda,float * S,float2 * U,int ldu,float2 * V,int ldv,float2 * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverCgesvdjBatched__funptr
    if __init_symbol(&_hipsolverCgesvdjBatched__funptr,"hipsolverCgesvdjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,float2 *,int,float *,float2 *,int,float2 *,int,float2 *,int,int *,void *,int) noexcept nogil> _hipsolverCgesvdjBatched__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverZgesvdjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverZgesvdjBatched(void * handle,hipsolverEigMode_t jobz,int m,int n,double2 * A,int lda,double * S,double2 * U,int ldu,double2 * V,int ldv,double2 * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverZgesvdjBatched__funptr
    if __init_symbol(&_hipsolverZgesvdjBatched__funptr,"hipsolverZgesvdjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,double2 *,int,double *,double2 *,int,double2 *,int,double2 *,int,int *,void *,int) noexcept nogil> _hipsolverZgesvdjBatched__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverSgetrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSgetrf_bufferSize(void * handle,int m,int n,float * A,int lda,int * lwork):
    global _hipsolverSgetrf_bufferSize__funptr
    if __init_symbol(&_hipsolverSgetrf_bufferSize__funptr,"hipsolverSgetrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,int *) noexcept nogil> _hipsolverSgetrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverDgetrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDgetrf_bufferSize(void * handle,int m,int n,double * A,int lda,int * lwork):
    global _hipsolverDgetrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDgetrf_bufferSize__funptr,"hipsolverDgetrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,int *) noexcept nogil> _hipsolverDgetrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverCgetrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCgetrf_bufferSize(void * handle,int m,int n,float2 * A,int lda,int * lwork):
    global _hipsolverCgetrf_bufferSize__funptr
    if __init_symbol(&_hipsolverCgetrf_bufferSize__funptr,"hipsolverCgetrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,int *) noexcept nogil> _hipsolverCgetrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverZgetrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZgetrf_bufferSize(void * handle,int m,int n,double2 * A,int lda,int * lwork):
    global _hipsolverZgetrf_bufferSize__funptr
    if __init_symbol(&_hipsolverZgetrf_bufferSize__funptr,"hipsolverZgetrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,int *) noexcept nogil> _hipsolverZgetrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverSgetrf__funptr = NULL
cdef hipsolverStatus_t hipsolverSgetrf(void * handle,int m,int n,float * A,int lda,float * work,int lwork,int * devIpiv,int * devInfo):
    global _hipsolverSgetrf__funptr
    if __init_symbol(&_hipsolverSgetrf__funptr,"hipsolverSgetrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,float *,int,int *,int *) noexcept nogil> _hipsolverSgetrf__funptr)(handle,m,n,A,lda,work,lwork,devIpiv,devInfo)


cdef void* _hipsolverDgetrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDgetrf(void * handle,int m,int n,double * A,int lda,double * work,int lwork,int * devIpiv,int * devInfo):
    global _hipsolverDgetrf__funptr
    if __init_symbol(&_hipsolverDgetrf__funptr,"hipsolverDgetrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,double *,int,int *,int *) noexcept nogil> _hipsolverDgetrf__funptr)(handle,m,n,A,lda,work,lwork,devIpiv,devInfo)


cdef void* _hipsolverCgetrf__funptr = NULL
cdef hipsolverStatus_t hipsolverCgetrf(void * handle,int m,int n,float2 * A,int lda,float2 * work,int lwork,int * devIpiv,int * devInfo):
    global _hipsolverCgetrf__funptr
    if __init_symbol(&_hipsolverCgetrf__funptr,"hipsolverCgetrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,float2 *,int,int *,int *) noexcept nogil> _hipsolverCgetrf__funptr)(handle,m,n,A,lda,work,lwork,devIpiv,devInfo)


cdef void* _hipsolverZgetrf__funptr = NULL
cdef hipsolverStatus_t hipsolverZgetrf(void * handle,int m,int n,double2 * A,int lda,double2 * work,int lwork,int * devIpiv,int * devInfo):
    global _hipsolverZgetrf__funptr
    if __init_symbol(&_hipsolverZgetrf__funptr,"hipsolverZgetrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,double2 *,int,int *,int *) noexcept nogil> _hipsolverZgetrf__funptr)(handle,m,n,A,lda,work,lwork,devIpiv,devInfo)


cdef void* _hipsolverSgetrs_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSgetrs_bufferSize(void * handle,hipblasOperation_t trans,int n,int nrhs,float * A,int lda,int * devIpiv,float * B,int ldb,int * lwork):
    global _hipsolverSgetrs_bufferSize__funptr
    if __init_symbol(&_hipsolverSgetrs_bufferSize__funptr,"hipsolverSgetrs_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasOperation_t,int,int,float *,int,int *,float *,int,int *) noexcept nogil> _hipsolverSgetrs_bufferSize__funptr)(handle,trans,n,nrhs,A,lda,devIpiv,B,ldb,lwork)


cdef void* _hipsolverDgetrs_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDgetrs_bufferSize(void * handle,hipblasOperation_t trans,int n,int nrhs,double * A,int lda,int * devIpiv,double * B,int ldb,int * lwork):
    global _hipsolverDgetrs_bufferSize__funptr
    if __init_symbol(&_hipsolverDgetrs_bufferSize__funptr,"hipsolverDgetrs_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasOperation_t,int,int,double *,int,int *,double *,int,int *) noexcept nogil> _hipsolverDgetrs_bufferSize__funptr)(handle,trans,n,nrhs,A,lda,devIpiv,B,ldb,lwork)


cdef void* _hipsolverCgetrs_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCgetrs_bufferSize(void * handle,hipblasOperation_t trans,int n,int nrhs,float2 * A,int lda,int * devIpiv,float2 * B,int ldb,int * lwork):
    global _hipsolverCgetrs_bufferSize__funptr
    if __init_symbol(&_hipsolverCgetrs_bufferSize__funptr,"hipsolverCgetrs_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasOperation_t,int,int,float2 *,int,int *,float2 *,int,int *) noexcept nogil> _hipsolverCgetrs_bufferSize__funptr)(handle,trans,n,nrhs,A,lda,devIpiv,B,ldb,lwork)


cdef void* _hipsolverZgetrs_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZgetrs_bufferSize(void * handle,hipblasOperation_t trans,int n,int nrhs,double2 * A,int lda,int * devIpiv,double2 * B,int ldb,int * lwork):
    global _hipsolverZgetrs_bufferSize__funptr
    if __init_symbol(&_hipsolverZgetrs_bufferSize__funptr,"hipsolverZgetrs_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasOperation_t,int,int,double2 *,int,int *,double2 *,int,int *) noexcept nogil> _hipsolverZgetrs_bufferSize__funptr)(handle,trans,n,nrhs,A,lda,devIpiv,B,ldb,lwork)


cdef void* _hipsolverSgetrs__funptr = NULL
cdef hipsolverStatus_t hipsolverSgetrs(void * handle,hipblasOperation_t trans,int n,int nrhs,float * A,int lda,int * devIpiv,float * B,int ldb,float * work,int lwork,int * devInfo):
    global _hipsolverSgetrs__funptr
    if __init_symbol(&_hipsolverSgetrs__funptr,"hipsolverSgetrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasOperation_t,int,int,float *,int,int *,float *,int,float *,int,int *) noexcept nogil> _hipsolverSgetrs__funptr)(handle,trans,n,nrhs,A,lda,devIpiv,B,ldb,work,lwork,devInfo)


cdef void* _hipsolverDgetrs__funptr = NULL
cdef hipsolverStatus_t hipsolverDgetrs(void * handle,hipblasOperation_t trans,int n,int nrhs,double * A,int lda,int * devIpiv,double * B,int ldb,double * work,int lwork,int * devInfo):
    global _hipsolverDgetrs__funptr
    if __init_symbol(&_hipsolverDgetrs__funptr,"hipsolverDgetrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasOperation_t,int,int,double *,int,int *,double *,int,double *,int,int *) noexcept nogil> _hipsolverDgetrs__funptr)(handle,trans,n,nrhs,A,lda,devIpiv,B,ldb,work,lwork,devInfo)


cdef void* _hipsolverCgetrs__funptr = NULL
cdef hipsolverStatus_t hipsolverCgetrs(void * handle,hipblasOperation_t trans,int n,int nrhs,float2 * A,int lda,int * devIpiv,float2 * B,int ldb,float2 * work,int lwork,int * devInfo):
    global _hipsolverCgetrs__funptr
    if __init_symbol(&_hipsolverCgetrs__funptr,"hipsolverCgetrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasOperation_t,int,int,float2 *,int,int *,float2 *,int,float2 *,int,int *) noexcept nogil> _hipsolverCgetrs__funptr)(handle,trans,n,nrhs,A,lda,devIpiv,B,ldb,work,lwork,devInfo)


cdef void* _hipsolverZgetrs__funptr = NULL
cdef hipsolverStatus_t hipsolverZgetrs(void * handle,hipblasOperation_t trans,int n,int nrhs,double2 * A,int lda,int * devIpiv,double2 * B,int ldb,double2 * work,int lwork,int * devInfo):
    global _hipsolverZgetrs__funptr
    if __init_symbol(&_hipsolverZgetrs__funptr,"hipsolverZgetrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasOperation_t,int,int,double2 *,int,int *,double2 *,int,double2 *,int,int *) noexcept nogil> _hipsolverZgetrs__funptr)(handle,trans,n,nrhs,A,lda,devIpiv,B,ldb,work,lwork,devInfo)


cdef void* _hipsolverSpotrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSpotrf_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,int * lwork):
    global _hipsolverSpotrf_bufferSize__funptr
    if __init_symbol(&_hipsolverSpotrf_bufferSize__funptr,"hipsolverSpotrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,int *) noexcept nogil> _hipsolverSpotrf_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverDpotrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDpotrf_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,int * lwork):
    global _hipsolverDpotrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDpotrf_bufferSize__funptr,"hipsolverDpotrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,int *) noexcept nogil> _hipsolverDpotrf_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverCpotrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCpotrf_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,int * lwork):
    global _hipsolverCpotrf_bufferSize__funptr
    if __init_symbol(&_hipsolverCpotrf_bufferSize__funptr,"hipsolverCpotrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,int *) noexcept nogil> _hipsolverCpotrf_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverZpotrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZpotrf_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,int * lwork):
    global _hipsolverZpotrf_bufferSize__funptr
    if __init_symbol(&_hipsolverZpotrf_bufferSize__funptr,"hipsolverZpotrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,int *) noexcept nogil> _hipsolverZpotrf_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverSpotrf__funptr = NULL
cdef hipsolverStatus_t hipsolverSpotrf(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,float * work,int lwork,int * devInfo):
    global _hipsolverSpotrf__funptr
    if __init_symbol(&_hipsolverSpotrf__funptr,"hipsolverSpotrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,float *,int,int *) noexcept nogil> _hipsolverSpotrf__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverDpotrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDpotrf(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,double * work,int lwork,int * devInfo):
    global _hipsolverDpotrf__funptr
    if __init_symbol(&_hipsolverDpotrf__funptr,"hipsolverDpotrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,double *,int,int *) noexcept nogil> _hipsolverDpotrf__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverCpotrf__funptr = NULL
cdef hipsolverStatus_t hipsolverCpotrf(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * work,int lwork,int * devInfo):
    global _hipsolverCpotrf__funptr
    if __init_symbol(&_hipsolverCpotrf__funptr,"hipsolverCpotrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,float2 *,int,int *) noexcept nogil> _hipsolverCpotrf__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverZpotrf__funptr = NULL
cdef hipsolverStatus_t hipsolverZpotrf(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * work,int lwork,int * devInfo):
    global _hipsolverZpotrf__funptr
    if __init_symbol(&_hipsolverZpotrf__funptr,"hipsolverZpotrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,double2 *,int,int *) noexcept nogil> _hipsolverZpotrf__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverSpotrfBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSpotrfBatched_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float ** A,int lda,int * lwork,int batch_count):
    global _hipsolverSpotrfBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverSpotrfBatched_bufferSize__funptr,"hipsolverSpotrfBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float **,int,int *,int) noexcept nogil> _hipsolverSpotrfBatched_bufferSize__funptr)(handle,uplo,n,A,lda,lwork,batch_count)


cdef void* _hipsolverDpotrfBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDpotrfBatched_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double ** A,int lda,int * lwork,int batch_count):
    global _hipsolverDpotrfBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDpotrfBatched_bufferSize__funptr,"hipsolverDpotrfBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double **,int,int *,int) noexcept nogil> _hipsolverDpotrfBatched_bufferSize__funptr)(handle,uplo,n,A,lda,lwork,batch_count)


cdef void* _hipsolverCpotrfBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCpotrfBatched_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float2 ** A,int lda,int * lwork,int batch_count):
    global _hipsolverCpotrfBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverCpotrfBatched_bufferSize__funptr,"hipsolverCpotrfBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 **,int,int *,int) noexcept nogil> _hipsolverCpotrfBatched_bufferSize__funptr)(handle,uplo,n,A,lda,lwork,batch_count)


cdef void* _hipsolverZpotrfBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZpotrfBatched_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double2 ** A,int lda,int * lwork,int batch_count):
    global _hipsolverZpotrfBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverZpotrfBatched_bufferSize__funptr,"hipsolverZpotrfBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 **,int,int *,int) noexcept nogil> _hipsolverZpotrfBatched_bufferSize__funptr)(handle,uplo,n,A,lda,lwork,batch_count)


cdef void* _hipsolverSpotrfBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverSpotrfBatched(void * handle,hipblasFillMode_t uplo,int n,float ** A,int lda,float * work,int lwork,int * devInfo,int batch_count):
    global _hipsolverSpotrfBatched__funptr
    if __init_symbol(&_hipsolverSpotrfBatched__funptr,"hipsolverSpotrfBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float **,int,float *,int,int *,int) noexcept nogil> _hipsolverSpotrfBatched__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo,batch_count)


cdef void* _hipsolverDpotrfBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDpotrfBatched(void * handle,hipblasFillMode_t uplo,int n,double ** A,int lda,double * work,int lwork,int * devInfo,int batch_count):
    global _hipsolverDpotrfBatched__funptr
    if __init_symbol(&_hipsolverDpotrfBatched__funptr,"hipsolverDpotrfBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double **,int,double *,int,int *,int) noexcept nogil> _hipsolverDpotrfBatched__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo,batch_count)


cdef void* _hipsolverCpotrfBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverCpotrfBatched(void * handle,hipblasFillMode_t uplo,int n,float2 ** A,int lda,float2 * work,int lwork,int * devInfo,int batch_count):
    global _hipsolverCpotrfBatched__funptr
    if __init_symbol(&_hipsolverCpotrfBatched__funptr,"hipsolverCpotrfBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 **,int,float2 *,int,int *,int) noexcept nogil> _hipsolverCpotrfBatched__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo,batch_count)


cdef void* _hipsolverZpotrfBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverZpotrfBatched(void * handle,hipblasFillMode_t uplo,int n,double2 ** A,int lda,double2 * work,int lwork,int * devInfo,int batch_count):
    global _hipsolverZpotrfBatched__funptr
    if __init_symbol(&_hipsolverZpotrfBatched__funptr,"hipsolverZpotrfBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 **,int,double2 *,int,int *,int) noexcept nogil> _hipsolverZpotrfBatched__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo,batch_count)


cdef void* _hipsolverSpotri_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSpotri_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,int * lwork):
    global _hipsolverSpotri_bufferSize__funptr
    if __init_symbol(&_hipsolverSpotri_bufferSize__funptr,"hipsolverSpotri_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,int *) noexcept nogil> _hipsolverSpotri_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverDpotri_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDpotri_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,int * lwork):
    global _hipsolverDpotri_bufferSize__funptr
    if __init_symbol(&_hipsolverDpotri_bufferSize__funptr,"hipsolverDpotri_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,int *) noexcept nogil> _hipsolverDpotri_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverCpotri_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCpotri_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,int * lwork):
    global _hipsolverCpotri_bufferSize__funptr
    if __init_symbol(&_hipsolverCpotri_bufferSize__funptr,"hipsolverCpotri_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,int *) noexcept nogil> _hipsolverCpotri_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverZpotri_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZpotri_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,int * lwork):
    global _hipsolverZpotri_bufferSize__funptr
    if __init_symbol(&_hipsolverZpotri_bufferSize__funptr,"hipsolverZpotri_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,int *) noexcept nogil> _hipsolverZpotri_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverSpotri__funptr = NULL
cdef hipsolverStatus_t hipsolverSpotri(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,float * work,int lwork,int * devInfo):
    global _hipsolverSpotri__funptr
    if __init_symbol(&_hipsolverSpotri__funptr,"hipsolverSpotri") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,float *,int,int *) noexcept nogil> _hipsolverSpotri__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverDpotri__funptr = NULL
cdef hipsolverStatus_t hipsolverDpotri(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,double * work,int lwork,int * devInfo):
    global _hipsolverDpotri__funptr
    if __init_symbol(&_hipsolverDpotri__funptr,"hipsolverDpotri") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,double *,int,int *) noexcept nogil> _hipsolverDpotri__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverCpotri__funptr = NULL
cdef hipsolverStatus_t hipsolverCpotri(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * work,int lwork,int * devInfo):
    global _hipsolverCpotri__funptr
    if __init_symbol(&_hipsolverCpotri__funptr,"hipsolverCpotri") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,float2 *,int,int *) noexcept nogil> _hipsolverCpotri__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverZpotri__funptr = NULL
cdef hipsolverStatus_t hipsolverZpotri(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * work,int lwork,int * devInfo):
    global _hipsolverZpotri__funptr
    if __init_symbol(&_hipsolverZpotri__funptr,"hipsolverZpotri") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,double2 *,int,int *) noexcept nogil> _hipsolverZpotri__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverSpotrs_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSpotrs_bufferSize(void * handle,hipblasFillMode_t uplo,int n,int nrhs,float * A,int lda,float * B,int ldb,int * lwork):
    global _hipsolverSpotrs_bufferSize__funptr
    if __init_symbol(&_hipsolverSpotrs_bufferSize__funptr,"hipsolverSpotrs_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,float *,int,float *,int,int *) noexcept nogil> _hipsolverSpotrs_bufferSize__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,lwork)


cdef void* _hipsolverDpotrs_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDpotrs_bufferSize(void * handle,hipblasFillMode_t uplo,int n,int nrhs,double * A,int lda,double * B,int ldb,int * lwork):
    global _hipsolverDpotrs_bufferSize__funptr
    if __init_symbol(&_hipsolverDpotrs_bufferSize__funptr,"hipsolverDpotrs_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,double *,int,double *,int,int *) noexcept nogil> _hipsolverDpotrs_bufferSize__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,lwork)


cdef void* _hipsolverCpotrs_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCpotrs_bufferSize(void * handle,hipblasFillMode_t uplo,int n,int nrhs,float2 * A,int lda,float2 * B,int ldb,int * lwork):
    global _hipsolverCpotrs_bufferSize__funptr
    if __init_symbol(&_hipsolverCpotrs_bufferSize__funptr,"hipsolverCpotrs_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,float2 *,int,float2 *,int,int *) noexcept nogil> _hipsolverCpotrs_bufferSize__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,lwork)


cdef void* _hipsolverZpotrs_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZpotrs_bufferSize(void * handle,hipblasFillMode_t uplo,int n,int nrhs,double2 * A,int lda,double2 * B,int ldb,int * lwork):
    global _hipsolverZpotrs_bufferSize__funptr
    if __init_symbol(&_hipsolverZpotrs_bufferSize__funptr,"hipsolverZpotrs_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,double2 *,int,double2 *,int,int *) noexcept nogil> _hipsolverZpotrs_bufferSize__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,lwork)


cdef void* _hipsolverSpotrs__funptr = NULL
cdef hipsolverStatus_t hipsolverSpotrs(void * handle,hipblasFillMode_t uplo,int n,int nrhs,float * A,int lda,float * B,int ldb,float * work,int lwork,int * devInfo):
    global _hipsolverSpotrs__funptr
    if __init_symbol(&_hipsolverSpotrs__funptr,"hipsolverSpotrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,float *,int,float *,int,float *,int,int *) noexcept nogil> _hipsolverSpotrs__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,work,lwork,devInfo)


cdef void* _hipsolverDpotrs__funptr = NULL
cdef hipsolverStatus_t hipsolverDpotrs(void * handle,hipblasFillMode_t uplo,int n,int nrhs,double * A,int lda,double * B,int ldb,double * work,int lwork,int * devInfo):
    global _hipsolverDpotrs__funptr
    if __init_symbol(&_hipsolverDpotrs__funptr,"hipsolverDpotrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,double *,int,double *,int,double *,int,int *) noexcept nogil> _hipsolverDpotrs__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,work,lwork,devInfo)


cdef void* _hipsolverCpotrs__funptr = NULL
cdef hipsolverStatus_t hipsolverCpotrs(void * handle,hipblasFillMode_t uplo,int n,int nrhs,float2 * A,int lda,float2 * B,int ldb,float2 * work,int lwork,int * devInfo):
    global _hipsolverCpotrs__funptr
    if __init_symbol(&_hipsolverCpotrs__funptr,"hipsolverCpotrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,float2 *,int,float2 *,int,float2 *,int,int *) noexcept nogil> _hipsolverCpotrs__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,work,lwork,devInfo)


cdef void* _hipsolverZpotrs__funptr = NULL
cdef hipsolverStatus_t hipsolverZpotrs(void * handle,hipblasFillMode_t uplo,int n,int nrhs,double2 * A,int lda,double2 * B,int ldb,double2 * work,int lwork,int * devInfo):
    global _hipsolverZpotrs__funptr
    if __init_symbol(&_hipsolverZpotrs__funptr,"hipsolverZpotrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,double2 *,int,double2 *,int,double2 *,int,int *) noexcept nogil> _hipsolverZpotrs__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,work,lwork,devInfo)


cdef void* _hipsolverSpotrsBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSpotrsBatched_bufferSize(void * handle,hipblasFillMode_t uplo,int n,int nrhs,float ** A,int lda,float ** B,int ldb,int * lwork,int batch_count):
    global _hipsolverSpotrsBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverSpotrsBatched_bufferSize__funptr,"hipsolverSpotrsBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,float **,int,float **,int,int *,int) noexcept nogil> _hipsolverSpotrsBatched_bufferSize__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,lwork,batch_count)


cdef void* _hipsolverDpotrsBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDpotrsBatched_bufferSize(void * handle,hipblasFillMode_t uplo,int n,int nrhs,double ** A,int lda,double ** B,int ldb,int * lwork,int batch_count):
    global _hipsolverDpotrsBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDpotrsBatched_bufferSize__funptr,"hipsolverDpotrsBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,double **,int,double **,int,int *,int) noexcept nogil> _hipsolverDpotrsBatched_bufferSize__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,lwork,batch_count)


cdef void* _hipsolverCpotrsBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCpotrsBatched_bufferSize(void * handle,hipblasFillMode_t uplo,int n,int nrhs,float2 ** A,int lda,float2 ** B,int ldb,int * lwork,int batch_count):
    global _hipsolverCpotrsBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverCpotrsBatched_bufferSize__funptr,"hipsolverCpotrsBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,float2 **,int,float2 **,int,int *,int) noexcept nogil> _hipsolverCpotrsBatched_bufferSize__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,lwork,batch_count)


cdef void* _hipsolverZpotrsBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZpotrsBatched_bufferSize(void * handle,hipblasFillMode_t uplo,int n,int nrhs,double2 ** A,int lda,double2 ** B,int ldb,int * lwork,int batch_count):
    global _hipsolverZpotrsBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverZpotrsBatched_bufferSize__funptr,"hipsolverZpotrsBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,double2 **,int,double2 **,int,int *,int) noexcept nogil> _hipsolverZpotrsBatched_bufferSize__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,lwork,batch_count)


cdef void* _hipsolverSpotrsBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverSpotrsBatched(void * handle,hipblasFillMode_t uplo,int n,int nrhs,float ** A,int lda,float ** B,int ldb,float * work,int lwork,int * devInfo,int batch_count):
    global _hipsolverSpotrsBatched__funptr
    if __init_symbol(&_hipsolverSpotrsBatched__funptr,"hipsolverSpotrsBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,float **,int,float **,int,float *,int,int *,int) noexcept nogil> _hipsolverSpotrsBatched__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,work,lwork,devInfo,batch_count)


cdef void* _hipsolverDpotrsBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDpotrsBatched(void * handle,hipblasFillMode_t uplo,int n,int nrhs,double ** A,int lda,double ** B,int ldb,double * work,int lwork,int * devInfo,int batch_count):
    global _hipsolverDpotrsBatched__funptr
    if __init_symbol(&_hipsolverDpotrsBatched__funptr,"hipsolverDpotrsBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,double **,int,double **,int,double *,int,int *,int) noexcept nogil> _hipsolverDpotrsBatched__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,work,lwork,devInfo,batch_count)


cdef void* _hipsolverCpotrsBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverCpotrsBatched(void * handle,hipblasFillMode_t uplo,int n,int nrhs,float2 ** A,int lda,float2 ** B,int ldb,float2 * work,int lwork,int * devInfo,int batch_count):
    global _hipsolverCpotrsBatched__funptr
    if __init_symbol(&_hipsolverCpotrsBatched__funptr,"hipsolverCpotrsBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,float2 **,int,float2 **,int,float2 *,int,int *,int) noexcept nogil> _hipsolverCpotrsBatched__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,work,lwork,devInfo,batch_count)


cdef void* _hipsolverZpotrsBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverZpotrsBatched(void * handle,hipblasFillMode_t uplo,int n,int nrhs,double2 ** A,int lda,double2 ** B,int ldb,double2 * work,int lwork,int * devInfo,int batch_count):
    global _hipsolverZpotrsBatched__funptr
    if __init_symbol(&_hipsolverZpotrsBatched__funptr,"hipsolverZpotrsBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,double2 **,int,double2 **,int,double2 *,int,int *,int) noexcept nogil> _hipsolverZpotrsBatched__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,work,lwork,devInfo,batch_count)


cdef void* _hipsolverSsyevd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSsyevd_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * D,int * lwork):
    global _hipsolverSsyevd_bufferSize__funptr
    if __init_symbol(&_hipsolverSsyevd_bufferSize__funptr,"hipsolverSsyevd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,int *) noexcept nogil> _hipsolverSsyevd_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,D,lwork)


cdef void* _hipsolverDsyevd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDsyevd_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * D,int * lwork):
    global _hipsolverDsyevd_bufferSize__funptr
    if __init_symbol(&_hipsolverDsyevd_bufferSize__funptr,"hipsolverDsyevd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,int *) noexcept nogil> _hipsolverDsyevd_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,D,lwork)


cdef void* _hipsolverCheevd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCheevd_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float * D,int * lwork):
    global _hipsolverCheevd_bufferSize__funptr
    if __init_symbol(&_hipsolverCheevd_bufferSize__funptr,"hipsolverCheevd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float *,int *) noexcept nogil> _hipsolverCheevd_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,D,lwork)


cdef void* _hipsolverZheevd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZheevd_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double * D,int * lwork):
    global _hipsolverZheevd_bufferSize__funptr
    if __init_symbol(&_hipsolverZheevd_bufferSize__funptr,"hipsolverZheevd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double *,int *) noexcept nogil> _hipsolverZheevd_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,D,lwork)


cdef void* _hipsolverSsyevd__funptr = NULL
cdef hipsolverStatus_t hipsolverSsyevd(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * D,float * work,int lwork,int * devInfo):
    global _hipsolverSsyevd__funptr
    if __init_symbol(&_hipsolverSsyevd__funptr,"hipsolverSsyevd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,float *,int,int *) noexcept nogil> _hipsolverSsyevd__funptr)(handle,jobz,uplo,n,A,lda,D,work,lwork,devInfo)


cdef void* _hipsolverDsyevd__funptr = NULL
cdef hipsolverStatus_t hipsolverDsyevd(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * D,double * work,int lwork,int * devInfo):
    global _hipsolverDsyevd__funptr
    if __init_symbol(&_hipsolverDsyevd__funptr,"hipsolverDsyevd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,double *,int,int *) noexcept nogil> _hipsolverDsyevd__funptr)(handle,jobz,uplo,n,A,lda,D,work,lwork,devInfo)


cdef void* _hipsolverCheevd__funptr = NULL
cdef hipsolverStatus_t hipsolverCheevd(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float * D,float2 * work,int lwork,int * devInfo):
    global _hipsolverCheevd__funptr
    if __init_symbol(&_hipsolverCheevd__funptr,"hipsolverCheevd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float *,float2 *,int,int *) noexcept nogil> _hipsolverCheevd__funptr)(handle,jobz,uplo,n,A,lda,D,work,lwork,devInfo)


cdef void* _hipsolverZheevd__funptr = NULL
cdef hipsolverStatus_t hipsolverZheevd(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double * D,double2 * work,int lwork,int * devInfo):
    global _hipsolverZheevd__funptr
    if __init_symbol(&_hipsolverZheevd__funptr,"hipsolverZheevd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double *,double2 *,int,int *) noexcept nogil> _hipsolverZheevd__funptr)(handle,jobz,uplo,n,A,lda,D,work,lwork,devInfo)


cdef void* _hipsolverSsyevdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSsyevdx_bufferSize(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,const float * A,int lda,float vl,float vu,int il,int iu,int * nev,const float * W,int * lwork):
    global _hipsolverSsyevdx_bufferSize__funptr
    if __init_symbol(&_hipsolverSsyevdx_bufferSize__funptr,"hipsolverSsyevdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,const float *,int,float,float,int,int,int *,const float *,int *) noexcept nogil> _hipsolverSsyevdx_bufferSize__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverDsyevdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDsyevdx_bufferSize(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,const double * A,int lda,double vl,double vu,int il,int iu,int * nev,const double * W,int * lwork):
    global _hipsolverDsyevdx_bufferSize__funptr
    if __init_symbol(&_hipsolverDsyevdx_bufferSize__funptr,"hipsolverDsyevdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,const double *,int,double,double,int,int,int *,const double *,int *) noexcept nogil> _hipsolverDsyevdx_bufferSize__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverCheevdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCheevdx_bufferSize(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,float2 * A,int lda,float vl,float vu,int il,int iu,int * nev,const float * W,int * lwork):
    global _hipsolverCheevdx_bufferSize__funptr
    if __init_symbol(&_hipsolverCheevdx_bufferSize__funptr,"hipsolverCheevdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,float2 *,int,float,float,int,int,int *,const float *,int *) noexcept nogil> _hipsolverCheevdx_bufferSize__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverZheevdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZheevdx_bufferSize(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,double2 * A,int lda,double vl,double vu,int il,int iu,int * nev,const double * W,int * lwork):
    global _hipsolverZheevdx_bufferSize__funptr
    if __init_symbol(&_hipsolverZheevdx_bufferSize__funptr,"hipsolverZheevdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,double2 *,int,double,double,int,int,int *,const double *,int *) noexcept nogil> _hipsolverZheevdx_bufferSize__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverSsyevdx__funptr = NULL
cdef hipsolverStatus_t hipsolverSsyevdx(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,float * A,int lda,float vl,float vu,int il,int iu,int * nev,float * W,float * work,int lwork,int * devInfo):
    global _hipsolverSsyevdx__funptr
    if __init_symbol(&_hipsolverSsyevdx__funptr,"hipsolverSsyevdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,float *,int,float,float,int,int,int *,float *,float *,int,int *) noexcept nogil> _hipsolverSsyevdx__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverDsyevdx__funptr = NULL
cdef hipsolverStatus_t hipsolverDsyevdx(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,double * A,int lda,double vl,double vu,int il,int iu,int * nev,double * W,double * work,int lwork,int * devInfo):
    global _hipsolverDsyevdx__funptr
    if __init_symbol(&_hipsolverDsyevdx__funptr,"hipsolverDsyevdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,double *,int,double,double,int,int,int *,double *,double *,int,int *) noexcept nogil> _hipsolverDsyevdx__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverCheevdx__funptr = NULL
cdef hipsolverStatus_t hipsolverCheevdx(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,float2 * A,int lda,float vl,float vu,int il,int iu,int * nev,float * W,float2 * work,int lwork,int * devInfo):
    global _hipsolverCheevdx__funptr
    if __init_symbol(&_hipsolverCheevdx__funptr,"hipsolverCheevdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,float2 *,int,float,float,int,int,int *,float *,float2 *,int,int *) noexcept nogil> _hipsolverCheevdx__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverZheevdx__funptr = NULL
cdef hipsolverStatus_t hipsolverZheevdx(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,double2 * A,int lda,double vl,double vu,int il,int iu,int * nev,double * W,double2 * work,int lwork,int * devInfo):
    global _hipsolverZheevdx__funptr
    if __init_symbol(&_hipsolverZheevdx__funptr,"hipsolverZheevdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,double2 *,int,double,double,int,int,int *,double *,double2 *,int,int *) noexcept nogil> _hipsolverZheevdx__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverSsyevj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSsyevj_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * W,int * lwork,void * params):
    global _hipsolverSsyevj_bufferSize__funptr
    if __init_symbol(&_hipsolverSsyevj_bufferSize__funptr,"hipsolverSsyevj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,int *,void *) noexcept nogil> _hipsolverSsyevj_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params)


cdef void* _hipsolverDsyevj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDsyevj_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * W,int * lwork,void * params):
    global _hipsolverDsyevj_bufferSize__funptr
    if __init_symbol(&_hipsolverDsyevj_bufferSize__funptr,"hipsolverDsyevj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,int *,void *) noexcept nogil> _hipsolverDsyevj_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params)


cdef void* _hipsolverCheevj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCheevj_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float * W,int * lwork,void * params):
    global _hipsolverCheevj_bufferSize__funptr
    if __init_symbol(&_hipsolverCheevj_bufferSize__funptr,"hipsolverCheevj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float *,int *,void *) noexcept nogil> _hipsolverCheevj_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params)


cdef void* _hipsolverZheevj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZheevj_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double * W,int * lwork,void * params):
    global _hipsolverZheevj_bufferSize__funptr
    if __init_symbol(&_hipsolverZheevj_bufferSize__funptr,"hipsolverZheevj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double *,int *,void *) noexcept nogil> _hipsolverZheevj_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params)


cdef void* _hipsolverSsyevj__funptr = NULL
cdef hipsolverStatus_t hipsolverSsyevj(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * W,float * work,int lwork,int * devInfo,void * params):
    global _hipsolverSsyevj__funptr
    if __init_symbol(&_hipsolverSsyevj__funptr,"hipsolverSsyevj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,float *,int,int *,void *) noexcept nogil> _hipsolverSsyevj__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params)


cdef void* _hipsolverDsyevj__funptr = NULL
cdef hipsolverStatus_t hipsolverDsyevj(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * W,double * work,int lwork,int * devInfo,void * params):
    global _hipsolverDsyevj__funptr
    if __init_symbol(&_hipsolverDsyevj__funptr,"hipsolverDsyevj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,double *,int,int *,void *) noexcept nogil> _hipsolverDsyevj__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params)


cdef void* _hipsolverCheevj__funptr = NULL
cdef hipsolverStatus_t hipsolverCheevj(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float * W,float2 * work,int lwork,int * devInfo,void * params):
    global _hipsolverCheevj__funptr
    if __init_symbol(&_hipsolverCheevj__funptr,"hipsolverCheevj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float *,float2 *,int,int *,void *) noexcept nogil> _hipsolverCheevj__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params)


cdef void* _hipsolverZheevj__funptr = NULL
cdef hipsolverStatus_t hipsolverZheevj(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double * W,double2 * work,int lwork,int * devInfo,void * params):
    global _hipsolverZheevj__funptr
    if __init_symbol(&_hipsolverZheevj__funptr,"hipsolverZheevj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double *,double2 *,int,int *,void *) noexcept nogil> _hipsolverZheevj__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params)


cdef void* _hipsolverSsyevjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSsyevjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * W,int * lwork,void * params,int batch_count):
    global _hipsolverSsyevjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverSsyevjBatched_bufferSize__funptr,"hipsolverSsyevjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,int *,void *,int) noexcept nogil> _hipsolverSsyevjBatched_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params,batch_count)


cdef void* _hipsolverDsyevjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDsyevjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * W,int * lwork,void * params,int batch_count):
    global _hipsolverDsyevjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDsyevjBatched_bufferSize__funptr,"hipsolverDsyevjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,int *,void *,int) noexcept nogil> _hipsolverDsyevjBatched_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params,batch_count)


cdef void* _hipsolverCheevjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCheevjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float * W,int * lwork,void * params,int batch_count):
    global _hipsolverCheevjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverCheevjBatched_bufferSize__funptr,"hipsolverCheevjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float *,int *,void *,int) noexcept nogil> _hipsolverCheevjBatched_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params,batch_count)


cdef void* _hipsolverZheevjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZheevjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double * W,int * lwork,void * params,int batch_count):
    global _hipsolverZheevjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverZheevjBatched_bufferSize__funptr,"hipsolverZheevjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double *,int *,void *,int) noexcept nogil> _hipsolverZheevjBatched_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params,batch_count)


cdef void* _hipsolverSsyevjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverSsyevjBatched(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * W,float * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverSsyevjBatched__funptr
    if __init_symbol(&_hipsolverSsyevjBatched__funptr,"hipsolverSsyevjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,float *,int,int *,void *,int) noexcept nogil> _hipsolverSsyevjBatched__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverDsyevjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDsyevjBatched(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * W,double * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverDsyevjBatched__funptr
    if __init_symbol(&_hipsolverDsyevjBatched__funptr,"hipsolverDsyevjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,double *,int,int *,void *,int) noexcept nogil> _hipsolverDsyevjBatched__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverCheevjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverCheevjBatched(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float * W,float2 * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverCheevjBatched__funptr
    if __init_symbol(&_hipsolverCheevjBatched__funptr,"hipsolverCheevjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float *,float2 *,int,int *,void *,int) noexcept nogil> _hipsolverCheevjBatched__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverZheevjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverZheevjBatched(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double * W,double2 * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverZheevjBatched__funptr
    if __init_symbol(&_hipsolverZheevjBatched__funptr,"hipsolverZheevjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double *,double2 *,int,int *,void *,int) noexcept nogil> _hipsolverZheevjBatched__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverSsygvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSsygvd_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * B,int ldb,float * W,int * lwork):
    global _hipsolverSsygvd_bufferSize__funptr
    if __init_symbol(&_hipsolverSsygvd_bufferSize__funptr,"hipsolverSsygvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,int,float *,int *) noexcept nogil> _hipsolverSsygvd_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork)


cdef void* _hipsolverDsygvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDsygvd_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * B,int ldb,double * W,int * lwork):
    global _hipsolverDsygvd_bufferSize__funptr
    if __init_symbol(&_hipsolverDsygvd_bufferSize__funptr,"hipsolverDsygvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,int,double *,int *) noexcept nogil> _hipsolverDsygvd_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork)


cdef void* _hipsolverChegvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverChegvd_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * B,int ldb,float * W,int * lwork):
    global _hipsolverChegvd_bufferSize__funptr
    if __init_symbol(&_hipsolverChegvd_bufferSize__funptr,"hipsolverChegvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float2 *,int,float *,int *) noexcept nogil> _hipsolverChegvd_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork)


cdef void* _hipsolverZhegvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZhegvd_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * B,int ldb,double * W,int * lwork):
    global _hipsolverZhegvd_bufferSize__funptr
    if __init_symbol(&_hipsolverZhegvd_bufferSize__funptr,"hipsolverZhegvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double2 *,int,double *,int *) noexcept nogil> _hipsolverZhegvd_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork)


cdef void* _hipsolverSsygvd__funptr = NULL
cdef hipsolverStatus_t hipsolverSsygvd(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * B,int ldb,float * W,float * work,int lwork,int * devInfo):
    global _hipsolverSsygvd__funptr
    if __init_symbol(&_hipsolverSsygvd__funptr,"hipsolverSsygvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,int,float *,float *,int,int *) noexcept nogil> _hipsolverSsygvd__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo)


cdef void* _hipsolverDsygvd__funptr = NULL
cdef hipsolverStatus_t hipsolverDsygvd(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * B,int ldb,double * W,double * work,int lwork,int * devInfo):
    global _hipsolverDsygvd__funptr
    if __init_symbol(&_hipsolverDsygvd__funptr,"hipsolverDsygvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,int,double *,double *,int,int *) noexcept nogil> _hipsolverDsygvd__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo)


cdef void* _hipsolverChegvd__funptr = NULL
cdef hipsolverStatus_t hipsolverChegvd(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * B,int ldb,float * W,float2 * work,int lwork,int * devInfo):
    global _hipsolverChegvd__funptr
    if __init_symbol(&_hipsolverChegvd__funptr,"hipsolverChegvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float2 *,int,float *,float2 *,int,int *) noexcept nogil> _hipsolverChegvd__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo)


cdef void* _hipsolverZhegvd__funptr = NULL
cdef hipsolverStatus_t hipsolverZhegvd(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * B,int ldb,double * W,double2 * work,int lwork,int * devInfo):
    global _hipsolverZhegvd__funptr
    if __init_symbol(&_hipsolverZhegvd__funptr,"hipsolverZhegvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double2 *,int,double *,double2 *,int,int *) noexcept nogil> _hipsolverZhegvd__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo)


cdef void* _hipsolverSsygvdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSsygvdx_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,const float * A,int lda,const float * B,int ldb,float vl,float vu,int il,int iu,int * nev,const float * W,int * lwork):
    global _hipsolverSsygvdx_bufferSize__funptr
    if __init_symbol(&_hipsolverSsygvdx_bufferSize__funptr,"hipsolverSsygvdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,const float *,int,const float *,int,float,float,int,int,int *,const float *,int *) noexcept nogil> _hipsolverSsygvdx_bufferSize__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverDsygvdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDsygvdx_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,const double * A,int lda,const double * B,int ldb,double vl,double vu,int il,int iu,int * nev,const double * W,int * lwork):
    global _hipsolverDsygvdx_bufferSize__funptr
    if __init_symbol(&_hipsolverDsygvdx_bufferSize__funptr,"hipsolverDsygvdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,const double *,int,const double *,int,double,double,int,int,int *,const double *,int *) noexcept nogil> _hipsolverDsygvdx_bufferSize__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverChegvdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverChegvdx_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * B,int ldb,float vl,float vu,int il,int iu,int * nev,const float * W,int * lwork):
    global _hipsolverChegvdx_bufferSize__funptr
    if __init_symbol(&_hipsolverChegvdx_bufferSize__funptr,"hipsolverChegvdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,float2 *,int,float2 *,int,float,float,int,int,int *,const float *,int *) noexcept nogil> _hipsolverChegvdx_bufferSize__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverZhegvdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZhegvdx_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * B,int ldb,double vl,double vu,int il,int iu,int * nev,const double * W,int * lwork):
    global _hipsolverZhegvdx_bufferSize__funptr
    if __init_symbol(&_hipsolverZhegvdx_bufferSize__funptr,"hipsolverZhegvdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,double2 *,int,double2 *,int,double,double,int,int,int *,const double *,int *) noexcept nogil> _hipsolverZhegvdx_bufferSize__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverSsygvdx__funptr = NULL
cdef hipsolverStatus_t hipsolverSsygvdx(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,float * A,int lda,float * B,int ldb,float vl,float vu,int il,int iu,int * nev,float * W,float * work,int lwork,int * devInfo):
    global _hipsolverSsygvdx__funptr
    if __init_symbol(&_hipsolverSsygvdx__funptr,"hipsolverSsygvdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,float *,int,float *,int,float,float,int,int,int *,float *,float *,int,int *) noexcept nogil> _hipsolverSsygvdx__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverDsygvdx__funptr = NULL
cdef hipsolverStatus_t hipsolverDsygvdx(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,double * A,int lda,double * B,int ldb,double vl,double vu,int il,int iu,int * nev,double * W,double * work,int lwork,int * devInfo):
    global _hipsolverDsygvdx__funptr
    if __init_symbol(&_hipsolverDsygvdx__funptr,"hipsolverDsygvdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,double *,int,double *,int,double,double,int,int,int *,double *,double *,int,int *) noexcept nogil> _hipsolverDsygvdx__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverChegvdx__funptr = NULL
cdef hipsolverStatus_t hipsolverChegvdx(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * B,int ldb,float vl,float vu,int il,int iu,int * nev,float * W,float2 * work,int lwork,int * devInfo):
    global _hipsolverChegvdx__funptr
    if __init_symbol(&_hipsolverChegvdx__funptr,"hipsolverChegvdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,float2 *,int,float2 *,int,float,float,int,int,int *,float *,float2 *,int,int *) noexcept nogil> _hipsolverChegvdx__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverZhegvdx__funptr = NULL
cdef hipsolverStatus_t hipsolverZhegvdx(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * B,int ldb,double vl,double vu,int il,int iu,int * nev,double * W,double2 * work,int lwork,int * devInfo):
    global _hipsolverZhegvdx__funptr
    if __init_symbol(&_hipsolverZhegvdx__funptr,"hipsolverZhegvdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,double2 *,int,double2 *,int,double,double,int,int,int *,double *,double2 *,int,int *) noexcept nogil> _hipsolverZhegvdx__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverSsygvj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSsygvj_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * B,int ldb,float * W,int * lwork,void * params):
    global _hipsolverSsygvj_bufferSize__funptr
    if __init_symbol(&_hipsolverSsygvj_bufferSize__funptr,"hipsolverSsygvj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,int,float *,int *,void *) noexcept nogil> _hipsolverSsygvj_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork,params)


cdef void* _hipsolverDsygvj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDsygvj_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * B,int ldb,double * W,int * lwork,void * params):
    global _hipsolverDsygvj_bufferSize__funptr
    if __init_symbol(&_hipsolverDsygvj_bufferSize__funptr,"hipsolverDsygvj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,int,double *,int *,void *) noexcept nogil> _hipsolverDsygvj_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork,params)


cdef void* _hipsolverChegvj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverChegvj_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * B,int ldb,float * W,int * lwork,void * params):
    global _hipsolverChegvj_bufferSize__funptr
    if __init_symbol(&_hipsolverChegvj_bufferSize__funptr,"hipsolverChegvj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float2 *,int,float *,int *,void *) noexcept nogil> _hipsolverChegvj_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork,params)


cdef void* _hipsolverZhegvj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZhegvj_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * B,int ldb,double * W,int * lwork,void * params):
    global _hipsolverZhegvj_bufferSize__funptr
    if __init_symbol(&_hipsolverZhegvj_bufferSize__funptr,"hipsolverZhegvj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double2 *,int,double *,int *,void *) noexcept nogil> _hipsolverZhegvj_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork,params)


cdef void* _hipsolverSsygvj__funptr = NULL
cdef hipsolverStatus_t hipsolverSsygvj(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * B,int ldb,float * W,float * work,int lwork,int * devInfo,void * params):
    global _hipsolverSsygvj__funptr
    if __init_symbol(&_hipsolverSsygvj__funptr,"hipsolverSsygvj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,int,float *,float *,int,int *,void *) noexcept nogil> _hipsolverSsygvj__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo,params)


cdef void* _hipsolverDsygvj__funptr = NULL
cdef hipsolverStatus_t hipsolverDsygvj(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * B,int ldb,double * W,double * work,int lwork,int * devInfo,void * params):
    global _hipsolverDsygvj__funptr
    if __init_symbol(&_hipsolverDsygvj__funptr,"hipsolverDsygvj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,int,double *,double *,int,int *,void *) noexcept nogil> _hipsolverDsygvj__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo,params)


cdef void* _hipsolverChegvj__funptr = NULL
cdef hipsolverStatus_t hipsolverChegvj(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * B,int ldb,float * W,float2 * work,int lwork,int * devInfo,void * params):
    global _hipsolverChegvj__funptr
    if __init_symbol(&_hipsolverChegvj__funptr,"hipsolverChegvj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float2 *,int,float *,float2 *,int,int *,void *) noexcept nogil> _hipsolverChegvj__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo,params)


cdef void* _hipsolverZhegvj__funptr = NULL
cdef hipsolverStatus_t hipsolverZhegvj(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * B,int ldb,double * W,double2 * work,int lwork,int * devInfo,void * params):
    global _hipsolverZhegvj__funptr
    if __init_symbol(&_hipsolverZhegvj__funptr,"hipsolverZhegvj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double2 *,int,double *,double2 *,int,int *,void *) noexcept nogil> _hipsolverZhegvj__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo,params)


cdef void* _hipsolverSsytrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSsytrd_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,float * D,float * E,float * tau,int * lwork):
    global _hipsolverSsytrd_bufferSize__funptr
    if __init_symbol(&_hipsolverSsytrd_bufferSize__funptr,"hipsolverSsytrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,float *,float *,float *,int *) noexcept nogil> _hipsolverSsytrd_bufferSize__funptr)(handle,uplo,n,A,lda,D,E,tau,lwork)


cdef void* _hipsolverDsytrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDsytrd_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,double * D,double * E,double * tau,int * lwork):
    global _hipsolverDsytrd_bufferSize__funptr
    if __init_symbol(&_hipsolverDsytrd_bufferSize__funptr,"hipsolverDsytrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,double *,double *,double *,int *) noexcept nogil> _hipsolverDsytrd_bufferSize__funptr)(handle,uplo,n,A,lda,D,E,tau,lwork)


cdef void* _hipsolverChetrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverChetrd_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,float * D,float * E,float2 * tau,int * lwork):
    global _hipsolverChetrd_bufferSize__funptr
    if __init_symbol(&_hipsolverChetrd_bufferSize__funptr,"hipsolverChetrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,float *,float *,float2 *,int *) noexcept nogil> _hipsolverChetrd_bufferSize__funptr)(handle,uplo,n,A,lda,D,E,tau,lwork)


cdef void* _hipsolverZhetrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZhetrd_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,double * D,double * E,double2 * tau,int * lwork):
    global _hipsolverZhetrd_bufferSize__funptr
    if __init_symbol(&_hipsolverZhetrd_bufferSize__funptr,"hipsolverZhetrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,double *,double *,double2 *,int *) noexcept nogil> _hipsolverZhetrd_bufferSize__funptr)(handle,uplo,n,A,lda,D,E,tau,lwork)


cdef void* _hipsolverSsytrd__funptr = NULL
cdef hipsolverStatus_t hipsolverSsytrd(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,float * D,float * E,float * tau,float * work,int lwork,int * devInfo):
    global _hipsolverSsytrd__funptr
    if __init_symbol(&_hipsolverSsytrd__funptr,"hipsolverSsytrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,float *,float *,float *,float *,int,int *) noexcept nogil> _hipsolverSsytrd__funptr)(handle,uplo,n,A,lda,D,E,tau,work,lwork,devInfo)


cdef void* _hipsolverDsytrd__funptr = NULL
cdef hipsolverStatus_t hipsolverDsytrd(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,double * D,double * E,double * tau,double * work,int lwork,int * devInfo):
    global _hipsolverDsytrd__funptr
    if __init_symbol(&_hipsolverDsytrd__funptr,"hipsolverDsytrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,double *,double *,double *,double *,int,int *) noexcept nogil> _hipsolverDsytrd__funptr)(handle,uplo,n,A,lda,D,E,tau,work,lwork,devInfo)


cdef void* _hipsolverChetrd__funptr = NULL
cdef hipsolverStatus_t hipsolverChetrd(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,float * D,float * E,float2 * tau,float2 * work,int lwork,int * devInfo):
    global _hipsolverChetrd__funptr
    if __init_symbol(&_hipsolverChetrd__funptr,"hipsolverChetrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,float *,float *,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverChetrd__funptr)(handle,uplo,n,A,lda,D,E,tau,work,lwork,devInfo)


cdef void* _hipsolverZhetrd__funptr = NULL
cdef hipsolverStatus_t hipsolverZhetrd(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,double * D,double * E,double2 * tau,double2 * work,int lwork,int * devInfo):
    global _hipsolverZhetrd__funptr
    if __init_symbol(&_hipsolverZhetrd__funptr,"hipsolverZhetrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,double *,double *,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverZhetrd__funptr)(handle,uplo,n,A,lda,D,E,tau,work,lwork,devInfo)


cdef void* _hipsolverSsytrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverSsytrf_bufferSize(void * handle,int n,float * A,int lda,int * lwork):
    global _hipsolverSsytrf_bufferSize__funptr
    if __init_symbol(&_hipsolverSsytrf_bufferSize__funptr,"hipsolverSsytrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,float *,int,int *) noexcept nogil> _hipsolverSsytrf_bufferSize__funptr)(handle,n,A,lda,lwork)


cdef void* _hipsolverDsytrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDsytrf_bufferSize(void * handle,int n,double * A,int lda,int * lwork):
    global _hipsolverDsytrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDsytrf_bufferSize__funptr,"hipsolverDsytrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,double *,int,int *) noexcept nogil> _hipsolverDsytrf_bufferSize__funptr)(handle,n,A,lda,lwork)


cdef void* _hipsolverCsytrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverCsytrf_bufferSize(void * handle,int n,float2 * A,int lda,int * lwork):
    global _hipsolverCsytrf_bufferSize__funptr
    if __init_symbol(&_hipsolverCsytrf_bufferSize__funptr,"hipsolverCsytrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,float2 *,int,int *) noexcept nogil> _hipsolverCsytrf_bufferSize__funptr)(handle,n,A,lda,lwork)


cdef void* _hipsolverZsytrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverZsytrf_bufferSize(void * handle,int n,double2 * A,int lda,int * lwork):
    global _hipsolverZsytrf_bufferSize__funptr
    if __init_symbol(&_hipsolverZsytrf_bufferSize__funptr,"hipsolverZsytrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,double2 *,int,int *) noexcept nogil> _hipsolverZsytrf_bufferSize__funptr)(handle,n,A,lda,lwork)


cdef void* _hipsolverSsytrf__funptr = NULL
cdef hipsolverStatus_t hipsolverSsytrf(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,int * ipiv,float * work,int lwork,int * devInfo):
    global _hipsolverSsytrf__funptr
    if __init_symbol(&_hipsolverSsytrf__funptr,"hipsolverSsytrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,int *,float *,int,int *) noexcept nogil> _hipsolverSsytrf__funptr)(handle,uplo,n,A,lda,ipiv,work,lwork,devInfo)


cdef void* _hipsolverDsytrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDsytrf(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,int * ipiv,double * work,int lwork,int * devInfo):
    global _hipsolverDsytrf__funptr
    if __init_symbol(&_hipsolverDsytrf__funptr,"hipsolverDsytrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,int *,double *,int,int *) noexcept nogil> _hipsolverDsytrf__funptr)(handle,uplo,n,A,lda,ipiv,work,lwork,devInfo)


cdef void* _hipsolverCsytrf__funptr = NULL
cdef hipsolverStatus_t hipsolverCsytrf(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,int * ipiv,float2 * work,int lwork,int * devInfo):
    global _hipsolverCsytrf__funptr
    if __init_symbol(&_hipsolverCsytrf__funptr,"hipsolverCsytrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,int *,float2 *,int,int *) noexcept nogil> _hipsolverCsytrf__funptr)(handle,uplo,n,A,lda,ipiv,work,lwork,devInfo)


cdef void* _hipsolverZsytrf__funptr = NULL
cdef hipsolverStatus_t hipsolverZsytrf(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,int * ipiv,double2 * work,int lwork,int * devInfo):
    global _hipsolverZsytrf__funptr
    if __init_symbol(&_hipsolverZsytrf__funptr,"hipsolverZsytrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,int *,double2 *,int,int *) noexcept nogil> _hipsolverZsytrf__funptr)(handle,uplo,n,A,lda,ipiv,work,lwork,devInfo)


cdef void* _hipsolverDnCreate__funptr = NULL
#   \brief An alias for #hipsolverCreate.
# ******************************************************************************
cdef hipsolverStatus_t hipsolverDnCreate(void ** handle):
    global _hipsolverDnCreate__funptr
    if __init_symbol(&_hipsolverDnCreate__funptr,"hipsolverDnCreate") > 0:
        pass
    return (<hipsolverStatus_t (*)(void **) noexcept nogil> _hipsolverDnCreate__funptr)(handle)


cdef void* _hipsolverDnDestroy__funptr = NULL
#   \brief An alias for #hipsolverDestroy.
# ******************************************************************************
cdef hipsolverStatus_t hipsolverDnDestroy(void * handle):
    global _hipsolverDnDestroy__funptr
    if __init_symbol(&_hipsolverDnDestroy__funptr,"hipsolverDnDestroy") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverDnDestroy__funptr)(handle)


cdef void* _hipsolverDnSetStream__funptr = NULL
#   \brief An alias for #hipsolverSetStream.
# ******************************************************************************
cdef hipsolverStatus_t hipsolverDnSetStream(void * handle,hipStream_t streamId):
    global _hipsolverDnSetStream__funptr
    if __init_symbol(&_hipsolverDnSetStream__funptr,"hipsolverDnSetStream") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipStream_t) noexcept nogil> _hipsolverDnSetStream__funptr)(handle,streamId)


cdef void* _hipsolverDnGetStream__funptr = NULL
#   \brief An alias for #hipsolverGetStream.
# ******************************************************************************
cdef hipsolverStatus_t hipsolverDnGetStream(void * handle,hipStream_t* streamId):
    global _hipsolverDnGetStream__funptr
    if __init_symbol(&_hipsolverDnGetStream__funptr,"hipsolverDnGetStream") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipStream_t*) noexcept nogil> _hipsolverDnGetStream__funptr)(handle,streamId)


cdef void* _hipsolverDnSetDeterministicMode__funptr = NULL
#   \brief An alias for #hipsolverSetDeterministicMode.
# ******************************************************************************
cdef hipsolverStatus_t hipsolverDnSetDeterministicMode(void * handle,hipsolverDeterministicMode_t mode):
    global _hipsolverDnSetDeterministicMode__funptr
    if __init_symbol(&_hipsolverDnSetDeterministicMode__funptr,"hipsolverDnSetDeterministicMode") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverDeterministicMode_t) noexcept nogil> _hipsolverDnSetDeterministicMode__funptr)(handle,mode)


cdef void* _hipsolverDnGetDeterministicMode__funptr = NULL
#   \brief An alias for #hipsolverGetDeterministicMode.
# ******************************************************************************
cdef hipsolverStatus_t hipsolverDnGetDeterministicMode(void * handle,hipsolverDeterministicMode_t * mode):
    global _hipsolverDnGetDeterministicMode__funptr
    if __init_symbol(&_hipsolverDnGetDeterministicMode__funptr,"hipsolverDnGetDeterministicMode") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverDeterministicMode_t *) noexcept nogil> _hipsolverDnGetDeterministicMode__funptr)(handle,mode)


cdef void* _hipsolverDnCreateGesvdjInfo__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCreateGesvdjInfo(void ** info):
    global _hipsolverDnCreateGesvdjInfo__funptr
    if __init_symbol(&_hipsolverDnCreateGesvdjInfo__funptr,"hipsolverDnCreateGesvdjInfo") > 0:
        pass
    return (<hipsolverStatus_t (*)(void **) noexcept nogil> _hipsolverDnCreateGesvdjInfo__funptr)(info)


cdef void* _hipsolverDnDestroyGesvdjInfo__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDestroyGesvdjInfo(void * info):
    global _hipsolverDnDestroyGesvdjInfo__funptr
    if __init_symbol(&_hipsolverDnDestroyGesvdjInfo__funptr,"hipsolverDnDestroyGesvdjInfo") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverDnDestroyGesvdjInfo__funptr)(info)


cdef void* _hipsolverDnXgesvdjSetMaxSweeps__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXgesvdjSetMaxSweeps(void * info,int max_sweeps):
    global _hipsolverDnXgesvdjSetMaxSweeps__funptr
    if __init_symbol(&_hipsolverDnXgesvdjSetMaxSweeps__funptr,"hipsolverDnXgesvdjSetMaxSweeps") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int) noexcept nogil> _hipsolverDnXgesvdjSetMaxSweeps__funptr)(info,max_sweeps)


cdef void* _hipsolverDnXgesvdjSetSortEig__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXgesvdjSetSortEig(void * info,int sort_eig):
    global _hipsolverDnXgesvdjSetSortEig__funptr
    if __init_symbol(&_hipsolverDnXgesvdjSetSortEig__funptr,"hipsolverDnXgesvdjSetSortEig") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int) noexcept nogil> _hipsolverDnXgesvdjSetSortEig__funptr)(info,sort_eig)


cdef void* _hipsolverDnXgesvdjSetTolerance__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXgesvdjSetTolerance(void * info,double tolerance):
    global _hipsolverDnXgesvdjSetTolerance__funptr
    if __init_symbol(&_hipsolverDnXgesvdjSetTolerance__funptr,"hipsolverDnXgesvdjSetTolerance") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,double) noexcept nogil> _hipsolverDnXgesvdjSetTolerance__funptr)(info,tolerance)


cdef void* _hipsolverDnXgesvdjGetResidual__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXgesvdjGetResidual(void * handle,void * info,double * residual):
    global _hipsolverDnXgesvdjGetResidual__funptr
    if __init_symbol(&_hipsolverDnXgesvdjGetResidual__funptr,"hipsolverDnXgesvdjGetResidual") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,double *) noexcept nogil> _hipsolverDnXgesvdjGetResidual__funptr)(handle,info,residual)


cdef void* _hipsolverDnXgesvdjGetSweeps__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXgesvdjGetSweeps(void * handle,void * info,int * executed_sweeps):
    global _hipsolverDnXgesvdjGetSweeps__funptr
    if __init_symbol(&_hipsolverDnXgesvdjGetSweeps__funptr,"hipsolverDnXgesvdjGetSweeps") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,int *) noexcept nogil> _hipsolverDnXgesvdjGetSweeps__funptr)(handle,info,executed_sweeps)


cdef void* _hipsolverDnCreateSyevjInfo__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCreateSyevjInfo(void ** info):
    global _hipsolverDnCreateSyevjInfo__funptr
    if __init_symbol(&_hipsolverDnCreateSyevjInfo__funptr,"hipsolverDnCreateSyevjInfo") > 0:
        pass
    return (<hipsolverStatus_t (*)(void **) noexcept nogil> _hipsolverDnCreateSyevjInfo__funptr)(info)


cdef void* _hipsolverDnDestroySyevjInfo__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDestroySyevjInfo(void * info):
    global _hipsolverDnDestroySyevjInfo__funptr
    if __init_symbol(&_hipsolverDnDestroySyevjInfo__funptr,"hipsolverDnDestroySyevjInfo") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverDnDestroySyevjInfo__funptr)(info)


cdef void* _hipsolverDnXsyevjSetMaxSweeps__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXsyevjSetMaxSweeps(void * info,int max_sweeps):
    global _hipsolverDnXsyevjSetMaxSweeps__funptr
    if __init_symbol(&_hipsolverDnXsyevjSetMaxSweeps__funptr,"hipsolverDnXsyevjSetMaxSweeps") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int) noexcept nogil> _hipsolverDnXsyevjSetMaxSweeps__funptr)(info,max_sweeps)


cdef void* _hipsolverDnXsyevjSetSortEig__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXsyevjSetSortEig(void * info,int sort_eig):
    global _hipsolverDnXsyevjSetSortEig__funptr
    if __init_symbol(&_hipsolverDnXsyevjSetSortEig__funptr,"hipsolverDnXsyevjSetSortEig") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int) noexcept nogil> _hipsolverDnXsyevjSetSortEig__funptr)(info,sort_eig)


cdef void* _hipsolverDnXsyevjSetTolerance__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXsyevjSetTolerance(void * info,double tolerance):
    global _hipsolverDnXsyevjSetTolerance__funptr
    if __init_symbol(&_hipsolverDnXsyevjSetTolerance__funptr,"hipsolverDnXsyevjSetTolerance") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,double) noexcept nogil> _hipsolverDnXsyevjSetTolerance__funptr)(info,tolerance)


cdef void* _hipsolverDnXsyevjGetResidual__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXsyevjGetResidual(void * handle,void * info,double * residual):
    global _hipsolverDnXsyevjGetResidual__funptr
    if __init_symbol(&_hipsolverDnXsyevjGetResidual__funptr,"hipsolverDnXsyevjGetResidual") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,double *) noexcept nogil> _hipsolverDnXsyevjGetResidual__funptr)(handle,info,residual)


cdef void* _hipsolverDnXsyevjGetSweeps__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXsyevjGetSweeps(void * handle,void * info,int * executed_sweeps):
    global _hipsolverDnXsyevjGetSweeps__funptr
    if __init_symbol(&_hipsolverDnXsyevjGetSweeps__funptr,"hipsolverDnXsyevjGetSweeps") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,int *) noexcept nogil> _hipsolverDnXsyevjGetSweeps__funptr)(handle,info,executed_sweeps)


cdef void* _hipsolverDnSorgbr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSorgbr_bufferSize(void * handle,hipblasSideMode_t side,int m,int n,int k,const float * A,int lda,const float * tau,int * lwork):
    global _hipsolverDnSorgbr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSorgbr_bufferSize__funptr,"hipsolverDnSorgbr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,const float *,int,const float *,int *) noexcept nogil> _hipsolverDnSorgbr_bufferSize__funptr)(handle,side,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverDnDorgbr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDorgbr_bufferSize(void * handle,hipblasSideMode_t side,int m,int n,int k,const double * A,int lda,const double * tau,int * lwork):
    global _hipsolverDnDorgbr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDorgbr_bufferSize__funptr,"hipsolverDnDorgbr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,const double *,int,const double *,int *) noexcept nogil> _hipsolverDnDorgbr_bufferSize__funptr)(handle,side,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverDnCungbr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCungbr_bufferSize(void * handle,hipblasSideMode_t side,int m,int n,int k,float2 * A,int lda,float2 * tau,int * lwork):
    global _hipsolverDnCungbr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCungbr_bufferSize__funptr,"hipsolverDnCungbr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,float2 *,int,float2 *,int *) noexcept nogil> _hipsolverDnCungbr_bufferSize__funptr)(handle,side,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverDnZungbr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZungbr_bufferSize(void * handle,hipblasSideMode_t side,int m,int n,int k,double2 * A,int lda,double2 * tau,int * lwork):
    global _hipsolverDnZungbr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZungbr_bufferSize__funptr,"hipsolverDnZungbr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,double2 *,int,double2 *,int *) noexcept nogil> _hipsolverDnZungbr_bufferSize__funptr)(handle,side,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverDnSorgbr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSorgbr(void * handle,hipblasSideMode_t side,int m,int n,int k,float * A,int lda,const float * tau,float * work,int lwork,int * devInfo):
    global _hipsolverDnSorgbr__funptr
    if __init_symbol(&_hipsolverDnSorgbr__funptr,"hipsolverDnSorgbr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,float *,int,const float *,float *,int,int *) noexcept nogil> _hipsolverDnSorgbr__funptr)(handle,side,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnDorgbr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDorgbr(void * handle,hipblasSideMode_t side,int m,int n,int k,double * A,int lda,const double * tau,double * work,int lwork,int * devInfo):
    global _hipsolverDnDorgbr__funptr
    if __init_symbol(&_hipsolverDnDorgbr__funptr,"hipsolverDnDorgbr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,double *,int,const double *,double *,int,int *) noexcept nogil> _hipsolverDnDorgbr__funptr)(handle,side,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnCungbr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCungbr(void * handle,hipblasSideMode_t side,int m,int n,int k,float2 * A,int lda,float2 * tau,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnCungbr__funptr
    if __init_symbol(&_hipsolverDnCungbr__funptr,"hipsolverDnCungbr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,float2 *,int,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverDnCungbr__funptr)(handle,side,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnZungbr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZungbr(void * handle,hipblasSideMode_t side,int m,int n,int k,double2 * A,int lda,double2 * tau,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZungbr__funptr
    if __init_symbol(&_hipsolverDnZungbr__funptr,"hipsolverDnZungbr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,int,int,int,double2 *,int,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverDnZungbr__funptr)(handle,side,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnSorgqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSorgqr_bufferSize(void * handle,int m,int n,int k,const float * A,int lda,const float * tau,int * lwork):
    global _hipsolverDnSorgqr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSorgqr_bufferSize__funptr,"hipsolverDnSorgqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,const float *,int,const float *,int *) noexcept nogil> _hipsolverDnSorgqr_bufferSize__funptr)(handle,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverDnDorgqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDorgqr_bufferSize(void * handle,int m,int n,int k,const double * A,int lda,const double * tau,int * lwork):
    global _hipsolverDnDorgqr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDorgqr_bufferSize__funptr,"hipsolverDnDorgqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,const double *,int,const double *,int *) noexcept nogil> _hipsolverDnDorgqr_bufferSize__funptr)(handle,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverDnCungqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCungqr_bufferSize(void * handle,int m,int n,int k,float2 * A,int lda,float2 * tau,int * lwork):
    global _hipsolverDnCungqr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCungqr_bufferSize__funptr,"hipsolverDnCungqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float2 *,int,float2 *,int *) noexcept nogil> _hipsolverDnCungqr_bufferSize__funptr)(handle,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverDnZungqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZungqr_bufferSize(void * handle,int m,int n,int k,double2 * A,int lda,double2 * tau,int * lwork):
    global _hipsolverDnZungqr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZungqr_bufferSize__funptr,"hipsolverDnZungqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double2 *,int,double2 *,int *) noexcept nogil> _hipsolverDnZungqr_bufferSize__funptr)(handle,m,n,k,A,lda,tau,lwork)


cdef void* _hipsolverDnSorgqr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSorgqr(void * handle,int m,int n,int k,float * A,int lda,const float * tau,float * work,int lwork,int * devInfo):
    global _hipsolverDnSorgqr__funptr
    if __init_symbol(&_hipsolverDnSorgqr__funptr,"hipsolverDnSorgqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float *,int,const float *,float *,int,int *) noexcept nogil> _hipsolverDnSorgqr__funptr)(handle,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnDorgqr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDorgqr(void * handle,int m,int n,int k,double * A,int lda,const double * tau,double * work,int lwork,int * devInfo):
    global _hipsolverDnDorgqr__funptr
    if __init_symbol(&_hipsolverDnDorgqr__funptr,"hipsolverDnDorgqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double *,int,const double *,double *,int,int *) noexcept nogil> _hipsolverDnDorgqr__funptr)(handle,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnCungqr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCungqr(void * handle,int m,int n,int k,float2 * A,int lda,float2 * tau,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnCungqr__funptr
    if __init_symbol(&_hipsolverDnCungqr__funptr,"hipsolverDnCungqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float2 *,int,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverDnCungqr__funptr)(handle,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnZungqr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZungqr(void * handle,int m,int n,int k,double2 * A,int lda,double2 * tau,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZungqr__funptr
    if __init_symbol(&_hipsolverDnZungqr__funptr,"hipsolverDnZungqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double2 *,int,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverDnZungqr__funptr)(handle,m,n,k,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnSorgtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSorgtr_bufferSize(void * handle,hipblasFillMode_t uplo,int n,const float * A,int lda,const float * tau,int * lwork):
    global _hipsolverDnSorgtr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSorgtr_bufferSize__funptr,"hipsolverDnSorgtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,const float *,int,const float *,int *) noexcept nogil> _hipsolverDnSorgtr_bufferSize__funptr)(handle,uplo,n,A,lda,tau,lwork)


cdef void* _hipsolverDnDorgtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDorgtr_bufferSize(void * handle,hipblasFillMode_t uplo,int n,const double * A,int lda,const double * tau,int * lwork):
    global _hipsolverDnDorgtr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDorgtr_bufferSize__funptr,"hipsolverDnDorgtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,const double *,int,const double *,int *) noexcept nogil> _hipsolverDnDorgtr_bufferSize__funptr)(handle,uplo,n,A,lda,tau,lwork)


cdef void* _hipsolverDnCungtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCungtr_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * tau,int * lwork):
    global _hipsolverDnCungtr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCungtr_bufferSize__funptr,"hipsolverDnCungtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,float2 *,int *) noexcept nogil> _hipsolverDnCungtr_bufferSize__funptr)(handle,uplo,n,A,lda,tau,lwork)


cdef void* _hipsolverDnZungtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZungtr_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * tau,int * lwork):
    global _hipsolverDnZungtr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZungtr_bufferSize__funptr,"hipsolverDnZungtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,double2 *,int *) noexcept nogil> _hipsolverDnZungtr_bufferSize__funptr)(handle,uplo,n,A,lda,tau,lwork)


cdef void* _hipsolverDnSorgtr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSorgtr(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,const float * tau,float * work,int lwork,int * devInfo):
    global _hipsolverDnSorgtr__funptr
    if __init_symbol(&_hipsolverDnSorgtr__funptr,"hipsolverDnSorgtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,const float *,float *,int,int *) noexcept nogil> _hipsolverDnSorgtr__funptr)(handle,uplo,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnDorgtr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDorgtr(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,const double * tau,double * work,int lwork,int * devInfo):
    global _hipsolverDnDorgtr__funptr
    if __init_symbol(&_hipsolverDnDorgtr__funptr,"hipsolverDnDorgtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,const double *,double *,int,int *) noexcept nogil> _hipsolverDnDorgtr__funptr)(handle,uplo,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnCungtr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCungtr(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * tau,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnCungtr__funptr
    if __init_symbol(&_hipsolverDnCungtr__funptr,"hipsolverDnCungtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverDnCungtr__funptr)(handle,uplo,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnZungtr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZungtr(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * tau,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZungtr__funptr
    if __init_symbol(&_hipsolverDnZungtr__funptr,"hipsolverDnZungtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverDnZungtr__funptr)(handle,uplo,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnSormqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSormqr_bufferSize(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,const float * A,int lda,const float * tau,const float * C,int ldc,int * lwork):
    global _hipsolverDnSormqr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSormqr_bufferSize__funptr,"hipsolverDnSormqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,const float *,int,const float *,const float *,int,int *) noexcept nogil> _hipsolverDnSormqr_bufferSize__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverDnDormqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDormqr_bufferSize(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,const double * A,int lda,const double * tau,const double * C,int ldc,int * lwork):
    global _hipsolverDnDormqr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDormqr_bufferSize__funptr,"hipsolverDnDormqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,const double *,int,const double *,const double *,int,int *) noexcept nogil> _hipsolverDnDormqr_bufferSize__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverDnCunmqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCunmqr_bufferSize(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,float2 * A,int lda,float2 * tau,float2 * C,int ldc,int * lwork):
    global _hipsolverDnCunmqr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCunmqr_bufferSize__funptr,"hipsolverDnCunmqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,float2 *,int,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverDnCunmqr_bufferSize__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverDnZunmqr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZunmqr_bufferSize(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,double2 * A,int lda,double2 * tau,double2 * C,int ldc,int * lwork):
    global _hipsolverDnZunmqr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZunmqr_bufferSize__funptr,"hipsolverDnZunmqr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,double2 *,int,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverDnZunmqr_bufferSize__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverDnSormqr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSormqr(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,const float * A,int lda,const float * tau,float * C,int ldc,float * work,int lwork,int * devInfo):
    global _hipsolverDnSormqr__funptr
    if __init_symbol(&_hipsolverDnSormqr__funptr,"hipsolverDnSormqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,const float *,int,const float *,float *,int,float *,int,int *) noexcept nogil> _hipsolverDnSormqr__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverDnDormqr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDormqr(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,const double * A,int lda,const double * tau,double * C,int ldc,double * work,int lwork,int * devInfo):
    global _hipsolverDnDormqr__funptr
    if __init_symbol(&_hipsolverDnDormqr__funptr,"hipsolverDnDormqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,const double *,int,const double *,double *,int,double *,int,int *) noexcept nogil> _hipsolverDnDormqr__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverDnCunmqr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCunmqr(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,float2 * A,int lda,float2 * tau,float2 * C,int ldc,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnCunmqr__funptr
    if __init_symbol(&_hipsolverDnCunmqr__funptr,"hipsolverDnCunmqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,float2 *,int,float2 *,float2 *,int,float2 *,int,int *) noexcept nogil> _hipsolverDnCunmqr__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverDnZunmqr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZunmqr(void * handle,hipblasSideMode_t side,hipblasOperation_t trans,int m,int n,int k,double2 * A,int lda,double2 * tau,double2 * C,int ldc,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZunmqr__funptr
    if __init_symbol(&_hipsolverDnZunmqr__funptr,"hipsolverDnZunmqr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasOperation_t,int,int,int,double2 *,int,double2 *,double2 *,int,double2 *,int,int *) noexcept nogil> _hipsolverDnZunmqr__funptr)(handle,side,trans,m,n,k,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverDnSormtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSormtr_bufferSize(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,const float * A,int lda,const float * tau,const float * C,int ldc,int * lwork):
    global _hipsolverDnSormtr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSormtr_bufferSize__funptr,"hipsolverDnSormtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,const float *,int,const float *,const float *,int,int *) noexcept nogil> _hipsolverDnSormtr_bufferSize__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverDnDormtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDormtr_bufferSize(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,const double * A,int lda,const double * tau,const double * C,int ldc,int * lwork):
    global _hipsolverDnDormtr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDormtr_bufferSize__funptr,"hipsolverDnDormtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,const double *,int,const double *,const double *,int,int *) noexcept nogil> _hipsolverDnDormtr_bufferSize__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverDnCunmtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCunmtr_bufferSize(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,float2 * A,int lda,float2 * tau,float2 * C,int ldc,int * lwork):
    global _hipsolverDnCunmtr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCunmtr_bufferSize__funptr,"hipsolverDnCunmtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,float2 *,int,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverDnCunmtr_bufferSize__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverDnZunmtr_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZunmtr_bufferSize(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,double2 * A,int lda,double2 * tau,double2 * C,int ldc,int * lwork):
    global _hipsolverDnZunmtr_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZunmtr_bufferSize__funptr,"hipsolverDnZunmtr_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,double2 *,int,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverDnZunmtr_bufferSize__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,lwork)


cdef void* _hipsolverDnSormtr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSormtr(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,float * A,int lda,float * tau,float * C,int ldc,float * work,int lwork,int * devInfo):
    global _hipsolverDnSormtr__funptr
    if __init_symbol(&_hipsolverDnSormtr__funptr,"hipsolverDnSormtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,float *,int,float *,float *,int,float *,int,int *) noexcept nogil> _hipsolverDnSormtr__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverDnDormtr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDormtr(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,double * A,int lda,double * tau,double * C,int ldc,double * work,int lwork,int * devInfo):
    global _hipsolverDnDormtr__funptr
    if __init_symbol(&_hipsolverDnDormtr__funptr,"hipsolverDnDormtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,double *,int,double *,double *,int,double *,int,int *) noexcept nogil> _hipsolverDnDormtr__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverDnCunmtr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCunmtr(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,float2 * A,int lda,float2 * tau,float2 * C,int ldc,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnCunmtr__funptr
    if __init_symbol(&_hipsolverDnCunmtr__funptr,"hipsolverDnCunmtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,float2 *,int,float2 *,float2 *,int,float2 *,int,int *) noexcept nogil> _hipsolverDnCunmtr__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverDnZunmtr__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZunmtr(void * handle,hipblasSideMode_t side,hipblasFillMode_t uplo,hipblasOperation_t trans,int m,int n,double2 * A,int lda,double2 * tau,double2 * C,int ldc,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZunmtr__funptr
    if __init_symbol(&_hipsolverDnZunmtr__funptr,"hipsolverDnZunmtr") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasSideMode_t,hipblasFillMode_t,hipblasOperation_t,int,int,double2 *,int,double2 *,double2 *,int,double2 *,int,int *) noexcept nogil> _hipsolverDnZunmtr__funptr)(handle,side,uplo,trans,m,n,A,lda,tau,C,ldc,work,lwork,devInfo)


cdef void* _hipsolverDnSgebrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgebrd_bufferSize(void * handle,int m,int n,int * lwork):
    global _hipsolverDnSgebrd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSgebrd_bufferSize__funptr,"hipsolverDnSgebrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int *) noexcept nogil> _hipsolverDnSgebrd_bufferSize__funptr)(handle,m,n,lwork)


cdef void* _hipsolverDnDgebrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgebrd_bufferSize(void * handle,int m,int n,int * lwork):
    global _hipsolverDnDgebrd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDgebrd_bufferSize__funptr,"hipsolverDnDgebrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int *) noexcept nogil> _hipsolverDnDgebrd_bufferSize__funptr)(handle,m,n,lwork)


cdef void* _hipsolverDnCgebrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgebrd_bufferSize(void * handle,int m,int n,int * lwork):
    global _hipsolverDnCgebrd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCgebrd_bufferSize__funptr,"hipsolverDnCgebrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int *) noexcept nogil> _hipsolverDnCgebrd_bufferSize__funptr)(handle,m,n,lwork)


cdef void* _hipsolverDnZgebrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgebrd_bufferSize(void * handle,int m,int n,int * lwork):
    global _hipsolverDnZgebrd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZgebrd_bufferSize__funptr,"hipsolverDnZgebrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int *) noexcept nogil> _hipsolverDnZgebrd_bufferSize__funptr)(handle,m,n,lwork)


cdef void* _hipsolverDnSgebrd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgebrd(void * handle,int m,int n,float * A,int lda,float * D,float * E,float * tauq,float * taup,float * work,int lwork,int * devInfo):
    global _hipsolverDnSgebrd__funptr
    if __init_symbol(&_hipsolverDnSgebrd__funptr,"hipsolverDnSgebrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,float *,float *,float *,float *,float *,int,int *) noexcept nogil> _hipsolverDnSgebrd__funptr)(handle,m,n,A,lda,D,E,tauq,taup,work,lwork,devInfo)


cdef void* _hipsolverDnDgebrd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgebrd(void * handle,int m,int n,double * A,int lda,double * D,double * E,double * tauq,double * taup,double * work,int lwork,int * devInfo):
    global _hipsolverDnDgebrd__funptr
    if __init_symbol(&_hipsolverDnDgebrd__funptr,"hipsolverDnDgebrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,double *,double *,double *,double *,double *,int,int *) noexcept nogil> _hipsolverDnDgebrd__funptr)(handle,m,n,A,lda,D,E,tauq,taup,work,lwork,devInfo)


cdef void* _hipsolverDnCgebrd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgebrd(void * handle,int m,int n,float2 * A,int lda,float * D,float * E,float2 * tauq,float2 * taup,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnCgebrd__funptr
    if __init_symbol(&_hipsolverDnCgebrd__funptr,"hipsolverDnCgebrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,float *,float *,float2 *,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverDnCgebrd__funptr)(handle,m,n,A,lda,D,E,tauq,taup,work,lwork,devInfo)


cdef void* _hipsolverDnZgebrd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgebrd(void * handle,int m,int n,double2 * A,int lda,double * D,double * E,double2 * tauq,double2 * taup,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZgebrd__funptr
    if __init_symbol(&_hipsolverDnZgebrd__funptr,"hipsolverDnZgebrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,double *,double *,double2 *,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverDnZgebrd__funptr)(handle,m,n,A,lda,D,E,tauq,taup,work,lwork,devInfo)


cdef void* _hipsolverDnSSgels_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSSgels_bufferSize(void * handle,int m,int n,int nrhs,float * A,int lda,float * B,int ldb,float * X,int ldx,void * work,unsigned long * lwork):
    global _hipsolverDnSSgels_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSSgels_bufferSize__funptr,"hipsolverDnSSgels_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float *,int,float *,int,float *,int,void *,unsigned long *) noexcept nogil> _hipsolverDnSSgels_bufferSize__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,work,lwork)


cdef void* _hipsolverDnDDgels_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDDgels_bufferSize(void * handle,int m,int n,int nrhs,double * A,int lda,double * B,int ldb,double * X,int ldx,void * work,unsigned long * lwork):
    global _hipsolverDnDDgels_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDDgels_bufferSize__funptr,"hipsolverDnDDgels_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double *,int,double *,int,double *,int,void *,unsigned long *) noexcept nogil> _hipsolverDnDDgels_bufferSize__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,work,lwork)


cdef void* _hipsolverDnCCgels_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCCgels_bufferSize(void * handle,int m,int n,int nrhs,float2 * A,int lda,float2 * B,int ldb,float2 * X,int ldx,void * work,unsigned long * lwork):
    global _hipsolverDnCCgels_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCCgels_bufferSize__funptr,"hipsolverDnCCgels_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float2 *,int,float2 *,int,float2 *,int,void *,unsigned long *) noexcept nogil> _hipsolverDnCCgels_bufferSize__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,work,lwork)


cdef void* _hipsolverDnZZgels_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZZgels_bufferSize(void * handle,int m,int n,int nrhs,double2 * A,int lda,double2 * B,int ldb,double2 * X,int ldx,void * work,unsigned long * lwork):
    global _hipsolverDnZZgels_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZZgels_bufferSize__funptr,"hipsolverDnZZgels_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double2 *,int,double2 *,int,double2 *,int,void *,unsigned long *) noexcept nogil> _hipsolverDnZZgels_bufferSize__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,work,lwork)


cdef void* _hipsolverDnSSgels__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSSgels(void * handle,int m,int n,int nrhs,float * A,int lda,float * B,int ldb,float * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverDnSSgels__funptr
    if __init_symbol(&_hipsolverDnSSgels__funptr,"hipsolverDnSSgels") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float *,int,float *,int,float *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverDnSSgels__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverDnDDgels__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDDgels(void * handle,int m,int n,int nrhs,double * A,int lda,double * B,int ldb,double * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverDnDDgels__funptr
    if __init_symbol(&_hipsolverDnDDgels__funptr,"hipsolverDnDDgels") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double *,int,double *,int,double *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverDnDDgels__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverDnCCgels__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCCgels(void * handle,int m,int n,int nrhs,float2 * A,int lda,float2 * B,int ldb,float2 * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverDnCCgels__funptr
    if __init_symbol(&_hipsolverDnCCgels__funptr,"hipsolverDnCCgels") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,float2 *,int,float2 *,int,float2 *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverDnCCgels__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverDnZZgels__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZZgels(void * handle,int m,int n,int nrhs,double2 * A,int lda,double2 * B,int ldb,double2 * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverDnZZgels__funptr
    if __init_symbol(&_hipsolverDnZZgels__funptr,"hipsolverDnZZgels") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int,double2 *,int,double2 *,int,double2 *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverDnZZgels__funptr)(handle,m,n,nrhs,A,lda,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverDnSgeqrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgeqrf_bufferSize(void * handle,int m,int n,float * A,int lda,int * lwork):
    global _hipsolverDnSgeqrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSgeqrf_bufferSize__funptr,"hipsolverDnSgeqrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,int *) noexcept nogil> _hipsolverDnSgeqrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverDnDgeqrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgeqrf_bufferSize(void * handle,int m,int n,double * A,int lda,int * lwork):
    global _hipsolverDnDgeqrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDgeqrf_bufferSize__funptr,"hipsolverDnDgeqrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,int *) noexcept nogil> _hipsolverDnDgeqrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverDnCgeqrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgeqrf_bufferSize(void * handle,int m,int n,float2 * A,int lda,int * lwork):
    global _hipsolverDnCgeqrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCgeqrf_bufferSize__funptr,"hipsolverDnCgeqrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,int *) noexcept nogil> _hipsolverDnCgeqrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverDnZgeqrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgeqrf_bufferSize(void * handle,int m,int n,double2 * A,int lda,int * lwork):
    global _hipsolverDnZgeqrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZgeqrf_bufferSize__funptr,"hipsolverDnZgeqrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,int *) noexcept nogil> _hipsolverDnZgeqrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverDnSgeqrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgeqrf(void * handle,int m,int n,float * A,int lda,float * tau,float * work,int lwork,int * devInfo):
    global _hipsolverDnSgeqrf__funptr
    if __init_symbol(&_hipsolverDnSgeqrf__funptr,"hipsolverDnSgeqrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,float *,float *,int,int *) noexcept nogil> _hipsolverDnSgeqrf__funptr)(handle,m,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnDgeqrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgeqrf(void * handle,int m,int n,double * A,int lda,double * tau,double * work,int lwork,int * devInfo):
    global _hipsolverDnDgeqrf__funptr
    if __init_symbol(&_hipsolverDnDgeqrf__funptr,"hipsolverDnDgeqrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,double *,double *,int,int *) noexcept nogil> _hipsolverDnDgeqrf__funptr)(handle,m,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnCgeqrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgeqrf(void * handle,int m,int n,float2 * A,int lda,float2 * tau,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnCgeqrf__funptr
    if __init_symbol(&_hipsolverDnCgeqrf__funptr,"hipsolverDnCgeqrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverDnCgeqrf__funptr)(handle,m,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnZgeqrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgeqrf(void * handle,int m,int n,double2 * A,int lda,double2 * tau,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZgeqrf__funptr
    if __init_symbol(&_hipsolverDnZgeqrf__funptr,"hipsolverDnZgeqrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverDnZgeqrf__funptr)(handle,m,n,A,lda,tau,work,lwork,devInfo)


cdef void* _hipsolverDnSSgesv_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSSgesv_bufferSize(void * handle,int n,int nrhs,float * A,int lda,int * devIpiv,float * B,int ldb,float * X,int ldx,void * work,unsigned long * lwork):
    global _hipsolverDnSSgesv_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSSgesv_bufferSize__funptr,"hipsolverDnSSgesv_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,int *,float *,int,float *,int,void *,unsigned long *) noexcept nogil> _hipsolverDnSSgesv_bufferSize__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,work,lwork)


cdef void* _hipsolverDnDDgesv_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDDgesv_bufferSize(void * handle,int n,int nrhs,double * A,int lda,int * devIpiv,double * B,int ldb,double * X,int ldx,void * work,unsigned long * lwork):
    global _hipsolverDnDDgesv_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDDgesv_bufferSize__funptr,"hipsolverDnDDgesv_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,int *,double *,int,double *,int,void *,unsigned long *) noexcept nogil> _hipsolverDnDDgesv_bufferSize__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,work,lwork)


cdef void* _hipsolverDnCCgesv_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCCgesv_bufferSize(void * handle,int n,int nrhs,float2 * A,int lda,int * devIpiv,float2 * B,int ldb,float2 * X,int ldx,void * work,unsigned long * lwork):
    global _hipsolverDnCCgesv_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCCgesv_bufferSize__funptr,"hipsolverDnCCgesv_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,int *,float2 *,int,float2 *,int,void *,unsigned long *) noexcept nogil> _hipsolverDnCCgesv_bufferSize__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,work,lwork)


cdef void* _hipsolverDnZZgesv_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZZgesv_bufferSize(void * handle,int n,int nrhs,double2 * A,int lda,int * devIpiv,double2 * B,int ldb,double2 * X,int ldx,void * work,unsigned long * lwork):
    global _hipsolverDnZZgesv_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZZgesv_bufferSize__funptr,"hipsolverDnZZgesv_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,int *,double2 *,int,double2 *,int,void *,unsigned long *) noexcept nogil> _hipsolverDnZZgesv_bufferSize__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,work,lwork)


cdef void* _hipsolverDnSSgesv__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSSgesv(void * handle,int n,int nrhs,float * A,int lda,int * devIpiv,float * B,int ldb,float * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverDnSSgesv__funptr
    if __init_symbol(&_hipsolverDnSSgesv__funptr,"hipsolverDnSSgesv") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,int *,float *,int,float *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverDnSSgesv__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverDnDDgesv__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDDgesv(void * handle,int n,int nrhs,double * A,int lda,int * devIpiv,double * B,int ldb,double * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverDnDDgesv__funptr
    if __init_symbol(&_hipsolverDnDDgesv__funptr,"hipsolverDnDDgesv") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,int *,double *,int,double *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverDnDDgesv__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverDnCCgesv__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCCgesv(void * handle,int n,int nrhs,float2 * A,int lda,int * devIpiv,float2 * B,int ldb,float2 * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverDnCCgesv__funptr
    if __init_symbol(&_hipsolverDnCCgesv__funptr,"hipsolverDnCCgesv") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,int *,float2 *,int,float2 *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverDnCCgesv__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverDnZZgesv__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZZgesv(void * handle,int n,int nrhs,double2 * A,int lda,int * devIpiv,double2 * B,int ldb,double2 * X,int ldx,void * work,unsigned long lwork,int * niters,int * devInfo):
    global _hipsolverDnZZgesv__funptr
    if __init_symbol(&_hipsolverDnZZgesv__funptr,"hipsolverDnZZgesv") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,int *,double2 *,int,double2 *,int,void *,unsigned long,int *,int *) noexcept nogil> _hipsolverDnZZgesv__funptr)(handle,n,nrhs,A,lda,devIpiv,B,ldb,X,ldx,work,lwork,niters,devInfo)


cdef void* _hipsolverDnSgesvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgesvd_bufferSize(void * handle,int m,int n,int * lwork):
    global _hipsolverDnSgesvd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSgesvd_bufferSize__funptr,"hipsolverDnSgesvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int *) noexcept nogil> _hipsolverDnSgesvd_bufferSize__funptr)(handle,m,n,lwork)


cdef void* _hipsolverDnDgesvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgesvd_bufferSize(void * handle,int m,int n,int * lwork):
    global _hipsolverDnDgesvd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDgesvd_bufferSize__funptr,"hipsolverDnDgesvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int *) noexcept nogil> _hipsolverDnDgesvd_bufferSize__funptr)(handle,m,n,lwork)


cdef void* _hipsolverDnCgesvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgesvd_bufferSize(void * handle,int m,int n,int * lwork):
    global _hipsolverDnCgesvd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCgesvd_bufferSize__funptr,"hipsolverDnCgesvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int *) noexcept nogil> _hipsolverDnCgesvd_bufferSize__funptr)(handle,m,n,lwork)


cdef void* _hipsolverDnZgesvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgesvd_bufferSize(void * handle,int m,int n,int * lwork):
    global _hipsolverDnZgesvd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZgesvd_bufferSize__funptr,"hipsolverDnZgesvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,int *) noexcept nogil> _hipsolverDnZgesvd_bufferSize__funptr)(handle,m,n,lwork)


cdef void* _hipsolverDnSgesvd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgesvd(void * handle,signed char jobu,signed char jobv,int m,int n,float * A,int lda,float * S,float * U,int ldu,float * V,int ldv,float * work,int lwork,float * rwork,int * devInfo):
    global _hipsolverDnSgesvd__funptr
    if __init_symbol(&_hipsolverDnSgesvd__funptr,"hipsolverDnSgesvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,signed char,signed char,int,int,float *,int,float *,float *,int,float *,int,float *,int,float *,int *) noexcept nogil> _hipsolverDnSgesvd__funptr)(handle,jobu,jobv,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,rwork,devInfo)


cdef void* _hipsolverDnDgesvd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgesvd(void * handle,signed char jobu,signed char jobv,int m,int n,double * A,int lda,double * S,double * U,int ldu,double * V,int ldv,double * work,int lwork,double * rwork,int * devInfo):
    global _hipsolverDnDgesvd__funptr
    if __init_symbol(&_hipsolverDnDgesvd__funptr,"hipsolverDnDgesvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,signed char,signed char,int,int,double *,int,double *,double *,int,double *,int,double *,int,double *,int *) noexcept nogil> _hipsolverDnDgesvd__funptr)(handle,jobu,jobv,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,rwork,devInfo)


cdef void* _hipsolverDnCgesvd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgesvd(void * handle,signed char jobu,signed char jobv,int m,int n,float2 * A,int lda,float * S,float2 * U,int ldu,float2 * V,int ldv,float2 * work,int lwork,float * rwork,int * devInfo):
    global _hipsolverDnCgesvd__funptr
    if __init_symbol(&_hipsolverDnCgesvd__funptr,"hipsolverDnCgesvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,signed char,signed char,int,int,float2 *,int,float *,float2 *,int,float2 *,int,float2 *,int,float *,int *) noexcept nogil> _hipsolverDnCgesvd__funptr)(handle,jobu,jobv,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,rwork,devInfo)


cdef void* _hipsolverDnZgesvd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgesvd(void * handle,signed char jobu,signed char jobv,int m,int n,double2 * A,int lda,double * S,double2 * U,int ldu,double2 * V,int ldv,double2 * work,int lwork,double * rwork,int * devInfo):
    global _hipsolverDnZgesvd__funptr
    if __init_symbol(&_hipsolverDnZgesvd__funptr,"hipsolverDnZgesvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,signed char,signed char,int,int,double2 *,int,double *,double2 *,int,double2 *,int,double2 *,int,double *,int *) noexcept nogil> _hipsolverDnZgesvd__funptr)(handle,jobu,jobv,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,rwork,devInfo)


cdef void* _hipsolverDnSgesvdj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgesvdj_bufferSize(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,const float * A,int lda,const float * S,const float * U,int ldu,const float * V,int ldv,int * lwork,void * params):
    global _hipsolverDnSgesvdj_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSgesvdj_bufferSize__funptr,"hipsolverDnSgesvdj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,const float *,int,const float *,const float *,int,const float *,int,int *,void *) noexcept nogil> _hipsolverDnSgesvdj_bufferSize__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,lwork,params)


cdef void* _hipsolverDnDgesvdj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgesvdj_bufferSize(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,const double * A,int lda,const double * S,const double * U,int ldu,const double * V,int ldv,int * lwork,void * params):
    global _hipsolverDnDgesvdj_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDgesvdj_bufferSize__funptr,"hipsolverDnDgesvdj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,const double *,int,const double *,const double *,int,const double *,int,int *,void *) noexcept nogil> _hipsolverDnDgesvdj_bufferSize__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,lwork,params)


cdef void* _hipsolverDnCgesvdj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgesvdj_bufferSize(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,float2 * A,int lda,const float * S,float2 * U,int ldu,float2 * V,int ldv,int * lwork,void * params):
    global _hipsolverDnCgesvdj_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCgesvdj_bufferSize__funptr,"hipsolverDnCgesvdj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,float2 *,int,const float *,float2 *,int,float2 *,int,int *,void *) noexcept nogil> _hipsolverDnCgesvdj_bufferSize__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,lwork,params)


cdef void* _hipsolverDnZgesvdj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgesvdj_bufferSize(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,double2 * A,int lda,const double * S,double2 * U,int ldu,double2 * V,int ldv,int * lwork,void * params):
    global _hipsolverDnZgesvdj_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZgesvdj_bufferSize__funptr,"hipsolverDnZgesvdj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,double2 *,int,const double *,double2 *,int,double2 *,int,int *,void *) noexcept nogil> _hipsolverDnZgesvdj_bufferSize__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,lwork,params)


cdef void* _hipsolverDnSgesvdj__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgesvdj(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,float * A,int lda,float * S,float * U,int ldu,float * V,int ldv,float * work,int lwork,int * devInfo,void * params):
    global _hipsolverDnSgesvdj__funptr
    if __init_symbol(&_hipsolverDnSgesvdj__funptr,"hipsolverDnSgesvdj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,float *,int,float *,float *,int,float *,int,float *,int,int *,void *) noexcept nogil> _hipsolverDnSgesvdj__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params)


cdef void* _hipsolverDnDgesvdj__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgesvdj(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,double * A,int lda,double * S,double * U,int ldu,double * V,int ldv,double * work,int lwork,int * devInfo,void * params):
    global _hipsolverDnDgesvdj__funptr
    if __init_symbol(&_hipsolverDnDgesvdj__funptr,"hipsolverDnDgesvdj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,double *,int,double *,double *,int,double *,int,double *,int,int *,void *) noexcept nogil> _hipsolverDnDgesvdj__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params)


cdef void* _hipsolverDnCgesvdj__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgesvdj(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,float2 * A,int lda,float * S,float2 * U,int ldu,float2 * V,int ldv,float2 * work,int lwork,int * devInfo,void * params):
    global _hipsolverDnCgesvdj__funptr
    if __init_symbol(&_hipsolverDnCgesvdj__funptr,"hipsolverDnCgesvdj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,float2 *,int,float *,float2 *,int,float2 *,int,float2 *,int,int *,void *) noexcept nogil> _hipsolverDnCgesvdj__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params)


cdef void* _hipsolverDnZgesvdj__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgesvdj(void * handle,hipsolverEigMode_t jobz,int econ,int m,int n,double2 * A,int lda,double * S,double2 * U,int ldu,double2 * V,int ldv,double2 * work,int lwork,int * devInfo,void * params):
    global _hipsolverDnZgesvdj__funptr
    if __init_symbol(&_hipsolverDnZgesvdj__funptr,"hipsolverDnZgesvdj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,double2 *,int,double *,double2 *,int,double2 *,int,double2 *,int,int *,void *) noexcept nogil> _hipsolverDnZgesvdj__funptr)(handle,jobz,econ,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params)


cdef void* _hipsolverDnSgesvdjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgesvdjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,int m,int n,const float * A,int lda,const float * S,const float * U,int ldu,const float * V,int ldv,int * lwork,void * params,int batch_count):
    global _hipsolverDnSgesvdjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSgesvdjBatched_bufferSize__funptr,"hipsolverDnSgesvdjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,const float *,int,const float *,const float *,int,const float *,int,int *,void *,int) noexcept nogil> _hipsolverDnSgesvdjBatched_bufferSize__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,lwork,params,batch_count)


cdef void* _hipsolverDnDgesvdjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgesvdjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,int m,int n,const double * A,int lda,const double * S,const double * U,int ldu,const double * V,int ldv,int * lwork,void * params,int batch_count):
    global _hipsolverDnDgesvdjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDgesvdjBatched_bufferSize__funptr,"hipsolverDnDgesvdjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,const double *,int,const double *,const double *,int,const double *,int,int *,void *,int) noexcept nogil> _hipsolverDnDgesvdjBatched_bufferSize__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,lwork,params,batch_count)


cdef void* _hipsolverDnCgesvdjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgesvdjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,int m,int n,float2 * A,int lda,const float * S,float2 * U,int ldu,float2 * V,int ldv,int * lwork,void * params,int batch_count):
    global _hipsolverDnCgesvdjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCgesvdjBatched_bufferSize__funptr,"hipsolverDnCgesvdjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,float2 *,int,const float *,float2 *,int,float2 *,int,int *,void *,int) noexcept nogil> _hipsolverDnCgesvdjBatched_bufferSize__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,lwork,params,batch_count)


cdef void* _hipsolverDnZgesvdjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgesvdjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,int m,int n,double2 * A,int lda,const double * S,double2 * U,int ldu,double2 * V,int ldv,int * lwork,void * params,int batch_count):
    global _hipsolverDnZgesvdjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZgesvdjBatched_bufferSize__funptr,"hipsolverDnZgesvdjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,double2 *,int,const double *,double2 *,int,double2 *,int,int *,void *,int) noexcept nogil> _hipsolverDnZgesvdjBatched_bufferSize__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,lwork,params,batch_count)


cdef void* _hipsolverDnSgesvdjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgesvdjBatched(void * handle,hipsolverEigMode_t jobz,int m,int n,float * A,int lda,float * S,float * U,int ldu,float * V,int ldv,float * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverDnSgesvdjBatched__funptr
    if __init_symbol(&_hipsolverDnSgesvdjBatched__funptr,"hipsolverDnSgesvdjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,float *,int,float *,float *,int,float *,int,float *,int,int *,void *,int) noexcept nogil> _hipsolverDnSgesvdjBatched__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverDnDgesvdjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgesvdjBatched(void * handle,hipsolverEigMode_t jobz,int m,int n,double * A,int lda,double * S,double * U,int ldu,double * V,int ldv,double * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverDnDgesvdjBatched__funptr
    if __init_symbol(&_hipsolverDnDgesvdjBatched__funptr,"hipsolverDnDgesvdjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,double *,int,double *,double *,int,double *,int,double *,int,int *,void *,int) noexcept nogil> _hipsolverDnDgesvdjBatched__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverDnCgesvdjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgesvdjBatched(void * handle,hipsolverEigMode_t jobz,int m,int n,float2 * A,int lda,float * S,float2 * U,int ldu,float2 * V,int ldv,float2 * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverDnCgesvdjBatched__funptr
    if __init_symbol(&_hipsolverDnCgesvdjBatched__funptr,"hipsolverDnCgesvdjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,float2 *,int,float *,float2 *,int,float2 *,int,float2 *,int,int *,void *,int) noexcept nogil> _hipsolverDnCgesvdjBatched__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverDnZgesvdjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgesvdjBatched(void * handle,hipsolverEigMode_t jobz,int m,int n,double2 * A,int lda,double * S,double2 * U,int ldu,double2 * V,int ldv,double2 * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverDnZgesvdjBatched__funptr
    if __init_symbol(&_hipsolverDnZgesvdjBatched__funptr,"hipsolverDnZgesvdjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,double2 *,int,double *,double2 *,int,double2 *,int,double2 *,int,int *,void *,int) noexcept nogil> _hipsolverDnZgesvdjBatched__funptr)(handle,jobz,m,n,A,lda,S,U,ldu,V,ldv,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverDnSgesvdaStridedBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgesvdaStridedBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,int rank,int m,int n,const float * A,int lda,long long strideA,const float * S,long long strideS,const float * U,int ldu,long long strideU,const float * V,int ldv,long long strideV,int * lwork,int batch_count):
    global _hipsolverDnSgesvdaStridedBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSgesvdaStridedBatched_bufferSize__funptr,"hipsolverDnSgesvdaStridedBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,const float *,int,long long,const float *,long long,const float *,int,long long,const float *,int,long long,int *,int) noexcept nogil> _hipsolverDnSgesvdaStridedBatched_bufferSize__funptr)(handle,jobz,rank,m,n,A,lda,strideA,S,strideS,U,ldu,strideU,V,ldv,strideV,lwork,batch_count)


cdef void* _hipsolverDnDgesvdaStridedBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgesvdaStridedBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,int rank,int m,int n,const double * A,int lda,long long strideA,const double * S,long long strideS,const double * U,int ldu,long long strideU,const double * V,int ldv,long long strideV,int * lwork,int batch_count):
    global _hipsolverDnDgesvdaStridedBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDgesvdaStridedBatched_bufferSize__funptr,"hipsolverDnDgesvdaStridedBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,const double *,int,long long,const double *,long long,const double *,int,long long,const double *,int,long long,int *,int) noexcept nogil> _hipsolverDnDgesvdaStridedBatched_bufferSize__funptr)(handle,jobz,rank,m,n,A,lda,strideA,S,strideS,U,ldu,strideU,V,ldv,strideV,lwork,batch_count)


cdef void* _hipsolverDnCgesvdaStridedBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgesvdaStridedBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,int rank,int m,int n,float2 * A,int lda,long long strideA,const float * S,long long strideS,float2 * U,int ldu,long long strideU,float2 * V,int ldv,long long strideV,int * lwork,int batch_count):
    global _hipsolverDnCgesvdaStridedBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCgesvdaStridedBatched_bufferSize__funptr,"hipsolverDnCgesvdaStridedBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,float2 *,int,long long,const float *,long long,float2 *,int,long long,float2 *,int,long long,int *,int) noexcept nogil> _hipsolverDnCgesvdaStridedBatched_bufferSize__funptr)(handle,jobz,rank,m,n,A,lda,strideA,S,strideS,U,ldu,strideU,V,ldv,strideV,lwork,batch_count)


cdef void* _hipsolverDnZgesvdaStridedBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgesvdaStridedBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,int rank,int m,int n,double2 * A,int lda,long long strideA,const double * S,long long strideS,double2 * U,int ldu,long long strideU,double2 * V,int ldv,long long strideV,int * lwork,int batch_count):
    global _hipsolverDnZgesvdaStridedBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZgesvdaStridedBatched_bufferSize__funptr,"hipsolverDnZgesvdaStridedBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,double2 *,int,long long,const double *,long long,double2 *,int,long long,double2 *,int,long long,int *,int) noexcept nogil> _hipsolverDnZgesvdaStridedBatched_bufferSize__funptr)(handle,jobz,rank,m,n,A,lda,strideA,S,strideS,U,ldu,strideU,V,ldv,strideV,lwork,batch_count)


cdef void* _hipsolverDnSgesvdaStridedBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgesvdaStridedBatched(void * handle,hipsolverEigMode_t jobz,int rank,int m,int n,const float * A,int lda,long long strideA,float * S,long long strideS,float * U,int ldu,long long strideU,float * V,int ldv,long long strideV,float * work,int lwork,int * devInfo,double * hRnrmF,int batch_count):
    global _hipsolverDnSgesvdaStridedBatched__funptr
    if __init_symbol(&_hipsolverDnSgesvdaStridedBatched__funptr,"hipsolverDnSgesvdaStridedBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,const float *,int,long long,float *,long long,float *,int,long long,float *,int,long long,float *,int,int *,double *,int) noexcept nogil> _hipsolverDnSgesvdaStridedBatched__funptr)(handle,jobz,rank,m,n,A,lda,strideA,S,strideS,U,ldu,strideU,V,ldv,strideV,work,lwork,devInfo,hRnrmF,batch_count)


cdef void* _hipsolverDnDgesvdaStridedBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgesvdaStridedBatched(void * handle,hipsolverEigMode_t jobz,int rank,int m,int n,const double * A,int lda,long long strideA,double * S,long long strideS,double * U,int ldu,long long strideU,double * V,int ldv,long long strideV,double * work,int lwork,int * devInfo,double * hRnrmF,int batch_count):
    global _hipsolverDnDgesvdaStridedBatched__funptr
    if __init_symbol(&_hipsolverDnDgesvdaStridedBatched__funptr,"hipsolverDnDgesvdaStridedBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,const double *,int,long long,double *,long long,double *,int,long long,double *,int,long long,double *,int,int *,double *,int) noexcept nogil> _hipsolverDnDgesvdaStridedBatched__funptr)(handle,jobz,rank,m,n,A,lda,strideA,S,strideS,U,ldu,strideU,V,ldv,strideV,work,lwork,devInfo,hRnrmF,batch_count)


cdef void* _hipsolverDnCgesvdaStridedBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgesvdaStridedBatched(void * handle,hipsolverEigMode_t jobz,int rank,int m,int n,float2 * A,int lda,long long strideA,float * S,long long strideS,float2 * U,int ldu,long long strideU,float2 * V,int ldv,long long strideV,float2 * work,int lwork,int * devInfo,double * hRnrmF,int batch_count):
    global _hipsolverDnCgesvdaStridedBatched__funptr
    if __init_symbol(&_hipsolverDnCgesvdaStridedBatched__funptr,"hipsolverDnCgesvdaStridedBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,float2 *,int,long long,float *,long long,float2 *,int,long long,float2 *,int,long long,float2 *,int,int *,double *,int) noexcept nogil> _hipsolverDnCgesvdaStridedBatched__funptr)(handle,jobz,rank,m,n,A,lda,strideA,S,strideS,U,ldu,strideU,V,ldv,strideV,work,lwork,devInfo,hRnrmF,batch_count)


cdef void* _hipsolverDnZgesvdaStridedBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgesvdaStridedBatched(void * handle,hipsolverEigMode_t jobz,int rank,int m,int n,double2 * A,int lda,long long strideA,double * S,long long strideS,double2 * U,int ldu,long long strideU,double2 * V,int ldv,long long strideV,double2 * work,int lwork,int * devInfo,double * hRnrmF,int batch_count):
    global _hipsolverDnZgesvdaStridedBatched__funptr
    if __init_symbol(&_hipsolverDnZgesvdaStridedBatched__funptr,"hipsolverDnZgesvdaStridedBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,int,int,int,double2 *,int,long long,double *,long long,double2 *,int,long long,double2 *,int,long long,double2 *,int,int *,double *,int) noexcept nogil> _hipsolverDnZgesvdaStridedBatched__funptr)(handle,jobz,rank,m,n,A,lda,strideA,S,strideS,U,ldu,strideU,V,ldv,strideV,work,lwork,devInfo,hRnrmF,batch_count)


cdef void* _hipsolverDnSgetrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgetrf_bufferSize(void * handle,int m,int n,float * A,int lda,int * lwork):
    global _hipsolverDnSgetrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSgetrf_bufferSize__funptr,"hipsolverDnSgetrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,int *) noexcept nogil> _hipsolverDnSgetrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverDnDgetrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgetrf_bufferSize(void * handle,int m,int n,double * A,int lda,int * lwork):
    global _hipsolverDnDgetrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDgetrf_bufferSize__funptr,"hipsolverDnDgetrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,int *) noexcept nogil> _hipsolverDnDgetrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverDnCgetrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgetrf_bufferSize(void * handle,int m,int n,float2 * A,int lda,int * lwork):
    global _hipsolverDnCgetrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCgetrf_bufferSize__funptr,"hipsolverDnCgetrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,int *) noexcept nogil> _hipsolverDnCgetrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverDnZgetrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgetrf_bufferSize(void * handle,int m,int n,double2 * A,int lda,int * lwork):
    global _hipsolverDnZgetrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZgetrf_bufferSize__funptr,"hipsolverDnZgetrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,int *) noexcept nogil> _hipsolverDnZgetrf_bufferSize__funptr)(handle,m,n,A,lda,lwork)


cdef void* _hipsolverDnSgetrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgetrf(void * handle,int m,int n,float * A,int lda,float * work,int * devIpiv,int * devInfo):
    global _hipsolverDnSgetrf__funptr
    if __init_symbol(&_hipsolverDnSgetrf__funptr,"hipsolverDnSgetrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float *,int,float *,int *,int *) noexcept nogil> _hipsolverDnSgetrf__funptr)(handle,m,n,A,lda,work,devIpiv,devInfo)


cdef void* _hipsolverDnDgetrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgetrf(void * handle,int m,int n,double * A,int lda,double * work,int * devIpiv,int * devInfo):
    global _hipsolverDnDgetrf__funptr
    if __init_symbol(&_hipsolverDnDgetrf__funptr,"hipsolverDnDgetrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double *,int,double *,int *,int *) noexcept nogil> _hipsolverDnDgetrf__funptr)(handle,m,n,A,lda,work,devIpiv,devInfo)


cdef void* _hipsolverDnCgetrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgetrf(void * handle,int m,int n,float2 * A,int lda,float2 * work,int * devIpiv,int * devInfo):
    global _hipsolverDnCgetrf__funptr
    if __init_symbol(&_hipsolverDnCgetrf__funptr,"hipsolverDnCgetrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,float2 *,int,float2 *,int *,int *) noexcept nogil> _hipsolverDnCgetrf__funptr)(handle,m,n,A,lda,work,devIpiv,devInfo)


cdef void* _hipsolverDnZgetrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgetrf(void * handle,int m,int n,double2 * A,int lda,double2 * work,int * devIpiv,int * devInfo):
    global _hipsolverDnZgetrf__funptr
    if __init_symbol(&_hipsolverDnZgetrf__funptr,"hipsolverDnZgetrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,double2 *,int,double2 *,int *,int *) noexcept nogil> _hipsolverDnZgetrf__funptr)(handle,m,n,A,lda,work,devIpiv,devInfo)


cdef void* _hipsolverDnSgetrs__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSgetrs(void * handle,hipblasOperation_t trans,int n,int nrhs,const float * A,int lda,const int * devIpiv,float * B,int ldb,int * devInfo):
    global _hipsolverDnSgetrs__funptr
    if __init_symbol(&_hipsolverDnSgetrs__funptr,"hipsolverDnSgetrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasOperation_t,int,int,const float *,int,const int *,float *,int,int *) noexcept nogil> _hipsolverDnSgetrs__funptr)(handle,trans,n,nrhs,A,lda,devIpiv,B,ldb,devInfo)


cdef void* _hipsolverDnDgetrs__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDgetrs(void * handle,hipblasOperation_t trans,int n,int nrhs,const double * A,int lda,const int * devIpiv,double * B,int ldb,int * devInfo):
    global _hipsolverDnDgetrs__funptr
    if __init_symbol(&_hipsolverDnDgetrs__funptr,"hipsolverDnDgetrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasOperation_t,int,int,const double *,int,const int *,double *,int,int *) noexcept nogil> _hipsolverDnDgetrs__funptr)(handle,trans,n,nrhs,A,lda,devIpiv,B,ldb,devInfo)


cdef void* _hipsolverDnCgetrs__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCgetrs(void * handle,hipblasOperation_t trans,int n,int nrhs,float2 * A,int lda,const int * devIpiv,float2 * B,int ldb,int * devInfo):
    global _hipsolverDnCgetrs__funptr
    if __init_symbol(&_hipsolverDnCgetrs__funptr,"hipsolverDnCgetrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasOperation_t,int,int,float2 *,int,const int *,float2 *,int,int *) noexcept nogil> _hipsolverDnCgetrs__funptr)(handle,trans,n,nrhs,A,lda,devIpiv,B,ldb,devInfo)


cdef void* _hipsolverDnZgetrs__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZgetrs(void * handle,hipblasOperation_t trans,int n,int nrhs,double2 * A,int lda,const int * devIpiv,double2 * B,int ldb,int * devInfo):
    global _hipsolverDnZgetrs__funptr
    if __init_symbol(&_hipsolverDnZgetrs__funptr,"hipsolverDnZgetrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasOperation_t,int,int,double2 *,int,const int *,double2 *,int,int *) noexcept nogil> _hipsolverDnZgetrs__funptr)(handle,trans,n,nrhs,A,lda,devIpiv,B,ldb,devInfo)


cdef void* _hipsolverDnSpotrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSpotrf_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,int * lwork):
    global _hipsolverDnSpotrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSpotrf_bufferSize__funptr,"hipsolverDnSpotrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,int *) noexcept nogil> _hipsolverDnSpotrf_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverDnDpotrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDpotrf_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,int * lwork):
    global _hipsolverDnDpotrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDpotrf_bufferSize__funptr,"hipsolverDnDpotrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,int *) noexcept nogil> _hipsolverDnDpotrf_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverDnCpotrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCpotrf_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,int * lwork):
    global _hipsolverDnCpotrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCpotrf_bufferSize__funptr,"hipsolverDnCpotrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,int *) noexcept nogil> _hipsolverDnCpotrf_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverDnZpotrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZpotrf_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,int * lwork):
    global _hipsolverDnZpotrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZpotrf_bufferSize__funptr,"hipsolverDnZpotrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,int *) noexcept nogil> _hipsolverDnZpotrf_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverDnSpotrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSpotrf(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,float * work,int lwork,int * devInfo):
    global _hipsolverDnSpotrf__funptr
    if __init_symbol(&_hipsolverDnSpotrf__funptr,"hipsolverDnSpotrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,float *,int,int *) noexcept nogil> _hipsolverDnSpotrf__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverDnDpotrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDpotrf(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,double * work,int lwork,int * devInfo):
    global _hipsolverDnDpotrf__funptr
    if __init_symbol(&_hipsolverDnDpotrf__funptr,"hipsolverDnDpotrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,double *,int,int *) noexcept nogil> _hipsolverDnDpotrf__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverDnCpotrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCpotrf(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnCpotrf__funptr
    if __init_symbol(&_hipsolverDnCpotrf__funptr,"hipsolverDnCpotrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,float2 *,int,int *) noexcept nogil> _hipsolverDnCpotrf__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverDnZpotrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZpotrf(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZpotrf__funptr
    if __init_symbol(&_hipsolverDnZpotrf__funptr,"hipsolverDnZpotrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,double2 *,int,int *) noexcept nogil> _hipsolverDnZpotrf__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverDnSpotrfBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSpotrfBatched(void * handle,hipblasFillMode_t uplo,int n,float ** A,int lda,int * devInfo,int batch_count):
    global _hipsolverDnSpotrfBatched__funptr
    if __init_symbol(&_hipsolverDnSpotrfBatched__funptr,"hipsolverDnSpotrfBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float **,int,int *,int) noexcept nogil> _hipsolverDnSpotrfBatched__funptr)(handle,uplo,n,A,lda,devInfo,batch_count)


cdef void* _hipsolverDnDpotrfBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDpotrfBatched(void * handle,hipblasFillMode_t uplo,int n,double ** A,int lda,int * devInfo,int batch_count):
    global _hipsolverDnDpotrfBatched__funptr
    if __init_symbol(&_hipsolverDnDpotrfBatched__funptr,"hipsolverDnDpotrfBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double **,int,int *,int) noexcept nogil> _hipsolverDnDpotrfBatched__funptr)(handle,uplo,n,A,lda,devInfo,batch_count)


cdef void* _hipsolverDnCpotrfBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCpotrfBatched(void * handle,hipblasFillMode_t uplo,int n,float2 ** A,int lda,int * devInfo,int batch_count):
    global _hipsolverDnCpotrfBatched__funptr
    if __init_symbol(&_hipsolverDnCpotrfBatched__funptr,"hipsolverDnCpotrfBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 **,int,int *,int) noexcept nogil> _hipsolverDnCpotrfBatched__funptr)(handle,uplo,n,A,lda,devInfo,batch_count)


cdef void* _hipsolverDnZpotrfBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZpotrfBatched(void * handle,hipblasFillMode_t uplo,int n,double2 ** A,int lda,int * devInfo,int batch_count):
    global _hipsolverDnZpotrfBatched__funptr
    if __init_symbol(&_hipsolverDnZpotrfBatched__funptr,"hipsolverDnZpotrfBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 **,int,int *,int) noexcept nogil> _hipsolverDnZpotrfBatched__funptr)(handle,uplo,n,A,lda,devInfo,batch_count)


cdef void* _hipsolverDnSpotri_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSpotri_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,int * lwork):
    global _hipsolverDnSpotri_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSpotri_bufferSize__funptr,"hipsolverDnSpotri_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,int *) noexcept nogil> _hipsolverDnSpotri_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverDnDpotri_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDpotri_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,int * lwork):
    global _hipsolverDnDpotri_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDpotri_bufferSize__funptr,"hipsolverDnDpotri_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,int *) noexcept nogil> _hipsolverDnDpotri_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverDnCpotri_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCpotri_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,int * lwork):
    global _hipsolverDnCpotri_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCpotri_bufferSize__funptr,"hipsolverDnCpotri_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,int *) noexcept nogil> _hipsolverDnCpotri_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverDnZpotri_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZpotri_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,int * lwork):
    global _hipsolverDnZpotri_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZpotri_bufferSize__funptr,"hipsolverDnZpotri_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,int *) noexcept nogil> _hipsolverDnZpotri_bufferSize__funptr)(handle,uplo,n,A,lda,lwork)


cdef void* _hipsolverDnSpotri__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSpotri(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,float * work,int lwork,int * devInfo):
    global _hipsolverDnSpotri__funptr
    if __init_symbol(&_hipsolverDnSpotri__funptr,"hipsolverDnSpotri") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,float *,int,int *) noexcept nogil> _hipsolverDnSpotri__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverDnDpotri__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDpotri(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,double * work,int lwork,int * devInfo):
    global _hipsolverDnDpotri__funptr
    if __init_symbol(&_hipsolverDnDpotri__funptr,"hipsolverDnDpotri") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,double *,int,int *) noexcept nogil> _hipsolverDnDpotri__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverDnCpotri__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCpotri(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnCpotri__funptr
    if __init_symbol(&_hipsolverDnCpotri__funptr,"hipsolverDnCpotri") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,float2 *,int,int *) noexcept nogil> _hipsolverDnCpotri__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverDnZpotri__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZpotri(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZpotri__funptr
    if __init_symbol(&_hipsolverDnZpotri__funptr,"hipsolverDnZpotri") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,double2 *,int,int *) noexcept nogil> _hipsolverDnZpotri__funptr)(handle,uplo,n,A,lda,work,lwork,devInfo)


cdef void* _hipsolverDnSpotrs__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSpotrs(void * handle,hipblasFillMode_t uplo,int n,int nrhs,const float * A,int lda,float * B,int ldb,int * devInfo):
    global _hipsolverDnSpotrs__funptr
    if __init_symbol(&_hipsolverDnSpotrs__funptr,"hipsolverDnSpotrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,const float *,int,float *,int,int *) noexcept nogil> _hipsolverDnSpotrs__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,devInfo)


cdef void* _hipsolverDnDpotrs__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDpotrs(void * handle,hipblasFillMode_t uplo,int n,int nrhs,const double * A,int lda,double * B,int ldb,int * devInfo):
    global _hipsolverDnDpotrs__funptr
    if __init_symbol(&_hipsolverDnDpotrs__funptr,"hipsolverDnDpotrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,const double *,int,double *,int,int *) noexcept nogil> _hipsolverDnDpotrs__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,devInfo)


cdef void* _hipsolverDnCpotrs__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCpotrs(void * handle,hipblasFillMode_t uplo,int n,int nrhs,float2 * A,int lda,float2 * B,int ldb,int * devInfo):
    global _hipsolverDnCpotrs__funptr
    if __init_symbol(&_hipsolverDnCpotrs__funptr,"hipsolverDnCpotrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,float2 *,int,float2 *,int,int *) noexcept nogil> _hipsolverDnCpotrs__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,devInfo)


cdef void* _hipsolverDnZpotrs__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZpotrs(void * handle,hipblasFillMode_t uplo,int n,int nrhs,double2 * A,int lda,double2 * B,int ldb,int * devInfo):
    global _hipsolverDnZpotrs__funptr
    if __init_symbol(&_hipsolverDnZpotrs__funptr,"hipsolverDnZpotrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,double2 *,int,double2 *,int,int *) noexcept nogil> _hipsolverDnZpotrs__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,devInfo)


cdef void* _hipsolverDnSpotrsBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSpotrsBatched(void * handle,hipblasFillMode_t uplo,int n,int nrhs,float ** A,int lda,float ** B,int ldb,int * devInfo,int batch_count):
    global _hipsolverDnSpotrsBatched__funptr
    if __init_symbol(&_hipsolverDnSpotrsBatched__funptr,"hipsolverDnSpotrsBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,float **,int,float **,int,int *,int) noexcept nogil> _hipsolverDnSpotrsBatched__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,devInfo,batch_count)


cdef void* _hipsolverDnDpotrsBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDpotrsBatched(void * handle,hipblasFillMode_t uplo,int n,int nrhs,double ** A,int lda,double ** B,int ldb,int * devInfo,int batch_count):
    global _hipsolverDnDpotrsBatched__funptr
    if __init_symbol(&_hipsolverDnDpotrsBatched__funptr,"hipsolverDnDpotrsBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,double **,int,double **,int,int *,int) noexcept nogil> _hipsolverDnDpotrsBatched__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,devInfo,batch_count)


cdef void* _hipsolverDnCpotrsBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCpotrsBatched(void * handle,hipblasFillMode_t uplo,int n,int nrhs,float2 ** A,int lda,float2 ** B,int ldb,int * devInfo,int batch_count):
    global _hipsolverDnCpotrsBatched__funptr
    if __init_symbol(&_hipsolverDnCpotrsBatched__funptr,"hipsolverDnCpotrsBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,float2 **,int,float2 **,int,int *,int) noexcept nogil> _hipsolverDnCpotrsBatched__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,devInfo,batch_count)


cdef void* _hipsolverDnZpotrsBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZpotrsBatched(void * handle,hipblasFillMode_t uplo,int n,int nrhs,double2 ** A,int lda,double2 ** B,int ldb,int * devInfo,int batch_count):
    global _hipsolverDnZpotrsBatched__funptr
    if __init_symbol(&_hipsolverDnZpotrsBatched__funptr,"hipsolverDnZpotrsBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,int,double2 **,int,double2 **,int,int *,int) noexcept nogil> _hipsolverDnZpotrsBatched__funptr)(handle,uplo,n,nrhs,A,lda,B,ldb,devInfo,batch_count)


cdef void* _hipsolverDnSsyevd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsyevd_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,const float * A,int lda,const float * W,int * lwork):
    global _hipsolverDnSsyevd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSsyevd_bufferSize__funptr,"hipsolverDnSsyevd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,const float *,int,const float *,int *) noexcept nogil> _hipsolverDnSsyevd_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork)


cdef void* _hipsolverDnDsyevd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsyevd_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,const double * A,int lda,const double * W,int * lwork):
    global _hipsolverDnDsyevd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDsyevd_bufferSize__funptr,"hipsolverDnDsyevd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,const double *,int,const double *,int *) noexcept nogil> _hipsolverDnDsyevd_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork)


cdef void* _hipsolverDnCheevd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCheevd_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,const float * W,int * lwork):
    global _hipsolverDnCheevd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCheevd_bufferSize__funptr,"hipsolverDnCheevd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,const float *,int *) noexcept nogil> _hipsolverDnCheevd_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork)


cdef void* _hipsolverDnZheevd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZheevd_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,const double * W,int * lwork):
    global _hipsolverDnZheevd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZheevd_bufferSize__funptr,"hipsolverDnZheevd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,const double *,int *) noexcept nogil> _hipsolverDnZheevd_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork)


cdef void* _hipsolverDnSsyevd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsyevd(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * W,float * work,int lwork,int * devInfo):
    global _hipsolverDnSsyevd__funptr
    if __init_symbol(&_hipsolverDnSsyevd__funptr,"hipsolverDnSsyevd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,float *,int,int *) noexcept nogil> _hipsolverDnSsyevd__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo)


cdef void* _hipsolverDnDsyevd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsyevd(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * W,double * work,int lwork,int * devInfo):
    global _hipsolverDnDsyevd__funptr
    if __init_symbol(&_hipsolverDnDsyevd__funptr,"hipsolverDnDsyevd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,double *,int,int *) noexcept nogil> _hipsolverDnDsyevd__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo)


cdef void* _hipsolverDnCheevd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCheevd(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float * W,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnCheevd__funptr
    if __init_symbol(&_hipsolverDnCheevd__funptr,"hipsolverDnCheevd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float *,float2 *,int,int *) noexcept nogil> _hipsolverDnCheevd__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo)


cdef void* _hipsolverDnZheevd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZheevd(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double * W,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZheevd__funptr
    if __init_symbol(&_hipsolverDnZheevd__funptr,"hipsolverDnZheevd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double *,double2 *,int,int *) noexcept nogil> _hipsolverDnZheevd__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo)


cdef void* _hipsolverDnSsyevdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsyevdx_bufferSize(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,const float * A,int lda,float vl,float vu,int il,int iu,int * nev,const float * W,int * lwork):
    global _hipsolverDnSsyevdx_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSsyevdx_bufferSize__funptr,"hipsolverDnSsyevdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,const float *,int,float,float,int,int,int *,const float *,int *) noexcept nogil> _hipsolverDnSsyevdx_bufferSize__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverDnDsyevdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsyevdx_bufferSize(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,const double * A,int lda,double vl,double vu,int il,int iu,int * nev,const double * W,int * lwork):
    global _hipsolverDnDsyevdx_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDsyevdx_bufferSize__funptr,"hipsolverDnDsyevdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,const double *,int,double,double,int,int,int *,const double *,int *) noexcept nogil> _hipsolverDnDsyevdx_bufferSize__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverDnCheevdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCheevdx_bufferSize(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,float2 * A,int lda,float vl,float vu,int il,int iu,int * nev,const float * W,int * lwork):
    global _hipsolverDnCheevdx_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCheevdx_bufferSize__funptr,"hipsolverDnCheevdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,float2 *,int,float,float,int,int,int *,const float *,int *) noexcept nogil> _hipsolverDnCheevdx_bufferSize__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverDnZheevdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZheevdx_bufferSize(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,double2 * A,int lda,double vl,double vu,int il,int iu,int * nev,const double * W,int * lwork):
    global _hipsolverDnZheevdx_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZheevdx_bufferSize__funptr,"hipsolverDnZheevdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,double2 *,int,double,double,int,int,int *,const double *,int *) noexcept nogil> _hipsolverDnZheevdx_bufferSize__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverDnSsyevdx__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsyevdx(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,float * A,int lda,float vl,float vu,int il,int iu,int * nev,float * W,float * work,int lwork,int * devInfo):
    global _hipsolverDnSsyevdx__funptr
    if __init_symbol(&_hipsolverDnSsyevdx__funptr,"hipsolverDnSsyevdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,float *,int,float,float,int,int,int *,float *,float *,int,int *) noexcept nogil> _hipsolverDnSsyevdx__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverDnDsyevdx__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsyevdx(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,double * A,int lda,double vl,double vu,int il,int iu,int * nev,double * W,double * work,int lwork,int * devInfo):
    global _hipsolverDnDsyevdx__funptr
    if __init_symbol(&_hipsolverDnDsyevdx__funptr,"hipsolverDnDsyevdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,double *,int,double,double,int,int,int *,double *,double *,int,int *) noexcept nogil> _hipsolverDnDsyevdx__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverDnCheevdx__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCheevdx(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,float2 * A,int lda,float vl,float vu,int il,int iu,int * nev,float * W,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnCheevdx__funptr
    if __init_symbol(&_hipsolverDnCheevdx__funptr,"hipsolverDnCheevdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,float2 *,int,float,float,int,int,int *,float *,float2 *,int,int *) noexcept nogil> _hipsolverDnCheevdx__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverDnZheevdx__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZheevdx(void * handle,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,double2 * A,int lda,double vl,double vu,int il,int iu,int * nev,double * W,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZheevdx__funptr
    if __init_symbol(&_hipsolverDnZheevdx__funptr,"hipsolverDnZheevdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,double2 *,int,double,double,int,int,int *,double *,double2 *,int,int *) noexcept nogil> _hipsolverDnZheevdx__funptr)(handle,jobz,range,uplo,n,A,lda,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverDnSsyevj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsyevj_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,const float * A,int lda,const float * W,int * lwork,void * params):
    global _hipsolverDnSsyevj_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSsyevj_bufferSize__funptr,"hipsolverDnSsyevj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,const float *,int,const float *,int *,void *) noexcept nogil> _hipsolverDnSsyevj_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params)


cdef void* _hipsolverDnDsyevj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsyevj_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,const double * A,int lda,const double * W,int * lwork,void * params):
    global _hipsolverDnDsyevj_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDsyevj_bufferSize__funptr,"hipsolverDnDsyevj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,const double *,int,const double *,int *,void *) noexcept nogil> _hipsolverDnDsyevj_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params)


cdef void* _hipsolverDnCheevj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCheevj_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,const float * W,int * lwork,void * params):
    global _hipsolverDnCheevj_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCheevj_bufferSize__funptr,"hipsolverDnCheevj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,const float *,int *,void *) noexcept nogil> _hipsolverDnCheevj_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params)


cdef void* _hipsolverDnZheevj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZheevj_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,const double * W,int * lwork,void * params):
    global _hipsolverDnZheevj_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZheevj_bufferSize__funptr,"hipsolverDnZheevj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,const double *,int *,void *) noexcept nogil> _hipsolverDnZheevj_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params)


cdef void* _hipsolverDnSsyevj__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsyevj(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * W,float * work,int lwork,int * devInfo,void * params):
    global _hipsolverDnSsyevj__funptr
    if __init_symbol(&_hipsolverDnSsyevj__funptr,"hipsolverDnSsyevj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,float *,int,int *,void *) noexcept nogil> _hipsolverDnSsyevj__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params)


cdef void* _hipsolverDnDsyevj__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsyevj(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * W,double * work,int lwork,int * devInfo,void * params):
    global _hipsolverDnDsyevj__funptr
    if __init_symbol(&_hipsolverDnDsyevj__funptr,"hipsolverDnDsyevj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,double *,int,int *,void *) noexcept nogil> _hipsolverDnDsyevj__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params)


cdef void* _hipsolverDnCheevj__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCheevj(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float * W,float2 * work,int lwork,int * devInfo,void * params):
    global _hipsolverDnCheevj__funptr
    if __init_symbol(&_hipsolverDnCheevj__funptr,"hipsolverDnCheevj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float *,float2 *,int,int *,void *) noexcept nogil> _hipsolverDnCheevj__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params)


cdef void* _hipsolverDnZheevj__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZheevj(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double * W,double2 * work,int lwork,int * devInfo,void * params):
    global _hipsolverDnZheevj__funptr
    if __init_symbol(&_hipsolverDnZheevj__funptr,"hipsolverDnZheevj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double *,double2 *,int,int *,void *) noexcept nogil> _hipsolverDnZheevj__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params)


cdef void* _hipsolverDnSsyevjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsyevjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,const float * A,int lda,const float * W,int * lwork,void * params,int batch_count):
    global _hipsolverDnSsyevjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSsyevjBatched_bufferSize__funptr,"hipsolverDnSsyevjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,const float *,int,const float *,int *,void *,int) noexcept nogil> _hipsolverDnSsyevjBatched_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params,batch_count)


cdef void* _hipsolverDnDsyevjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsyevjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,const double * A,int lda,const double * W,int * lwork,void * params,int batch_count):
    global _hipsolverDnDsyevjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDsyevjBatched_bufferSize__funptr,"hipsolverDnDsyevjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,const double *,int,const double *,int *,void *,int) noexcept nogil> _hipsolverDnDsyevjBatched_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params,batch_count)


cdef void* _hipsolverDnCheevjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCheevjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,const float * W,int * lwork,void * params,int batch_count):
    global _hipsolverDnCheevjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCheevjBatched_bufferSize__funptr,"hipsolverDnCheevjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,const float *,int *,void *,int) noexcept nogil> _hipsolverDnCheevjBatched_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params,batch_count)


cdef void* _hipsolverDnZheevjBatched_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZheevjBatched_bufferSize(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,const double * W,int * lwork,void * params,int batch_count):
    global _hipsolverDnZheevjBatched_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZheevjBatched_bufferSize__funptr,"hipsolverDnZheevjBatched_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,const double *,int *,void *,int) noexcept nogil> _hipsolverDnZheevjBatched_bufferSize__funptr)(handle,jobz,uplo,n,A,lda,W,lwork,params,batch_count)


cdef void* _hipsolverDnSsyevjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsyevjBatched(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * W,float * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverDnSsyevjBatched__funptr
    if __init_symbol(&_hipsolverDnSsyevjBatched__funptr,"hipsolverDnSsyevjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,float *,int,int *,void *,int) noexcept nogil> _hipsolverDnSsyevjBatched__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverDnDsyevjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsyevjBatched(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * W,double * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverDnDsyevjBatched__funptr
    if __init_symbol(&_hipsolverDnDsyevjBatched__funptr,"hipsolverDnDsyevjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,double *,int,int *,void *,int) noexcept nogil> _hipsolverDnDsyevjBatched__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverDnCheevjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCheevjBatched(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float * W,float2 * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverDnCheevjBatched__funptr
    if __init_symbol(&_hipsolverDnCheevjBatched__funptr,"hipsolverDnCheevjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float *,float2 *,int,int *,void *,int) noexcept nogil> _hipsolverDnCheevjBatched__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverDnZheevjBatched__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZheevjBatched(void * handle,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double * W,double2 * work,int lwork,int * devInfo,void * params,int batch_count):
    global _hipsolverDnZheevjBatched__funptr
    if __init_symbol(&_hipsolverDnZheevjBatched__funptr,"hipsolverDnZheevjBatched") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double *,double2 *,int,int *,void *,int) noexcept nogil> _hipsolverDnZheevjBatched__funptr)(handle,jobz,uplo,n,A,lda,W,work,lwork,devInfo,params,batch_count)


cdef void* _hipsolverDnSsygvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsygvd_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,const float * A,int lda,const float * B,int ldb,const float * W,int * lwork):
    global _hipsolverDnSsygvd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSsygvd_bufferSize__funptr,"hipsolverDnSsygvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,const float *,int,const float *,int,const float *,int *) noexcept nogil> _hipsolverDnSsygvd_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork)


cdef void* _hipsolverDnDsygvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsygvd_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,const double * A,int lda,const double * B,int ldb,const double * W,int * lwork):
    global _hipsolverDnDsygvd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDsygvd_bufferSize__funptr,"hipsolverDnDsygvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,const double *,int,const double *,int,const double *,int *) noexcept nogil> _hipsolverDnDsygvd_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork)


cdef void* _hipsolverDnChegvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnChegvd_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * B,int ldb,const float * W,int * lwork):
    global _hipsolverDnChegvd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnChegvd_bufferSize__funptr,"hipsolverDnChegvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float2 *,int,const float *,int *) noexcept nogil> _hipsolverDnChegvd_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork)


cdef void* _hipsolverDnZhegvd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZhegvd_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * B,int ldb,const double * W,int * lwork):
    global _hipsolverDnZhegvd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZhegvd_bufferSize__funptr,"hipsolverDnZhegvd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double2 *,int,const double *,int *) noexcept nogil> _hipsolverDnZhegvd_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork)


cdef void* _hipsolverDnSsygvd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsygvd(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * B,int ldb,float * W,float * work,int lwork,int * devInfo):
    global _hipsolverDnSsygvd__funptr
    if __init_symbol(&_hipsolverDnSsygvd__funptr,"hipsolverDnSsygvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,int,float *,float *,int,int *) noexcept nogil> _hipsolverDnSsygvd__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo)


cdef void* _hipsolverDnDsygvd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsygvd(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * B,int ldb,double * W,double * work,int lwork,int * devInfo):
    global _hipsolverDnDsygvd__funptr
    if __init_symbol(&_hipsolverDnDsygvd__funptr,"hipsolverDnDsygvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,int,double *,double *,int,int *) noexcept nogil> _hipsolverDnDsygvd__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo)


cdef void* _hipsolverDnChegvd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnChegvd(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * B,int ldb,float * W,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnChegvd__funptr
    if __init_symbol(&_hipsolverDnChegvd__funptr,"hipsolverDnChegvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float2 *,int,float *,float2 *,int,int *) noexcept nogil> _hipsolverDnChegvd__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo)


cdef void* _hipsolverDnZhegvd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZhegvd(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * B,int ldb,double * W,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZhegvd__funptr
    if __init_symbol(&_hipsolverDnZhegvd__funptr,"hipsolverDnZhegvd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double2 *,int,double *,double2 *,int,int *) noexcept nogil> _hipsolverDnZhegvd__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo)


cdef void* _hipsolverDnSsygvdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsygvdx_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,const float * A,int lda,const float * B,int ldb,float vl,float vu,int il,int iu,int * nev,const float * W,int * lwork):
    global _hipsolverDnSsygvdx_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSsygvdx_bufferSize__funptr,"hipsolverDnSsygvdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,const float *,int,const float *,int,float,float,int,int,int *,const float *,int *) noexcept nogil> _hipsolverDnSsygvdx_bufferSize__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverDnDsygvdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsygvdx_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,const double * A,int lda,const double * B,int ldb,double vl,double vu,int il,int iu,int * nev,const double * W,int * lwork):
    global _hipsolverDnDsygvdx_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDsygvdx_bufferSize__funptr,"hipsolverDnDsygvdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,const double *,int,const double *,int,double,double,int,int,int *,const double *,int *) noexcept nogil> _hipsolverDnDsygvdx_bufferSize__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverDnChegvdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnChegvdx_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * B,int ldb,float vl,float vu,int il,int iu,int * nev,const float * W,int * lwork):
    global _hipsolverDnChegvdx_bufferSize__funptr
    if __init_symbol(&_hipsolverDnChegvdx_bufferSize__funptr,"hipsolverDnChegvdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,float2 *,int,float2 *,int,float,float,int,int,int *,const float *,int *) noexcept nogil> _hipsolverDnChegvdx_bufferSize__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverDnZhegvdx_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZhegvdx_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * B,int ldb,double vl,double vu,int il,int iu,int * nev,const double * W,int * lwork):
    global _hipsolverDnZhegvdx_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZhegvdx_bufferSize__funptr,"hipsolverDnZhegvdx_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,double2 *,int,double2 *,int,double,double,int,int,int *,const double *,int *) noexcept nogil> _hipsolverDnZhegvdx_bufferSize__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,lwork)


cdef void* _hipsolverDnSsygvdx__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsygvdx(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,float * A,int lda,float * B,int ldb,float vl,float vu,int il,int iu,int * nev,float * W,float * work,int lwork,int * devInfo):
    global _hipsolverDnSsygvdx__funptr
    if __init_symbol(&_hipsolverDnSsygvdx__funptr,"hipsolverDnSsygvdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,float *,int,float *,int,float,float,int,int,int *,float *,float *,int,int *) noexcept nogil> _hipsolverDnSsygvdx__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverDnDsygvdx__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsygvdx(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,double * A,int lda,double * B,int ldb,double vl,double vu,int il,int iu,int * nev,double * W,double * work,int lwork,int * devInfo):
    global _hipsolverDnDsygvdx__funptr
    if __init_symbol(&_hipsolverDnDsygvdx__funptr,"hipsolverDnDsygvdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,double *,int,double *,int,double,double,int,int,int *,double *,double *,int,int *) noexcept nogil> _hipsolverDnDsygvdx__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverDnChegvdx__funptr = NULL
cdef hipsolverStatus_t hipsolverDnChegvdx(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * B,int ldb,float vl,float vu,int il,int iu,int * nev,float * W,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnChegvdx__funptr
    if __init_symbol(&_hipsolverDnChegvdx__funptr,"hipsolverDnChegvdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,float2 *,int,float2 *,int,float,float,int,int,int *,float *,float2 *,int,int *) noexcept nogil> _hipsolverDnChegvdx__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverDnZhegvdx__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZhegvdx(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipsolverEigRange_t range,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * B,int ldb,double vl,double vu,int il,int iu,int * nev,double * W,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZhegvdx__funptr
    if __init_symbol(&_hipsolverDnZhegvdx__funptr,"hipsolverDnZhegvdx") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipsolverEigRange_t,hipblasFillMode_t,int,double2 *,int,double2 *,int,double,double,int,int,int *,double *,double2 *,int,int *) noexcept nogil> _hipsolverDnZhegvdx__funptr)(handle,itype,jobz,range,uplo,n,A,lda,B,ldb,vl,vu,il,iu,nev,W,work,lwork,devInfo)


cdef void* _hipsolverDnSsygvj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsygvj_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,const float * A,int lda,const float * B,int ldb,const float * W,int * lwork,void * params):
    global _hipsolverDnSsygvj_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSsygvj_bufferSize__funptr,"hipsolverDnSsygvj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,const float *,int,const float *,int,const float *,int *,void *) noexcept nogil> _hipsolverDnSsygvj_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork,params)


cdef void* _hipsolverDnDsygvj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsygvj_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,const double * A,int lda,const double * B,int ldb,const double * W,int * lwork,void * params):
    global _hipsolverDnDsygvj_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDsygvj_bufferSize__funptr,"hipsolverDnDsygvj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,const double *,int,const double *,int,const double *,int *,void *) noexcept nogil> _hipsolverDnDsygvj_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork,params)


cdef void* _hipsolverDnChegvj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnChegvj_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * B,int ldb,const float * W,int * lwork,void * params):
    global _hipsolverDnChegvj_bufferSize__funptr
    if __init_symbol(&_hipsolverDnChegvj_bufferSize__funptr,"hipsolverDnChegvj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float2 *,int,const float *,int *,void *) noexcept nogil> _hipsolverDnChegvj_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork,params)


cdef void* _hipsolverDnZhegvj_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZhegvj_bufferSize(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * B,int ldb,const double * W,int * lwork,void * params):
    global _hipsolverDnZhegvj_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZhegvj_bufferSize__funptr,"hipsolverDnZhegvj_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double2 *,int,const double *,int *,void *) noexcept nogil> _hipsolverDnZhegvj_bufferSize__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,lwork,params)


cdef void* _hipsolverDnSsygvj__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsygvj(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float * A,int lda,float * B,int ldb,float * W,float * work,int lwork,int * devInfo,void * params):
    global _hipsolverDnSsygvj__funptr
    if __init_symbol(&_hipsolverDnSsygvj__funptr,"hipsolverDnSsygvj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float *,int,float *,int,float *,float *,int,int *,void *) noexcept nogil> _hipsolverDnSsygvj__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo,params)


cdef void* _hipsolverDnDsygvj__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsygvj(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double * A,int lda,double * B,int ldb,double * W,double * work,int lwork,int * devInfo,void * params):
    global _hipsolverDnDsygvj__funptr
    if __init_symbol(&_hipsolverDnDsygvj__funptr,"hipsolverDnDsygvj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double *,int,double *,int,double *,double *,int,int *,void *) noexcept nogil> _hipsolverDnDsygvj__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo,params)


cdef void* _hipsolverDnChegvj__funptr = NULL
cdef hipsolverStatus_t hipsolverDnChegvj(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,float2 * A,int lda,float2 * B,int ldb,float * W,float2 * work,int lwork,int * devInfo,void * params):
    global _hipsolverDnChegvj__funptr
    if __init_symbol(&_hipsolverDnChegvj__funptr,"hipsolverDnChegvj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,float2 *,int,float2 *,int,float *,float2 *,int,int *,void *) noexcept nogil> _hipsolverDnChegvj__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo,params)


cdef void* _hipsolverDnZhegvj__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZhegvj(void * handle,hipsolverEigType_t itype,hipsolverEigMode_t jobz,hipblasFillMode_t uplo,int n,double2 * A,int lda,double2 * B,int ldb,double * W,double2 * work,int lwork,int * devInfo,void * params):
    global _hipsolverDnZhegvj__funptr
    if __init_symbol(&_hipsolverDnZhegvj__funptr,"hipsolverDnZhegvj") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverEigType_t,hipsolverEigMode_t,hipblasFillMode_t,int,double2 *,int,double2 *,int,double *,double2 *,int,int *,void *) noexcept nogil> _hipsolverDnZhegvj__funptr)(handle,itype,jobz,uplo,n,A,lda,B,ldb,W,work,lwork,devInfo,params)


cdef void* _hipsolverDnSsytrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsytrd_bufferSize(void * handle,hipblasFillMode_t uplo,int n,const float * A,int lda,const float * D,const float * E,const float * tau,int * lwork):
    global _hipsolverDnSsytrd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSsytrd_bufferSize__funptr,"hipsolverDnSsytrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,const float *,int,const float *,const float *,const float *,int *) noexcept nogil> _hipsolverDnSsytrd_bufferSize__funptr)(handle,uplo,n,A,lda,D,E,tau,lwork)


cdef void* _hipsolverDnDsytrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsytrd_bufferSize(void * handle,hipblasFillMode_t uplo,int n,const double * A,int lda,const double * D,const double * E,const double * tau,int * lwork):
    global _hipsolverDnDsytrd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDsytrd_bufferSize__funptr,"hipsolverDnDsytrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,const double *,int,const double *,const double *,const double *,int *) noexcept nogil> _hipsolverDnDsytrd_bufferSize__funptr)(handle,uplo,n,A,lda,D,E,tau,lwork)


cdef void* _hipsolverDnChetrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnChetrd_bufferSize(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,const float * D,const float * E,float2 * tau,int * lwork):
    global _hipsolverDnChetrd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnChetrd_bufferSize__funptr,"hipsolverDnChetrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,const float *,const float *,float2 *,int *) noexcept nogil> _hipsolverDnChetrd_bufferSize__funptr)(handle,uplo,n,A,lda,D,E,tau,lwork)


cdef void* _hipsolverDnZhetrd_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZhetrd_bufferSize(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,const double * D,const double * E,double2 * tau,int * lwork):
    global _hipsolverDnZhetrd_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZhetrd_bufferSize__funptr,"hipsolverDnZhetrd_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,const double *,const double *,double2 *,int *) noexcept nogil> _hipsolverDnZhetrd_bufferSize__funptr)(handle,uplo,n,A,lda,D,E,tau,lwork)


cdef void* _hipsolverDnSsytrd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsytrd(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,float * D,float * E,float * tau,float * work,int lwork,int * devInfo):
    global _hipsolverDnSsytrd__funptr
    if __init_symbol(&_hipsolverDnSsytrd__funptr,"hipsolverDnSsytrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,float *,float *,float *,float *,int,int *) noexcept nogil> _hipsolverDnSsytrd__funptr)(handle,uplo,n,A,lda,D,E,tau,work,lwork,devInfo)


cdef void* _hipsolverDnDsytrd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsytrd(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,double * D,double * E,double * tau,double * work,int lwork,int * devInfo):
    global _hipsolverDnDsytrd__funptr
    if __init_symbol(&_hipsolverDnDsytrd__funptr,"hipsolverDnDsytrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,double *,double *,double *,double *,int,int *) noexcept nogil> _hipsolverDnDsytrd__funptr)(handle,uplo,n,A,lda,D,E,tau,work,lwork,devInfo)


cdef void* _hipsolverDnChetrd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnChetrd(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,float * D,float * E,float2 * tau,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnChetrd__funptr
    if __init_symbol(&_hipsolverDnChetrd__funptr,"hipsolverDnChetrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,float *,float *,float2 *,float2 *,int,int *) noexcept nogil> _hipsolverDnChetrd__funptr)(handle,uplo,n,A,lda,D,E,tau,work,lwork,devInfo)


cdef void* _hipsolverDnZhetrd__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZhetrd(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,double * D,double * E,double2 * tau,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZhetrd__funptr
    if __init_symbol(&_hipsolverDnZhetrd__funptr,"hipsolverDnZhetrd") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,double *,double *,double2 *,double2 *,int,int *) noexcept nogil> _hipsolverDnZhetrd__funptr)(handle,uplo,n,A,lda,D,E,tau,work,lwork,devInfo)


cdef void* _hipsolverDnSsytrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsytrf_bufferSize(void * handle,int n,float * A,int lda,int * lwork):
    global _hipsolverDnSsytrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnSsytrf_bufferSize__funptr,"hipsolverDnSsytrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,float *,int,int *) noexcept nogil> _hipsolverDnSsytrf_bufferSize__funptr)(handle,n,A,lda,lwork)


cdef void* _hipsolverDnDsytrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsytrf_bufferSize(void * handle,int n,double * A,int lda,int * lwork):
    global _hipsolverDnDsytrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnDsytrf_bufferSize__funptr,"hipsolverDnDsytrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,double *,int,int *) noexcept nogil> _hipsolverDnDsytrf_bufferSize__funptr)(handle,n,A,lda,lwork)


cdef void* _hipsolverDnCsytrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCsytrf_bufferSize(void * handle,int n,float2 * A,int lda,int * lwork):
    global _hipsolverDnCsytrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnCsytrf_bufferSize__funptr,"hipsolverDnCsytrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,float2 *,int,int *) noexcept nogil> _hipsolverDnCsytrf_bufferSize__funptr)(handle,n,A,lda,lwork)


cdef void* _hipsolverDnZsytrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZsytrf_bufferSize(void * handle,int n,double2 * A,int lda,int * lwork):
    global _hipsolverDnZsytrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnZsytrf_bufferSize__funptr,"hipsolverDnZsytrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,double2 *,int,int *) noexcept nogil> _hipsolverDnZsytrf_bufferSize__funptr)(handle,n,A,lda,lwork)


cdef void* _hipsolverDnSsytrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSsytrf(void * handle,hipblasFillMode_t uplo,int n,float * A,int lda,int * ipiv,float * work,int lwork,int * devInfo):
    global _hipsolverDnSsytrf__funptr
    if __init_symbol(&_hipsolverDnSsytrf__funptr,"hipsolverDnSsytrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float *,int,int *,float *,int,int *) noexcept nogil> _hipsolverDnSsytrf__funptr)(handle,uplo,n,A,lda,ipiv,work,lwork,devInfo)


cdef void* _hipsolverDnDsytrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDsytrf(void * handle,hipblasFillMode_t uplo,int n,double * A,int lda,int * ipiv,double * work,int lwork,int * devInfo):
    global _hipsolverDnDsytrf__funptr
    if __init_symbol(&_hipsolverDnDsytrf__funptr,"hipsolverDnDsytrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double *,int,int *,double *,int,int *) noexcept nogil> _hipsolverDnDsytrf__funptr)(handle,uplo,n,A,lda,ipiv,work,lwork,devInfo)


cdef void* _hipsolverDnCsytrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCsytrf(void * handle,hipblasFillMode_t uplo,int n,float2 * A,int lda,int * ipiv,float2 * work,int lwork,int * devInfo):
    global _hipsolverDnCsytrf__funptr
    if __init_symbol(&_hipsolverDnCsytrf__funptr,"hipsolverDnCsytrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,float2 *,int,int *,float2 *,int,int *) noexcept nogil> _hipsolverDnCsytrf__funptr)(handle,uplo,n,A,lda,ipiv,work,lwork,devInfo)


cdef void* _hipsolverDnZsytrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnZsytrf(void * handle,hipblasFillMode_t uplo,int n,double2 * A,int lda,int * ipiv,double2 * work,int lwork,int * devInfo):
    global _hipsolverDnZsytrf__funptr
    if __init_symbol(&_hipsolverDnZsytrf__funptr,"hipsolverDnZsytrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipblasFillMode_t,int,double2 *,int,int *,double2 *,int,int *) noexcept nogil> _hipsolverDnZsytrf__funptr)(handle,uplo,n,A,lda,ipiv,work,lwork,devInfo)


cdef void* _hipsolverDnCreateParams__funptr = NULL
cdef hipsolverStatus_t hipsolverDnCreateParams(void ** params):
    global _hipsolverDnCreateParams__funptr
    if __init_symbol(&_hipsolverDnCreateParams__funptr,"hipsolverDnCreateParams") > 0:
        pass
    return (<hipsolverStatus_t (*)(void **) noexcept nogil> _hipsolverDnCreateParams__funptr)(params)


cdef void* _hipsolverDnDestroyParams__funptr = NULL
cdef hipsolverStatus_t hipsolverDnDestroyParams(void * params):
    global _hipsolverDnDestroyParams__funptr
    if __init_symbol(&_hipsolverDnDestroyParams__funptr,"hipsolverDnDestroyParams") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverDnDestroyParams__funptr)(params)


cdef void* _hipsolverDnSetAdvOptions__funptr = NULL
cdef hipsolverStatus_t hipsolverDnSetAdvOptions(void * params,hipsolverDnFunction_t func,hipsolverAlgMode_t alg):
    global _hipsolverDnSetAdvOptions__funptr
    if __init_symbol(&_hipsolverDnSetAdvOptions__funptr,"hipsolverDnSetAdvOptions") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverDnFunction_t,hipsolverAlgMode_t) noexcept nogil> _hipsolverDnSetAdvOptions__funptr)(params,func,alg)


cdef void* _hipsolverDnXgeqrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXgeqrf_bufferSize(void * handle,void * params,long m,long n,hipDataType dataTypeA,const void * A,long lda,hipDataType dataTypeTau,const void * tau,hipDataType computeType,unsigned long * lworkOnDevice,unsigned long * lworkOnHost):
    global _hipsolverDnXgeqrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnXgeqrf_bufferSize__funptr,"hipsolverDnXgeqrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,long,long,hipDataType,const void *,long,hipDataType,const void *,hipDataType,unsigned long *,unsigned long *) noexcept nogil> _hipsolverDnXgeqrf_bufferSize__funptr)(handle,params,m,n,dataTypeA,A,lda,dataTypeTau,tau,computeType,lworkOnDevice,lworkOnHost)


cdef void* _hipsolverDnXgeqrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXgeqrf(void * handle,void * params,long m,long n,hipDataType dataTypeA,void * A,long lda,hipDataType dataTypeTau,void * tau,hipDataType computeType,void * workOnDevice,unsigned long lworkOnDevice,void * workOnHost,unsigned long lworkOnHost,int * devInfo):
    global _hipsolverDnXgeqrf__funptr
    if __init_symbol(&_hipsolverDnXgeqrf__funptr,"hipsolverDnXgeqrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,long,long,hipDataType,void *,long,hipDataType,void *,hipDataType,void *,unsigned long,void *,unsigned long,int *) noexcept nogil> _hipsolverDnXgeqrf__funptr)(handle,params,m,n,dataTypeA,A,lda,dataTypeTau,tau,computeType,workOnDevice,lworkOnDevice,workOnHost,lworkOnHost,devInfo)


cdef void* _hipsolverDnXgetrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXgetrf_bufferSize(void * handle,void * params,long m,long n,hipDataType dataTypeA,const void * A,long lda,hipDataType computeType,unsigned long * lworkOnDevice,unsigned long * lworkOnHost):
    global _hipsolverDnXgetrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnXgetrf_bufferSize__funptr,"hipsolverDnXgetrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,long,long,hipDataType,const void *,long,hipDataType,unsigned long *,unsigned long *) noexcept nogil> _hipsolverDnXgetrf_bufferSize__funptr)(handle,params,m,n,dataTypeA,A,lda,computeType,lworkOnDevice,lworkOnHost)


cdef void* _hipsolverDnXgetrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXgetrf(void * handle,void * params,long m,long n,hipDataType dataTypeA,void * A,long lda,long * devIpiv,hipDataType computeType,void * workOnDevice,unsigned long lworkOnDevice,void * workOnHost,unsigned long lworkOnHost,int * devInfo):
    global _hipsolverDnXgetrf__funptr
    if __init_symbol(&_hipsolverDnXgetrf__funptr,"hipsolverDnXgetrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,long,long,hipDataType,void *,long,long *,hipDataType,void *,unsigned long,void *,unsigned long,int *) noexcept nogil> _hipsolverDnXgetrf__funptr)(handle,params,m,n,dataTypeA,A,lda,devIpiv,computeType,workOnDevice,lworkOnDevice,workOnHost,lworkOnHost,devInfo)


cdef void* _hipsolverDnXgetrs__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXgetrs(void * handle,void * params,hipblasOperation_t trans,long n,long nrhs,hipDataType dataTypeA,const void * A,long lda,const long * devIpiv,hipDataType dataTypeB,void * B,long ldb,int * devInfo):
    global _hipsolverDnXgetrs__funptr
    if __init_symbol(&_hipsolverDnXgetrs__funptr,"hipsolverDnXgetrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,hipblasOperation_t,long,long,hipDataType,const void *,long,const long *,hipDataType,void *,long,int *) noexcept nogil> _hipsolverDnXgetrs__funptr)(handle,params,trans,n,nrhs,dataTypeA,A,lda,devIpiv,dataTypeB,B,ldb,devInfo)


cdef void* _hipsolverDnXpotrf_bufferSize__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXpotrf_bufferSize(void * handle,void * params,hipblasFillMode_t uplo,long n,hipDataType dataTypeA,const void * A,long lda,hipDataType computeType,unsigned long * lworkOnDevice,unsigned long * lworkOnHost):
    global _hipsolverDnXpotrf_bufferSize__funptr
    if __init_symbol(&_hipsolverDnXpotrf_bufferSize__funptr,"hipsolverDnXpotrf_bufferSize") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,hipblasFillMode_t,long,hipDataType,const void *,long,hipDataType,unsigned long *,unsigned long *) noexcept nogil> _hipsolverDnXpotrf_bufferSize__funptr)(handle,params,uplo,n,dataTypeA,A,lda,computeType,lworkOnDevice,lworkOnHost)


cdef void* _hipsolverDnXpotrf__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXpotrf(void * handle,void * params,hipblasFillMode_t uplo,long n,hipDataType dataTypeA,void * A,long lda,hipDataType computeType,void * workOnDevice,unsigned long lworkOnDevice,void * workOnHost,unsigned long lworkOnHost,int * info):
    global _hipsolverDnXpotrf__funptr
    if __init_symbol(&_hipsolverDnXpotrf__funptr,"hipsolverDnXpotrf") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,hipblasFillMode_t,long,hipDataType,void *,long,hipDataType,void *,unsigned long,void *,unsigned long,int *) noexcept nogil> _hipsolverDnXpotrf__funptr)(handle,params,uplo,n,dataTypeA,A,lda,computeType,workOnDevice,lworkOnDevice,workOnHost,lworkOnHost,info)


cdef void* _hipsolverDnXpotrs__funptr = NULL
cdef hipsolverStatus_t hipsolverDnXpotrs(void * handle,void * params,hipblasFillMode_t uplo,long n,long nrhs,hipDataType dataTypeA,const void * A,long lda,hipDataType dataTypeB,void * B,long ldb,int * info):
    global _hipsolverDnXpotrs__funptr
    if __init_symbol(&_hipsolverDnXpotrs__funptr,"hipsolverDnXpotrs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,void *,hipblasFillMode_t,long,long,hipDataType,const void *,long,hipDataType,void *,long,int *) noexcept nogil> _hipsolverDnXpotrs__funptr)(handle,params,uplo,n,nrhs,dataTypeA,A,lda,dataTypeB,B,ldb,info)


cdef void* _hipsolverRfCreate__funptr = NULL
cdef hipsolverStatus_t hipsolverRfCreate(void ** handle):
    global _hipsolverRfCreate__funptr
    if __init_symbol(&_hipsolverRfCreate__funptr,"hipsolverRfCreate") > 0:
        pass
    return (<hipsolverStatus_t (*)(void **) noexcept nogil> _hipsolverRfCreate__funptr)(handle)


cdef void* _hipsolverRfDestroy__funptr = NULL
cdef hipsolverStatus_t hipsolverRfDestroy(void * handle):
    global _hipsolverRfDestroy__funptr
    if __init_symbol(&_hipsolverRfDestroy__funptr,"hipsolverRfDestroy") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverRfDestroy__funptr)(handle)


cdef void* _hipsolverRfSetupDevice__funptr = NULL
cdef hipsolverStatus_t hipsolverRfSetupDevice(int n,int nnzA,int * csrRowPtrA,int * csrColIndA,double * csrValA,int nnzL,int * csrRowPtrL,int * csrColIndL,double * csrValL,int nnzU,int * csrRowPtrU,int * csrColIndU,double * csrValU,int * P,int * Q,void * handle):
    global _hipsolverRfSetupDevice__funptr
    if __init_symbol(&_hipsolverRfSetupDevice__funptr,"hipsolverRfSetupDevice") > 0:
        pass
    return (<hipsolverStatus_t (*)(int,int,int *,int *,double *,int,int *,int *,double *,int,int *,int *,double *,int *,int *,void *) noexcept nogil> _hipsolverRfSetupDevice__funptr)(n,nnzA,csrRowPtrA,csrColIndA,csrValA,nnzL,csrRowPtrL,csrColIndL,csrValL,nnzU,csrRowPtrU,csrColIndU,csrValU,P,Q,handle)


cdef void* _hipsolverRfSetupHost__funptr = NULL
cdef hipsolverStatus_t hipsolverRfSetupHost(int n,int nnzA,int * h_csrRowPtrA,int * h_csrColIndA,double * h_csrValA,int nnzL,int * h_csrRowPtrL,int * h_csrColIndL,double * h_csrValL,int nnzU,int * h_csrRowPtrU,int * h_csrColIndU,double * h_csrValU,int * h_P,int * h_Q,void * handle):
    global _hipsolverRfSetupHost__funptr
    if __init_symbol(&_hipsolverRfSetupHost__funptr,"hipsolverRfSetupHost") > 0:
        pass
    return (<hipsolverStatus_t (*)(int,int,int *,int *,double *,int,int *,int *,double *,int,int *,int *,double *,int *,int *,void *) noexcept nogil> _hipsolverRfSetupHost__funptr)(n,nnzA,h_csrRowPtrA,h_csrColIndA,h_csrValA,nnzL,h_csrRowPtrL,h_csrColIndL,h_csrValL,nnzU,h_csrRowPtrU,h_csrColIndU,h_csrValU,h_P,h_Q,handle)


cdef void* _hipsolverRfAccessBundledFactorsDevice__funptr = NULL
cdef hipsolverStatus_t hipsolverRfAccessBundledFactorsDevice(void * handle,int * nnzM,int ** Mp,int ** Mi,double ** Mx):
    global _hipsolverRfAccessBundledFactorsDevice__funptr
    if __init_symbol(&_hipsolverRfAccessBundledFactorsDevice__funptr,"hipsolverRfAccessBundledFactorsDevice") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int *,int **,int **,double **) noexcept nogil> _hipsolverRfAccessBundledFactorsDevice__funptr)(handle,nnzM,Mp,Mi,Mx)


cdef void* _hipsolverRfAnalyze__funptr = NULL
cdef hipsolverStatus_t hipsolverRfAnalyze(void * handle):
    global _hipsolverRfAnalyze__funptr
    if __init_symbol(&_hipsolverRfAnalyze__funptr,"hipsolverRfAnalyze") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverRfAnalyze__funptr)(handle)


cdef void* _hipsolverRfExtractBundledFactorsHost__funptr = NULL
cdef hipsolverStatus_t hipsolverRfExtractBundledFactorsHost(void * handle,int * h_nnzM,int ** h_Mp,int ** h_Mi,double ** h_Mx):
    global _hipsolverRfExtractBundledFactorsHost__funptr
    if __init_symbol(&_hipsolverRfExtractBundledFactorsHost__funptr,"hipsolverRfExtractBundledFactorsHost") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int *,int **,int **,double **) noexcept nogil> _hipsolverRfExtractBundledFactorsHost__funptr)(handle,h_nnzM,h_Mp,h_Mi,h_Mx)


cdef void* _hipsolverRfExtractSplitFactorsHost__funptr = NULL
cdef hipsolverStatus_t hipsolverRfExtractSplitFactorsHost(void * handle,int * h_nnzL,int ** h_Lp,int ** h_Li,double ** h_Lx,int * h_nnzU,int ** h_Up,int ** h_Ui,double ** h_Ux):
    global _hipsolverRfExtractSplitFactorsHost__funptr
    if __init_symbol(&_hipsolverRfExtractSplitFactorsHost__funptr,"hipsolverRfExtractSplitFactorsHost") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int *,int **,int **,double **,int *,int **,int **,double **) noexcept nogil> _hipsolverRfExtractSplitFactorsHost__funptr)(handle,h_nnzL,h_Lp,h_Li,h_Lx,h_nnzU,h_Up,h_Ui,h_Ux)


cdef void* _hipsolverRfGet_Algs__funptr = NULL
cdef hipsolverStatus_t hipsolverRfGet_Algs(void * handle,hipsolverRfFactorization_t * fact_alg,hipsolverRfTriangularSolve_t * solve_alg):
    global _hipsolverRfGet_Algs__funptr
    if __init_symbol(&_hipsolverRfGet_Algs__funptr,"hipsolverRfGet_Algs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverRfFactorization_t *,hipsolverRfTriangularSolve_t *) noexcept nogil> _hipsolverRfGet_Algs__funptr)(handle,fact_alg,solve_alg)


cdef void* _hipsolverRfGetMatrixFormat__funptr = NULL
cdef hipsolverStatus_t hipsolverRfGetMatrixFormat(void * handle,hipsolverRfMatrixFormat_t * format,hipsolverRfUnitDiagonal_t * diag):
    global _hipsolverRfGetMatrixFormat__funptr
    if __init_symbol(&_hipsolverRfGetMatrixFormat__funptr,"hipsolverRfGetMatrixFormat") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverRfMatrixFormat_t *,hipsolverRfUnitDiagonal_t *) noexcept nogil> _hipsolverRfGetMatrixFormat__funptr)(handle,format,diag)


cdef void* _hipsolverRfGetNumericBoostReport__funptr = NULL
cdef hipsolverStatus_t hipsolverRfGetNumericBoostReport(void * handle,hipsolverRfNumericBoostReport_t * report):
    global _hipsolverRfGetNumericBoostReport__funptr
    if __init_symbol(&_hipsolverRfGetNumericBoostReport__funptr,"hipsolverRfGetNumericBoostReport") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverRfNumericBoostReport_t *) noexcept nogil> _hipsolverRfGetNumericBoostReport__funptr)(handle,report)


cdef void* _hipsolverRfGetNumericProperties__funptr = NULL
cdef hipsolverStatus_t hipsolverRfGetNumericProperties(void * handle,double * zero,double * boost):
    global _hipsolverRfGetNumericProperties__funptr
    if __init_symbol(&_hipsolverRfGetNumericProperties__funptr,"hipsolverRfGetNumericProperties") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,double *,double *) noexcept nogil> _hipsolverRfGetNumericProperties__funptr)(handle,zero,boost)


cdef void* _hipsolverRfGetResetValuesFastMode__funptr = NULL
cdef hipsolverStatus_t hipsolverRfGetResetValuesFastMode(void * handle,hipsolverRfResetValuesFastMode_t * fastMode):
    global _hipsolverRfGetResetValuesFastMode__funptr
    if __init_symbol(&_hipsolverRfGetResetValuesFastMode__funptr,"hipsolverRfGetResetValuesFastMode") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverRfResetValuesFastMode_t *) noexcept nogil> _hipsolverRfGetResetValuesFastMode__funptr)(handle,fastMode)


cdef void* _hipsolverRfRefactor__funptr = NULL
cdef hipsolverStatus_t hipsolverRfRefactor(void * handle):
    global _hipsolverRfRefactor__funptr
    if __init_symbol(&_hipsolverRfRefactor__funptr,"hipsolverRfRefactor") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverRfRefactor__funptr)(handle)


cdef void* _hipsolverRfResetValues__funptr = NULL
cdef hipsolverStatus_t hipsolverRfResetValues(int n,int nnzA,int * csrRowPtrA,int * csrColIndA,double * csrValA,int * P,int * Q,void * handle):
    global _hipsolverRfResetValues__funptr
    if __init_symbol(&_hipsolverRfResetValues__funptr,"hipsolverRfResetValues") > 0:
        pass
    return (<hipsolverStatus_t (*)(int,int,int *,int *,double *,int *,int *,void *) noexcept nogil> _hipsolverRfResetValues__funptr)(n,nnzA,csrRowPtrA,csrColIndA,csrValA,P,Q,handle)


cdef void* _hipsolverRfSetAlgs__funptr = NULL
cdef hipsolverStatus_t hipsolverRfSetAlgs(void * handle,hipsolverRfFactorization_t fact_alg,hipsolverRfTriangularSolve_t solve_alg):
    global _hipsolverRfSetAlgs__funptr
    if __init_symbol(&_hipsolverRfSetAlgs__funptr,"hipsolverRfSetAlgs") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverRfFactorization_t,hipsolverRfTriangularSolve_t) noexcept nogil> _hipsolverRfSetAlgs__funptr)(handle,fact_alg,solve_alg)


cdef void* _hipsolverRfSetMatrixFormat__funptr = NULL
cdef hipsolverStatus_t hipsolverRfSetMatrixFormat(void * handle,hipsolverRfMatrixFormat_t format,hipsolverRfUnitDiagonal_t diag):
    global _hipsolverRfSetMatrixFormat__funptr
    if __init_symbol(&_hipsolverRfSetMatrixFormat__funptr,"hipsolverRfSetMatrixFormat") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverRfMatrixFormat_t,hipsolverRfUnitDiagonal_t) noexcept nogil> _hipsolverRfSetMatrixFormat__funptr)(handle,format,diag)


cdef void* _hipsolverRfSetNumericProperties__funptr = NULL
cdef hipsolverStatus_t hipsolverRfSetNumericProperties(void * handle,double effective_zero,double boost_val):
    global _hipsolverRfSetNumericProperties__funptr
    if __init_symbol(&_hipsolverRfSetNumericProperties__funptr,"hipsolverRfSetNumericProperties") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,double,double) noexcept nogil> _hipsolverRfSetNumericProperties__funptr)(handle,effective_zero,boost_val)


cdef void* _hipsolverRfSetResetValuesFastMode__funptr = NULL
cdef hipsolverStatus_t hipsolverRfSetResetValuesFastMode(void * handle,hipsolverRfResetValuesFastMode_t fastMode):
    global _hipsolverRfSetResetValuesFastMode__funptr
    if __init_symbol(&_hipsolverRfSetResetValuesFastMode__funptr,"hipsolverRfSetResetValuesFastMode") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipsolverRfResetValuesFastMode_t) noexcept nogil> _hipsolverRfSetResetValuesFastMode__funptr)(handle,fastMode)


cdef void* _hipsolverRfSolve__funptr = NULL
cdef hipsolverStatus_t hipsolverRfSolve(void * handle,int * P,int * Q,int nrhs,double * Temp,int ldt,double * XF,int ldxf):
    global _hipsolverRfSolve__funptr
    if __init_symbol(&_hipsolverRfSolve__funptr,"hipsolverRfSolve") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int *,int *,int,double *,int,double *,int) noexcept nogil> _hipsolverRfSolve__funptr)(handle,P,Q,nrhs,Temp,ldt,XF,ldxf)


cdef void* _hipsolverRfBatchSetupHost__funptr = NULL
cdef hipsolverStatus_t hipsolverRfBatchSetupHost(int batchSize,int n,int nnzA,int * h_csrRowPtrA,int * h_csrColIndA,double ** h_csrValA_array,int nnzL,int * h_csrRowPtrL,int * h_csrColIndL,double * h_csrValL,int nnzU,int * h_csrRowPtrU,int * h_csrColIndU,double * h_csrValU,int * h_P,int * h_Q,void * handle):
    global _hipsolverRfBatchSetupHost__funptr
    if __init_symbol(&_hipsolverRfBatchSetupHost__funptr,"hipsolverRfBatchSetupHost") > 0:
        pass
    return (<hipsolverStatus_t (*)(int,int,int,int *,int *,double **,int,int *,int *,double *,int,int *,int *,double *,int *,int *,void *) noexcept nogil> _hipsolverRfBatchSetupHost__funptr)(batchSize,n,nnzA,h_csrRowPtrA,h_csrColIndA,h_csrValA_array,nnzL,h_csrRowPtrL,h_csrColIndL,h_csrValL,nnzU,h_csrRowPtrU,h_csrColIndU,h_csrValU,h_P,h_Q,handle)


cdef void* _hipsolverRfBatchAnalyze__funptr = NULL
cdef hipsolverStatus_t hipsolverRfBatchAnalyze(void * handle):
    global _hipsolverRfBatchAnalyze__funptr
    if __init_symbol(&_hipsolverRfBatchAnalyze__funptr,"hipsolverRfBatchAnalyze") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverRfBatchAnalyze__funptr)(handle)


cdef void* _hipsolverRfBatchRefactor__funptr = NULL
cdef hipsolverStatus_t hipsolverRfBatchRefactor(void * handle):
    global _hipsolverRfBatchRefactor__funptr
    if __init_symbol(&_hipsolverRfBatchRefactor__funptr,"hipsolverRfBatchRefactor") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverRfBatchRefactor__funptr)(handle)


cdef void* _hipsolverRfBatchResetValues__funptr = NULL
cdef hipsolverStatus_t hipsolverRfBatchResetValues(int batchSize,int n,int nnzA,int * csrRowPtrA,int * csrColIndA,double ** csrValA_array,int * P,int * Q,void * handle):
    global _hipsolverRfBatchResetValues__funptr
    if __init_symbol(&_hipsolverRfBatchResetValues__funptr,"hipsolverRfBatchResetValues") > 0:
        pass
    return (<hipsolverStatus_t (*)(int,int,int,int *,int *,double **,int *,int *,void *) noexcept nogil> _hipsolverRfBatchResetValues__funptr)(batchSize,n,nnzA,csrRowPtrA,csrColIndA,csrValA_array,P,Q,handle)


cdef void* _hipsolverRfBatchSolve__funptr = NULL
cdef hipsolverStatus_t hipsolverRfBatchSolve(void * handle,int * P,int * Q,int nrhs,double * Temp,int ldt,double ** XF_array,int ldxf):
    global _hipsolverRfBatchSolve__funptr
    if __init_symbol(&_hipsolverRfBatchSolve__funptr,"hipsolverRfBatchSolve") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int *,int *,int,double *,int,double **,int) noexcept nogil> _hipsolverRfBatchSolve__funptr)(handle,P,Q,nrhs,Temp,ldt,XF_array,ldxf)


cdef void* _hipsolverRfBatchZeroPivot__funptr = NULL
cdef hipsolverStatus_t hipsolverRfBatchZeroPivot(void * handle,int * position):
    global _hipsolverRfBatchZeroPivot__funptr
    if __init_symbol(&_hipsolverRfBatchZeroPivot__funptr,"hipsolverRfBatchZeroPivot") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int *) noexcept nogil> _hipsolverRfBatchZeroPivot__funptr)(handle,position)


cdef void* _hipsolverSpCreate__funptr = NULL
cdef hipsolverStatus_t hipsolverSpCreate(void ** handle):
    global _hipsolverSpCreate__funptr
    if __init_symbol(&_hipsolverSpCreate__funptr,"hipsolverSpCreate") > 0:
        pass
    return (<hipsolverStatus_t (*)(void **) noexcept nogil> _hipsolverSpCreate__funptr)(handle)


cdef void* _hipsolverSpDestroy__funptr = NULL
cdef hipsolverStatus_t hipsolverSpDestroy(void * handle):
    global _hipsolverSpDestroy__funptr
    if __init_symbol(&_hipsolverSpDestroy__funptr,"hipsolverSpDestroy") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *) noexcept nogil> _hipsolverSpDestroy__funptr)(handle)


cdef void* _hipsolverSpSetStream__funptr = NULL
cdef hipsolverStatus_t hipsolverSpSetStream(void * handle,hipStream_t streamId):
    global _hipsolverSpSetStream__funptr
    if __init_symbol(&_hipsolverSpSetStream__funptr,"hipsolverSpSetStream") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,hipStream_t) noexcept nogil> _hipsolverSpSetStream__funptr)(handle,streamId)


cdef void* _hipsolverSpScsrlsvchol__funptr = NULL
cdef hipsolverStatus_t hipsolverSpScsrlsvchol(void * handle,int n,int nnzA,void *const descrA,const float * csrVal,const int * csrRowPtr,const int * csrColInd,const float * b,float tolerance,int reorder,float * x,int * singularity):
    global _hipsolverSpScsrlsvchol__funptr
    if __init_symbol(&_hipsolverSpScsrlsvchol__funptr,"hipsolverSpScsrlsvchol") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,void *const,const float *,const int *,const int *,const float *,float,int,float *,int *) noexcept nogil> _hipsolverSpScsrlsvchol__funptr)(handle,n,nnzA,descrA,csrVal,csrRowPtr,csrColInd,b,tolerance,reorder,x,singularity)


cdef void* _hipsolverSpDcsrlsvchol__funptr = NULL
cdef hipsolverStatus_t hipsolverSpDcsrlsvchol(void * handle,int n,int nnzA,void *const descrA,const double * csrVal,const int * csrRowPtr,const int * csrColInd,const double * b,double tolerance,int reorder,double * x,int * singularity):
    global _hipsolverSpDcsrlsvchol__funptr
    if __init_symbol(&_hipsolverSpDcsrlsvchol__funptr,"hipsolverSpDcsrlsvchol") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,void *const,const double *,const int *,const int *,const double *,double,int,double *,int *) noexcept nogil> _hipsolverSpDcsrlsvchol__funptr)(handle,n,nnzA,descrA,csrVal,csrRowPtr,csrColInd,b,tolerance,reorder,x,singularity)


cdef void* _hipsolverSpScsrlsvcholHost__funptr = NULL
cdef hipsolverStatus_t hipsolverSpScsrlsvcholHost(void * handle,int n,int nnzA,void *const descrA,const float * csrVal,const int * csrRowPtr,const int * csrColInd,const float * b,float tolerance,int reorder,float * x,int * singularity):
    global _hipsolverSpScsrlsvcholHost__funptr
    if __init_symbol(&_hipsolverSpScsrlsvcholHost__funptr,"hipsolverSpScsrlsvcholHost") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,void *const,const float *,const int *,const int *,const float *,float,int,float *,int *) noexcept nogil> _hipsolverSpScsrlsvcholHost__funptr)(handle,n,nnzA,descrA,csrVal,csrRowPtr,csrColInd,b,tolerance,reorder,x,singularity)


cdef void* _hipsolverSpDcsrlsvcholHost__funptr = NULL
cdef hipsolverStatus_t hipsolverSpDcsrlsvcholHost(void * handle,int n,int nnzA,void *const descrA,const double * csrVal,const int * csrRowPtr,const int * csrColInd,const double * b,double tolerance,int reorder,double * x,int * singularity):
    global _hipsolverSpDcsrlsvcholHost__funptr
    if __init_symbol(&_hipsolverSpDcsrlsvcholHost__funptr,"hipsolverSpDcsrlsvcholHost") > 0:
        pass
    return (<hipsolverStatus_t (*)(void *,int,int,void *const,const double *,const int *,const int *,const double *,double,int,double *,int *) noexcept nogil> _hipsolverSpDcsrlsvcholHost__funptr)(handle,n,nnzA,descrA,csrVal,csrRowPtr,csrColInd,b,tolerance,reorder,x,singularity)
